#!/usr/bin/python2
# -*- coding: utf-8 -*-

'''
This file is part of PyX3 - Huawei X3 Toolkit

    Copyright (C) 2013-2016 ElTonno @ Android-Hilfe.de

    PyX3 is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the
    Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PyX3 is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program. If not, see <http://www.gnu.org/licenses/>.
'''

__title__       = 'PyX3 - Huawei X3 Toolkit'
__version__     = 'rev 20160328'
__author__      = 'ElTonno @ Android-Hilfe.de'
__copyright__   = '2013-2016'

import os
import posixpath
import sys
import re
import imp
import platform
import operator
import ConfigParser
import base64
import codecs
import zipfile
import webbrowser, urllib
from time import sleep, gmtime, strftime
from shutil import copy, move, rmtree

reload(sys)
sys.setdefaultencoding('UTF8')

try:
    from PyQt4.QtCore import *
    from PyQt4.QtGui import *
except ImportError:
    print 'Error: PyQt4 package not found\nError: required packages: PyQt4 (>4.5)\nError: program aborted.'
    sys.exit(-1)
    
##try:
##    from PyQt4.Qsci import QsciScintilla, QsciScintillaBase, QsciLexerPython
##except ImportError:
##    print 'Error: QScintilla package not found\nError: required packages: QScintilla\nError: program aborted.'
##    pass
##    #sys.exit(-1)

# OS Determination -----------------------------------------------------------------------------------------------------------
distr = ''
if sys.platform == 'linux2':
    OS = 'lin'
    for dist in platform._supported_dists:
        if platform.linux_distribution()[0] == dist:
            distr = dist.lower()
elif sys.platform.startswith('win'):
    OS = 'win'
elif sys.platform == 'darwin':
    OS = 'mac'
else:
    OS = 'default'

ospath = os.path
if OS == 'win':
    SysDir = ospath.join('c:\\','Windows')
    ospath = os.path
elif OS == 'lin':
    SysDir = ospath.join('usr','bin')
    ospath = posixpath
else:
    SysDir = ''
    
if (sys.maxsize > 2**32):
    bit = 64
else:
    bit = 32

# CORRECT PATH ---------------------------------------------------------------------------------------------------------------
##if OS == 'win':
##    f = sys.argv[0]
##else:
##    f = __file__

f = sys.argv[0]

os.chdir(unicode(ospath.dirname(ospath.realpath(f))))

# VARIABLES ------------------------------------------------------------------------------------------------------------------
ScriptDir = unicode(ospath.dirname(ospath.realpath(f)))   #/home/<USER>/Desktop/PyX3
ConfDir = ScriptDir                                         #/home/<USER>/Desktop/PyX3
ResDir = ospath.join(ScriptDir, 'res')                     #/home/<USER>/Desktop/PyX3/res
ImageDir = ospath.join(ScriptDir, 'images')                #/home/<USER>/Desktop/PyX3/images
TempDir = ospath.join(ScriptDir, 'tmp')                    #/home/<USER>/Desktop/PyX3/tmp
CacheDir = ospath.join(TempDir, 'cache')                   #/home/<USER>/Desktop/PyX3/tmp/cache
BackupDir = ospath.join(ScriptDir, 'backup')               #/home/<USER>/Desktop/PyX3/backup
ScreenshotDir = ospath.join(ScriptDir, 'screenshot')       #/home/<USER>/Desktop/PyX3/screenshot
DownloadDir = ospath.join(ScriptDir, 'downloads')          #/home/<USER>/Desktop/PyX3/downloads
RootDir = ospath.join(ResDir, 'root')                      #/home/<USER>/Desktop/PyX3/res/root
BootsplashDir = ospath.join(ResDir, 'bootsplash')          #/home/<USER>/Desktop/PyX3/res/bootsplash
Home = unicode(ospath.expanduser('~'))                     #/home/<USER>
MyFile = unicode(ospath.basename(f))                       #PyX3.py
FullFile = unicode(ospath.abspath(ospath.realpath(f)))    #/home/<USER>/Desktop/PyX3/PyX3.py
Python = unicode(ospath.abspath(sys.executable))           #/usr/bin/python
PythonDir = ospath.dirname(Python)                         #/usr/bin
IconSize = 23
helperApp = 'null'

# IMPORT SCRIPTS -------------------------------------------------------------------------------------------------------------
try:
    #DBridge = imp.load_source('DebugBridge_log', ospath.join(ResDir, 'DebugBridge_log.py'))
    from res import DebugBridge_log as DBridge
except ImportError:
    print 'Error: DebugBridge-Script not found\nError: programm aborted'
    sys.exit(-1)

# SETTINGS -------------------------------------------------------------------------------------------------------------------
if not ospath.isfile(ospath.join(ConfDir,'settings.cfg')):
    cfgfile = open(ospath.join(ConfDir,'settings.cfg'),'w')
    Config = ConfigParser.ConfigParser()
    Config.add_section('android')
    Config.set('android', 'androidsdk', ospath.join(Home,'adt', 'sdk'))
    Config.add_section('megatools')
    Config.set('megatools', 'megatools', '/usr/local/bin')
    Config.write(cfgfile)
    cfgfile.close()
    copy(ospath.join(ConfDir,'settings.cfg'), ospath.join(ResDir,'AndroidExplorer','settings.cfg'))

def EditConfigMap(section, option, value):
    Config = ConfigParser.ConfigParser()
    Config.read(ospath.join(ConfDir,'settings.cfg'))
    Config.set(section, option, value)
    with open(ospath.join(ConfDir,'settings.cfg'), 'wb') as configfile:
        Config.write(configfile)
    with open(ospath.join(ResDir,'AndroidExplorer','settings.cfg'), 'wb') as configfile:
        Config.write(configfile)

def ReadConfigMap(section):
    dict1 = {}
    Config = ConfigParser.ConfigParser()
    Config.read(ospath.join(ConfDir,'settings.cfg'))
    options = Config.options(section)
    for option in options:
        try:
            dict1[option] = Config.get(section, option)
            if dict1[option] == -1:
                print 'skip: {}'.format(option)
                DBridge.logging('skip: {}'.format(option))
        except:
            print 'exception on {}!'.format(option)
            DBridge.logging('exception on {}!'.format(option))
            dict1[option] = None
    return dict1

# SET BINARIES ---------------------------------------------------------------------------------------------------------------
ext = ''
if OS == 'win': ext = '.exe'

adb = ospath.join(ReadConfigMap('android')['androidsdk'], 'platform-tools', 'adb'+ext)
if ospath.isfile(adb):
    pass
elif ospath.isfile(ospath.join(ResDir,'adb'+ext)):
    adb = ospath.join(ResDir,'adb'+ext)
elif ospath.isfile(ospath.join(SysDir,'adb'+ext)):
    adb = ospath.join(SysDir,'adb'+ext)
else:
    DBridge.logging.debug('\'adb\' not found')
    pass

fastboot = ospath.join(ReadConfigMap('android')['androidsdk'], 'platform-tools', 'fastboot'+ext)
if ospath.isfile(fastboot):
    pass
elif ospath.isfile(ospath.join(ResDir,'fastboot'+ext)):
    fastboot = ospath.join(ResDir,'fastboot'+ext)
elif ospath.isfile(ospath.join(SysDir,'fastboot'+ext)):
    fastboot = ospath.join(SysDir,'fastboot'+ext)
else:
    DBridge.logging.debug('\'fastboot\' not found')
    pass

aapt = ospath.join(ReadConfigMap('android')['androidsdk'], 'platform-tools', 'aapt'+ext)
if ospath.isfile(aapt):
    pass
elif ospath.isfile(ospath.join(ResDir,'aapt'+ext)):
    aapt = ospath.join(ResDir,'aapt'+ext)
elif ospath.isfile(ospath.join(SysDir,'aapt'+ext)):
    aapt = ospath.join(SysDir,'aapt'+ext)
else:
    DBridge.logging.debug('\'aapt\' not found')
    pass

mega = ospath.join(ReadConfigMap('megatools')['megatools'], 'megadl'+ext)
if ospath.isfile(mega):
    pass
elif ospath.isfile(ospath.join(ResDir,'megadl'+ext)):
    mega = ospath.join(ResDir,'megadl'+ext)
elif ospath.isfile(ospath.join(SysDir,'megadl'+ext)):
    mega = ospath.join(SysDir,'megadl'+ext)
else:
    DBridge.logging.debug('\'megadl\' not found')
    pass

print '{:*^60}'.format('INFO')
print 'ARCH:        {}'.format(sys.platform)
print 'OS:          {}-bit'.format(bit)
print 'DIST:        {}'.format(distr)
print 'DIR:         {}'.format(ScriptDir)
print 'FILE:        {}'.format(MyFile)
print 'VERSION:     {}'.format(__version__)
print 'AUTHOR:      {}, {}'.format(__author__, __copyright__)
print
print '{:*^60}'.format('CONFIG')
print 'ADB:         {}'.format(adb)
print 'FASTBOOT:    {}'.format(fastboot)
print 'AAPT:        {}'.format(aapt)
print 'MEGADL:      {}'.format(mega)
print

# USEFUL GLOBAL-FUNCTIONS ----------------------------------------------------------------------------------------------------
def ANDROID_DATA():
    return DBridge.Adb(adb)._ANDROID_DATA()

def ANDROID_ROOT():
    return DBridge.Adb(adb)._ANDROID_ROOT()

def EXTERNAL_STORAGE():
    return DBridge.Adb(adb)._EXTERNAL_STORAGE()

def SD_EXT_DIRECTORY():
    return DBridge.Adb(adb)._SD_EXT_DIRECTORY()

# MyDeviceInfo ---------------------------------------------------------------------------------------------------------------
class MyDeviceInfo(QWidget):
    def __init__(self, parent=None):
        super(MyDeviceInfo, self).__init__(parent)
        self.initUI()
    def initUI(self):
        self.setWindowTitle('Device-Info')
        font = QFont()
        font.setPointSize(13)
        self.resize(626, 431)
        sizePolicy = QSizePolicy(QSizePolicy.Fixed, QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        self.setSizePolicy(sizePolicy)

        # GROUPBOX-1
        self.gBox1 = QGroupBox('Device')
        sizePolicy.setHeightForWidth(self.gBox1.sizePolicy().hasHeightForWidth())
        self.gBox1.setSizePolicy(sizePolicy)
        # GROUPBOX-2
        self.gBox2 = QGroupBox('Storage')
        sizePolicy.setHeightForWidth(self.gBox2.sizePolicy().hasHeightForWidth())
        self.gBox2.setSizePolicy(sizePolicy)

        # LAYOUTS
        self.fLayout1 = QFormLayout()
        self.fLayout2 = QFormLayout()
        self.fLayout3 = QFormLayout()
        self.fLayout4 = QFormLayout()
        self.fLayout5 = QFormLayout()
        self.fLayout6 = QFormLayout()

        self.hLayout1 = QHBoxLayout()
        self.hLayout1.setSpacing(6)
        self.hLayout2 = QHBoxLayout()
        self.hLayout2.setSpacing(6)
        self.hLayout3 = QHBoxLayout()
        self.hLayout3.setSpacing(6)
        self.hLayout4 = QHBoxLayout()
        self.hLayout4.setSpacing(6)

        self.gLayout1 = QGridLayout()
        self.gLayout1.setSpacing(15)
        self.gLayout2 = QGridLayout(self.gBox2)
        self.gLayout3 = QGridLayout(self.gBox1)
        self.gLayout4 = QGridLayout()
        self.gLayout4.setSizeConstraint(QLayout.SetFixedSize)

        # DATA
        self.lbl14 = QLabel('Data', self.gBox2); self.lbl14.setFont(font)
        self.lbl15 = QLabel('Total:', self.gBox2); self.lbl15.setMinimumSize(QSize(40, 0))
        self.lbl16 = QLabel('Free:', self.gBox2); self.lbl16.setMinimumSize(QSize(40, 0))
        self.lbl17 = QLabel('Used:', self.gBox2); self.lbl17.setMinimumSize(QSize(40, 0))
        self.pgBarDATA = QProgressBar(self.gBox2)
        self.pgBarDATA.setValue(0)
        self.pgBarDATA.setOrientation(Qt.Vertical)
        self.totalDATA = QLabel('0 MB', self.gBox2)
        self.totalDATA.setMinimumSize(QSize(40, 0))
        self.totalDATA.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.usedDATA = QLabel('0 MB', self.gBox2)
        self.usedDATA.setMinimumSize(QSize(40, 0))
        self.usedDATA.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.freeDATA = QLabel('0 MB', self.gBox2)
        self.freeDATA.setMinimumSize(QSize(40, 0))
        self.freeDATA.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        # SYSTEM
        self.lbl18 = QLabel('System', self.gBox2); self.lbl18.setFont(font)
        self.lbl19 = QLabel('Total:', self.gBox2); self.lbl19.setMinimumSize(QSize(40, 0))
        self.lbl20 = QLabel('Free:', self.gBox2); self.lbl20.setMinimumSize(QSize(40, 0))
        self.lbl21 = QLabel('Used:', self.gBox2); self.lbl21.setMinimumSize(QSize(40, 0))
        self.pgBarSYSTEM = QProgressBar(self.gBox2)
        self.pgBarSYSTEM.setValue(0)
        self.pgBarSYSTEM.setOrientation(Qt.Vertical)
        self.totalSYSTEM = QLabel('0 MB', self.gBox2)
        self.totalSYSTEM.setMinimumSize(QSize(40, 0))
        self.totalSYSTEM.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.usedSYSTEM = QLabel('0 MB', self.gBox2)
        self.usedSYSTEM.setMinimumSize(QSize(40, 0))
        self.usedSYSTEM.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.freeSYSTEM = QLabel('0 MB', self.gBox2)
        self.freeSYSTEM.setMinimumSize(QSize(40, 0))
        self.freeSYSTEM.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        # SDCARD
        self.lbl22 = QLabel('SD-Card', self.gBox2); self.lbl22.setFont(font)
        self.lbl23 = QLabel('Total:', self.gBox2); self.lbl23.setMinimumSize(QSize(40, 0))
        self.lbl24 = QLabel('Free:', self.gBox2); self.lbl24.setMinimumSize(QSize(40, 0))
        self.lbl25 = QLabel('Used:', self.gBox2); self.lbl25.setMinimumSize(QSize(40, 0))
        self.pgBarSDCARD = QProgressBar(self.gBox2)
        self.pgBarSDCARD.setValue(0)
        self.pgBarSDCARD.setOrientation(Qt.Vertical)
        self.totalSDCARD = QLabel('0 MB', self.gBox2)
        self.totalSDCARD.setMinimumSize(QSize(40, 0))
        self.totalSDCARD.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.usedSDCARD = QLabel('0 MB', self.gBox2)
        self.usedSDCARD.setMinimumSize(QSize(40, 0))
        self.usedSDCARD.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.freeSDCARD = QLabel('0 MB', self.gBox2)
        self.freeSDCARD.setMinimumSize(QSize(40, 0))
        self.freeSDCARD.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        # SDEXT
        self.lbl26 = QLabel('SD-Ext', self.gBox2); self.lbl26.setFont(font)
        self.lbl27 = QLabel('Total:', self.gBox2); self.lbl27.setMinimumSize(QSize(40, 0))
        self.lbl28 = QLabel('Free:', self.gBox2); self.lbl28.setMinimumSize(QSize(40, 0))
        self.lbl29 = QLabel('Used:', self.gBox2); self.lbl29.setMinimumSize(QSize(40, 0))
        self.pgBarSDEXT = QProgressBar(self.gBox2)
        self.pgBarSDEXT.setValue(0)
        self.pgBarSDEXT.setOrientation(Qt.Vertical)
        self.totalSDEXT = QLabel('0 MB', self.gBox2)
        self.totalSDEXT.setMinimumSize(QSize(40, 0))
        self.totalSDEXT.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.usedSDEXT = QLabel('0 MB', self.gBox2)
        self.usedSDEXT.setMinimumSize(QSize(40, 0))
        self.usedSDEXT.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)
        self.freeSDEXT = QLabel('0 MB', self.gBox2)
        self.freeSDEXT.setMinimumSize(QSize(40, 0))
        self.freeSDEXT.setAlignment(Qt.AlignRight|Qt.AlignTrailing|Qt.AlignVCenter)

        # Serial
        self.lbl1  = QLabel('Serial No.', self.gBox1)
        self.editSerial = QLineEdit(self.gBox1)
        self.editSerial.setMinimumSize(QSize(160, 0))
        self.editSerial.setReadOnly(True)
        # Model
        self.lbl2  = QLabel('Model', self.gBox1)
        self.editModel = QLineEdit(self.gBox1)
        self.editModel.setMinimumSize(QSize(160, 0))
        self.editModel.setReadOnly(True)
        # Device
        self.lbl3  = QLabel('Device', self.gBox1)
        self.editDevice = QLineEdit(self.gBox1)
        self.editDevice.setMinimumSize(QSize(160, 0))
        self.editDevice.setReadOnly(True)
        # Brand
        self.lbl4  = QLabel('Brand', self.gBox1)
        self.editBrand = QLineEdit(self.gBox1)
        self.editBrand.setMinimumSize(QSize(160, 0))
        self.editBrand.setReadOnly(True)
        # Manufacturer
        self.lbl5  = QLabel('Manufacturer', self.gBox1)
        self.editManufacturer = QLineEdit(self.gBox1)
        self.editManufacturer.setMinimumSize(QSize(160, 0))
        self.editManufacturer.setReadOnly(True)
        # Baseband
        self.lbl6  = QLabel('Baseband', self.gBox1)
        self.editBaseband = QLineEdit(self.gBox1)
        self.editBaseband.setMinimumSize(QSize(160, 0))
        self.editBaseband.setReadOnly(True)
        # Bootloader
        self.lbl7  = QLabel('Bootloader', self.gBox1)
        self.editBootloader = QLineEdit(self.gBox1)
        self.editBootloader.setMinimumSize(QSize(160, 0))
        self.editBootloader.setReadOnly(True)
        # Mod-Version
        self.lbl8  = QLabel('Mod Version', self.gBox1)
        self.editModVer = QLineEdit(self.gBox1)
        self.editModVer.setMinimumSize(QSize(160, 0))
        self.editModVer.setReadOnly(True)
        # Release
        self.lbl9  = QLabel('Release', self.gBox1)
        self.editRelease = QLineEdit(self.gBox1)
        self.editRelease.setMinimumSize(QSize(160, 0))
        self.editRelease.setReadOnly(True)
        # Build-ID
        self.lbl10 = QLabel('Build ID', self.gBox1)
        self.editBuild = QLineEdit(self.gBox1)
        self.editBuild.setMinimumSize(QSize(160, 0))
        self.editBuild.setReadOnly(True)
        # Operator
        self.lbl11 = QLabel('Operator', self.gBox1)
        self.editOperator = QLineEdit(self.gBox1)
        self.editOperator.setMinimumSize(QSize(160, 0))
        self.editOperator.setReadOnly(True)
        # Root
        self.lbl12 = QLabel('Root access (ID)', self.gBox1)
        self.editRoot = QLineEdit(self.gBox1)
        self.editRoot.setMinimumSize(QSize(160, 0))
        self.editRoot.setReadOnly(True)
        # Busybox
        self.lbl13 = QLabel('Busybox', self.gBox1)
        self.editBusybox = QLineEdit(self.gBox1)
        self.editBusybox.setMinimumSize(QSize(160, 0))
        self.editBusybox.setReadOnly(True)

        # Refresh
        self.chkBox = QCheckBox('Refresh')
        self.chkBox.setGeometry(QRect(70, 100, 84, 20))

        # SET LAYOUTS
        self.fLayout1.setWidget(0,  QFormLayout.LabelRole, self.lbl1)
        self.fLayout1.setWidget(1,  QFormLayout.LabelRole, self.lbl2)
        self.fLayout1.setWidget(2,  QFormLayout.LabelRole, self.lbl3)
        self.fLayout1.setWidget(3,  QFormLayout.LabelRole, self.lbl4)
        self.fLayout1.setWidget(4,  QFormLayout.LabelRole, self.lbl5)
        self.fLayout1.setWidget(5,  QFormLayout.LabelRole, self.lbl6)
        self.fLayout1.setWidget(6,  QFormLayout.LabelRole, self.lbl7)
        self.fLayout1.setWidget(7,  QFormLayout.LabelRole, self.lbl8)
        self.fLayout1.setWidget(8,  QFormLayout.LabelRole, self.lbl9)
        self.fLayout1.setWidget(9,  QFormLayout.LabelRole, self.lbl10)
        self.fLayout1.setWidget(10, QFormLayout.LabelRole, self.lbl11)
        self.fLayout1.setWidget(11, QFormLayout.LabelRole, self.lbl12)
        self.fLayout1.setWidget(12, QFormLayout.LabelRole, self.lbl13)
        self.fLayout1.setWidget(0,  QFormLayout.FieldRole, self.editSerial)
        self.fLayout1.setWidget(1,  QFormLayout.FieldRole, self.editModel)
        self.fLayout1.setWidget(2,  QFormLayout.FieldRole, self.editDevice)
        self.fLayout1.setWidget(3,  QFormLayout.FieldRole, self.editBrand)
        self.fLayout1.setWidget(4,  QFormLayout.FieldRole, self.editManufacturer)
        self.fLayout1.setWidget(5,  QFormLayout.FieldRole, self.editBaseband)
        self.fLayout1.setWidget(6,  QFormLayout.FieldRole, self.editBootloader)
        self.fLayout1.setWidget(7,  QFormLayout.FieldRole, self.editModVer)
        self.fLayout1.setWidget(8,  QFormLayout.FieldRole, self.editRelease)
        self.fLayout1.setWidget(9,  QFormLayout.FieldRole, self.editBuild)
        self.fLayout1.setWidget(10, QFormLayout.FieldRole, self.editOperator)
        self.fLayout1.setWidget(11, QFormLayout.FieldRole, self.editRoot)
        self.fLayout1.setWidget(12, QFormLayout.FieldRole, self.editBusybox)

        self.fLayout2.setWidget(0, QFormLayout.LabelRole, self.gBox1)
        self.fLayout2.setWidget(0, QFormLayout.FieldRole, self.gBox2)

        self.fLayout3.setWidget(0, QFormLayout.LabelRole, self.lbl14)
        self.fLayout3.setWidget(1, QFormLayout.LabelRole, self.lbl15)
        self.fLayout3.setWidget(1, QFormLayout.FieldRole, self.totalDATA)
        self.fLayout3.setWidget(2, QFormLayout.LabelRole, self.lbl16)
        self.fLayout3.setWidget(2, QFormLayout.FieldRole, self.freeDATA)
        self.fLayout3.setWidget(3, QFormLayout.LabelRole, self.lbl17)
        self.fLayout3.setWidget(3, QFormLayout.FieldRole, self.usedDATA)

        self.fLayout4.setWidget(0, QFormLayout.LabelRole, self.lbl18)
        self.fLayout4.setWidget(1, QFormLayout.LabelRole, self.lbl19)
        self.fLayout4.setWidget(2, QFormLayout.LabelRole, self.lbl20)
        self.fLayout4.setWidget(3, QFormLayout.LabelRole, self.lbl21)
        self.fLayout4.setWidget(1, QFormLayout.FieldRole, self.totalSYSTEM)
        self.fLayout4.setWidget(3, QFormLayout.FieldRole, self.usedSYSTEM)
        self.fLayout4.setWidget(2, QFormLayout.FieldRole, self.freeSYSTEM)

        self.fLayout5.setWidget(0, QFormLayout.LabelRole, self.lbl22)
        self.fLayout5.setWidget(1, QFormLayout.LabelRole, self.lbl23)
        self.fLayout5.setWidget(2, QFormLayout.LabelRole, self.lbl24)
        self.fLayout5.setWidget(3, QFormLayout.LabelRole, self.lbl25)
        self.fLayout5.setWidget(1, QFormLayout.FieldRole, self.totalSDCARD)
        self.fLayout5.setWidget(3, QFormLayout.FieldRole, self.usedSDCARD)
        self.fLayout5.setWidget(2, QFormLayout.FieldRole, self.freeSDCARD)

        self.fLayout6.setWidget(0, QFormLayout.LabelRole, self.lbl26)
        self.fLayout6.setWidget(1, QFormLayout.LabelRole, self.lbl27)
        self.fLayout6.setWidget(2, QFormLayout.LabelRole, self.lbl28)
        self.fLayout6.setWidget(1, QFormLayout.FieldRole, self.totalSDEXT)
        self.fLayout6.setWidget(2, QFormLayout.FieldRole, self.freeSDEXT)
        self.fLayout6.setWidget(3, QFormLayout.LabelRole, self.lbl29)
        self.fLayout6.setWidget(3, QFormLayout.FieldRole, self.usedSDEXT)

        self.hLayout1.addWidget(self.pgBarDATA)
        self.hLayout1.addLayout(self.fLayout3)
        self.hLayout2.addWidget(self.pgBarSYSTEM)
        self.hLayout2.addLayout(self.fLayout4)
        self.hLayout3.addWidget(self.pgBarSDCARD)
        self.hLayout3.addLayout(self.fLayout5)
        self.hLayout4.addWidget(self.pgBarSDEXT)
        self.hLayout4.addLayout(self.fLayout6)

        self.gLayout1.addLayout(self.hLayout1, 0, 0)
        self.gLayout1.addLayout(self.hLayout2, 0, 3)
        self.gLayout1.addLayout(self.hLayout3, 1, 0)
        self.gLayout1.addLayout(self.hLayout4, 1, 3)
        self.gLayout1.addWidget(self.chkBox,   2, 0)
        self.gLayout2.addLayout(self.gLayout1, 0, 0)
        self.gLayout3.addLayout(self.fLayout1, 0, 0)
        self.gLayout4.addLayout(self.fLayout2, 0, 0)

        self.setLayout(self.gLayout4)

# MyProgressWidget -----------------------------------------------------------------------------------------------------------
class ProgressWidget(QWidget):
    def __init__(self, parent=None):
        super(ProgressWidget, self).__init__(parent)
        self.initUI()
    def initUI(self):
        self.killProcVar = False
        # geometry
        self.resize(408, 258)
        self.setWindowTitle('Info')
        # Font
        font = QFont()
        font.setFamily('Roboto')
        font.setPointSize(9)
        # TextEdit
        self.plainTextEdit = QPlainTextEdit()
        self.plainTextEdit.setFont(font)
        self.plainTextEdit.setReadOnly(True)
        self.plainTextEdit.setWordWrapMode(QTextOption.NoWrap)
        self.plainTextEdit.textChanged.connect(self.sizeChange)
        # ProgressBar
        self.pgBar = QProgressBar()
        self.pgBar.setMaximumSize(QSize(16777215, 15))
        self.pgBar.setFont(font)
        self.pgBar.setValue(0)
        self.pgBar.setMinimum(0)
        # Button
        self.BtnClose = QPushButton('&Close')
        self.BtnClose.setMaximumSize(QSize(115, 30))
        self.BtnClose.setFont(font)
        self.BtnClose.clicked.connect(self.close)
        # Layout
        self.vLayout = QVBoxLayout()
        self.vLayout.setSpacing(0)
        self.vLayout.setContentsMargins(2, 2, 2, 2)
        self.hLayout = QHBoxLayout()
        self.hLayout.setSpacing(0)
        self.vLayout.addWidget(self.plainTextEdit)
        self.vLayout.addWidget(self.pgBar)
        self.hLayout.addWidget(self.BtnClose)
        self.vLayout.addLayout(self.hLayout)
        self.setLayout(self.vLayout)

    def setKillProcVar(self):
        self.killProcVar = False
        DBridge.killProcess()

    def getKillProcVar(self):
        return self.killProcVar

    def sizeChange(self):
        widthMax = 10000
        docWidth = self.plainTextEdit.document().size().width()
        if docWidth < widthMax:
            self.plainTextEdit.setMinimumWidth(docWidth + 50)

    def closeEvent(self, e):
        if self.BtnClose.isEnabled():
            self.killProcVar = False
            e.accept()
        else:
            ret = QMessageBox.warning(self,'Cancel...','Cancel the process?','&Ok','&Cancel','',0,1)
            if ret == 0:
                self.killProcVar = True
                e.accept()
            else:
                self.killProcVar = False
                e.ignore()

# MyMessageBox ---------------------------------------------------------------------------------------------------------------
class MyMessageBox(QMessageBox):
    def __init__(self, parent=None):
        super(QMessageBox, self).__init__(parent)
        self.setSizeGripEnabled(True)
    def event(self, e):
        result = QMessageBox.event(self, e)
        self.setMinimumHeight(100)
        self.setMaximumHeight(16777215)
        self.setMinimumWidth(100)
        self.setMaximumWidth(16777215)
        self.setSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        textEdit = self.findChild(QTextEdit)
        if textEdit != None :
            textEdit.setMinimumHeight(300)
            textEdit.setMaximumHeight(16777215)
            textEdit.setMinimumWidth(600)
            textEdit.setMaximumWidth(16777215)
            textEdit.setSizePolicy(QSizePolicy.Expanding, QSizePolicy.Expanding)
        return result

# MyEditor -------------------------------------------------------------------------------------------------------------------
class MyEditor(QMainWindow):
    def __init__(self, fname):
        super(MyEditor, self).__init__()
        self.setWindowTitle(unicode(__title__))
        self.resize(750, 400)

        self.centralwidget = QWidget(self)
        self.setCentralWidget(self.centralwidget)
        self.vLayout = QVBoxLayout(self.centralwidget)
        self.vLayout.setContentsMargins(2, 2, 2, 2)
        self.vLayout.setSpacing(0)
        self.editor = QsciScintilla()
        self.vLayout.addWidget(self.editor)

        self.makeMenu()
        try:
            self.fname = fname
        except IndexError:
            self.fname = ''
        self.findString = ''
        self.running = True

        ## define the font to use
        self.font = QFont()
        self.font.setFamily('Consolas')
        self.font.setFixedPitch(True)
        self.font.setPointSize(10)

        self.lexer = QsciLexerPython()
        self.lexer.setDefaultFont(self.font)
        self.editor.setLexer(None)
        self.editor.setFont(self.font)
        self.editor.setMarginsFont(self.font)
        self.editor.setMarginLineNumbers(1, True)
        self.editor.setMarginWidth(1, QFontMetrics(self.font).width('00'))
        self.editor.setFolding(QsciScintilla.BoxedTreeFoldStyle)
        self.editor.setBraceMatching(QsciScintilla.SloppyBraceMatch)
        self.editor.setCaretLineVisible(True)
        self.editor.setCaretLineBackgroundColor(QColor('#ffe4e4'))
        self.editor.setMarginsBackgroundColor(QColor('#333333'))
        self.editor.setMarginsForegroundColor(QColor('#CCCCCC'))
        self.editor.setFoldMarginColors(QColor('#99CC66'),QColor('#333300'))
        self.editor.setAutoIndent(True)
        self.editor.textChanged.connect(self.editorTextChanged)
        ## show Editor
        self.editor.show()
        if self.fname:
            self.actionOpenDirect()
        else:
            self.actionOpen()

    def makeMenu(self):
        menuBar = self.menuBar()
        self.setStyleSheet("""
           QMenuBar {background-color: rgb(49,49,49); color: rgb(255,255,255); border: 1px solid #000;}
           QMenuBar::item {background-color: rgb(49,49,49); color: rgb(255,255,255);}
           QMenuBar::item::selected {background-color: rgb(30,30,30);}
           QMenu {background-color: rgb(49,49,49); color: rgb(255,255,255); border: 1px solid #000;}
           QMenu::item::selected {background-color: rgb(30,30,30);}
           """)
    # File
        menuFile = menuBar.addMenu('&File')
        menuFile.addAction('New',self.actionNew,'Ctrl+N')
        menuFile.addAction('Open',self.actionOpen,'Ctrl+O')
        menuFile.addSeparator()
        menuFile.addAction('Save',self.actionSave,'Ctrl+S')
        menuFile.addAction('Save as...',self.actionSave_as,'Ctrl+R')
        menuFile.addSeparator()
        menuFile.addAction('Exit',self.actionExit,'Ctrl+Q')
    # Edit
        menuEdit = menuBar.addMenu('&Edit')
        menuEdit.addAction('Cut',self.actionCut,'Ctrl+X')
        menuEdit.addAction('Copy',self.actionCopy,'Ctrl+C')
        menuEdit.addAction('Paste',self.actionPaste,'Ctrl+V')
        menuEdit.addAction('Select All',self.actionSelect_All,'Ctrl+A')
        menuEdit.addSeparator()
        menuEdit.addAction('Find...',self.actionFind,'Ctrl+F')
        menuEdit.addAction('Find again',self.actionFind_again,'Ctrl+G')
        menuEdit.addSeparator()
        menuEdit.addAction('Sort',self.actionSort,'Ctrl+E')
        menuEdit.addSeparator()
        menuEdit.addAction('Undo',self.actionUndo,'Ctrl+Z')
        menuEdit.addAction('Redo',self.actionRedo,'Ctrl+Shift+N')
    # View
        menuView = menuBar.addMenu('&View')
        self.syntaxhighlight = menuView.addAction('Syntax Highlighting',self.actionHighlight,'Ctrl+H')
        self.syntaxhighlight.setCheckable(True)
        self.syntaxhighlight.setChecked(False)
    # Help
        menuHelp = menuBar.addMenu('&Help')
        menuHelp.addAction('QScintilla Doc',self.actionQSciTE)

    def actionRunning(self):
        return self.running

    def MyDialog(self):
        text, ok = QInputDialog.getText(self, 'Find...', 'Find:')
        if ok:
            self.findString = str(text)

    def actionNew(self):
        self.editor.clear()
        self.setWindowTitle(unicode(__title__))
        self.fname = ''

    def actionOpenDirect(self):
        try:
            if not self.fname:
                return
            self.setWindowTitle(u'{0} - {1}'.format(self.fname,__title__))
            with codecs.open(self.fname, 'rb', 'utf-8') as f:
                self.editor.setText(f.read())
        except IOError:
            self.setWindowTitle(unicode(__title__))
            return

    def actionOpen(self):
        try:
            self.fname = QFileDialog.getOpenFileName(self, 'Open file')
            if not self.fname:
                return
            self.setWindowTitle(u'{0} - {1}'.format(self.fname,__title__))
            with codecs.open(self.fname, 'rb', 'utf-8') as f:
                self.editor.setText(f.read())
        except IOError:
            self.setWindowTitle(unicode(__title__))
            return

    def actionSave(self):
        try:
            with codecs.open(self.fname, 'w', 'utf-8') as f:
                f.write(self.editor.text())
            self.setWindowTitle(u'{0} - {1}'.format(self.fname,__title__))
        except IOError:
            return

    def actionSave_as(self):
        try:
            self.fname = QFileDialog.getSaveFileName(self, 'Save file')
            with codecs.open(self.fname, 'w', 'utf-8') as f:
                f.write(self.editor.text())
            self.setWindowTitle(u'{0} - {1}'.format(self.fname,__title__))
        except IOError:
            return

    def actionExit(self):
        self.running = False
        self.close()

    def actionCut(self):
        self.editor.cut()

    def actionCopy(self):
        self.editor.copy()

    def actionPaste(self):
        self.editor.paste()

    def actionSelect_All(self):
        self.editor.selectAll()

    def actionFind(self):
        ##findFirst(QString, re, cs, wo, wrap, forward = true, line = -1, index = -1, show = true, posix = false)
        ## re,                 If re is true then expr is interpreted as a regular expression rather than a simple string.
        ## cs,                 case sensitive
        ## wo,                 whole word matches only, otherwise any matching text
        ## wrap,               wrap around the end of the text
        ## forward = true,     search forward from the starting position, otherwise backwards
        ## line = -1,          the search begins from the current cursor position, otherwise the search begins at position index of line line.
        ## index = -1,
        ## show = true,        made text found visible
        ## posix = false       POSIX compatible interpreting
        self.MyDialog()
        if not self.findString:
            return
        self.editor.findFirst(self.findString,False,False,False,True,True,-1,-1,True,True)

    def actionFind_again(self):
        if not self.findString:
            return
        self.editor.findNext()

    def actionSort(self):
        text = self.editor.text()
        if text:
            lines = unicode(text).splitlines()
            lines.sort()
            self.editor.clear()
            for elem in lines:
                self.editor.append('{0}\n'.format(elem))
        else:
            return

    def actionUndo(self):
        self.editor.undo()

    def actionRedo(self):
        self.editor.redo()

    def actionHighlight(self):
        if self.syntaxhighlight.isChecked():
            self.lexer.setDefaultFont(self.font)
            self.editor.setLexer(self.lexer)
            self.editor.setFont(self.font)
            self.editor.setMarginsFont(self.font)
            self.editor.setMarginLineNumbers(1, True)
            self.editor.setFolding(QsciScintilla.BoxedTreeFoldStyle)
            self.editor.setBraceMatching(QsciScintilla.SloppyBraceMatch)
            self.editor.setCaretLineVisible(True)
            self.editor.setCaretLineBackgroundColor(QColor('#ffe4e4'))
            self.editor.setMarginsBackgroundColor(QColor('#333333'))
            self.editor.setMarginsForegroundColor(QColor('#CCCCCC'))
            self.editor.setFoldMarginColors(QColor('#99CC66'),QColor('#333300'))
            self.editor.setAutoIndent(True)
        else:
            self.editor.setLexer(None)
            self.editor.setFont(self.font)
            self.editor.setMarginsFont(self.font)
            self.editor.setMarginLineNumbers(1, True)
            self.editor.setBraceMatching(QsciScintilla.SloppyBraceMatch)
            self.editor.setCaretLineVisible(True)
            self.editor.setCaretLineBackgroundColor(QColor('#ffe4e4'))
            self.editor.setMarginsBackgroundColor(QColor('#333333'))
            self.editor.setMarginsForegroundColor(QColor('#CCCCCC'))
            self.editor.setAutoIndent(True)

    def actionQSciTE(self):
        webbrowser.open_new_tab(r'http://www.scintilla.org/SciTEDoc.html')

    def editorTextChanged(self):
        self.setWindowTitle(u'{0}* - {1}'.format(self.fname,__title__))
        lines = len(str(len(str(self.editor.text()).splitlines())+1))
        width = ('0'*(lines))+'0'
        self.editor.setMarginWidth(1, QFontMetrics(self.font).width(width))

# HostsWidget ----------------------------------------------------------------------------------------------------------------
class HostsWidget(QDialog):
    def __init__(self, parent=None):
        super(HostsWidget, self).__init__(parent)
        self.initUI()
    def initUI(self):
        self.setWindowTitle('Install hosts-file')
        # geometry
        self.resize(196, 122)
        sizePolicy = QSizePolicy(QSizePolicy.Fixed, QSizePolicy.Fixed)
        sizePolicy.setHorizontalStretch(0)
        sizePolicy.setVerticalStretch(0)
        sizePolicy.setHeightForWidth(self.sizePolicy().hasHeightForWidth())
        self.setSizePolicy(sizePolicy)
        self.setMaximumSize(QSize(196, 122))
        # Font
        font = QFont()
        font.setFamily('Roboto')
        font.setPointSize(10)
        font.setBold(True)
        # Label
        self.label = QLabel('Install to...')
        self.label.setFont(font)
        self.label.setAlignment(Qt.AlignCenter)
        # Button
        self.btnBox = QDialogButtonBox(QDialogButtonBox.Cancel|QDialogButtonBox.Ok)
        self.btnBox.accepted.connect(self.btnBoxAccepted)
        self.btnBox.rejected.connect(self.close)
        self.ret = ''
        self.radioBtn = QRadioButton('/system/etc/hosts')
        self.radioBtn2 = QRadioButton('/data/data/hosts')
        # Layout
        self.gLayout = QGridLayout()
        self.vLayout2 = QVBoxLayout()
        self.vLayout = QVBoxLayout()
        self.vLayout.addWidget(self.label)
        self.vLayout.addWidget(self.radioBtn)
        self.vLayout.addWidget(self.radioBtn2)
        self.vLayout2.addLayout(self.vLayout)
        self.vLayout2.addWidget(self.btnBox)
        self.gLayout.addLayout(self.vLayout2, 0, 0, 1, 1)
        self.setLayout(self.gLayout)

    def btnBoxAccepted(self):
        self.ret = '/system/etc/hosts'
        if self.radioBtn2.isChecked():
            self.ret = '/data/data/hosts'
        self.accept()

    def exec_(self):
        if QDialog.exec_(self) == QDialog.Accepted:
            return self.ret
        else:
            return ''

# MyHighlighter --------------------------------------------------------------------------------------------------------------
class highlightSyntax(QSyntaxHighlighter):
    def __init__(self, listKeywords_color, parent=None):
        super(highlightSyntax, self).__init__(parent)
        self.highlightingRules = []
        for key,color in listKeywords_color:
            brush = QBrush(color, Qt.SolidPattern)
            keyword = QTextCharFormat()
            keyword.setForeground(brush)
            #keyword.setFontWeight(QFont.Bold)
            self.highlightingRules.append(highlightRule(key, keyword))
    def highlightBlock(self, text):
        t = text.split(': ')
        length = len(t[0])
        for rule in self.highlightingRules:
            expression = QRegExp(rule.pattern)
            index      = expression.indexIn(text)
            while index >= 0:                
                self.setFormat(index, length, rule.format)
                index = text.indexOf(expression, index + length)
        self.setCurrentBlockState(0)
class highlightRule(object):
    def __init__(self, pattern, format):
        self.pattern = pattern
        self.format  = format

# MyTable --------------------------------------------------------------------------------------------------------------------
class MyTableModel(QAbstractTableModel):
    def __init__(self, rawdata, headerdata, parent=None,):
        super(MyTableModel, self).__init__(parent)
        self.rawdata = rawdata
        self.headerdata = headerdata
        self._setIcons = 0        
    def setIcons(self, n):
        self._setIcons = n
    def rowCount(self, parent = QModelIndex()):
        try:
            return len(self.rawdata)
        except:
            return 0
    def columnCount(self, parent = QModelIndex()):
        try:
            return len(self.rawdata[0])
        except:
            return 0
    def removeAllRows(self, parent = QModelIndex()):
        self.rawdata = []
    def data(self, index, role = Qt.DisplayRole):
        if index.isValid() and (role == Qt.DisplayRole):
            return self.rawdata[index.row()][index.column()]
        elif role == Qt.DecorationRole:
            if (index.column() == 0) and (self._setIcons == 1):
                path = ospath.join(CacheDir,'{0}.png'.format(self.rawdata[index.row()][0]))                
                if ospath.isfile(path) and ospath.getsize(path) != 0:
                    icon = QIcon(path)
                else:
                    icon = QIcon(ospath.join(ImageDir,'empty.png'))
                return QVariant(icon.pixmap(QSize(IconSize, IconSize), QIcon.Normal))
        else:
            return
    def headerData(self, section, orientation, role = Qt.DisplayRole):
        if (orientation == Qt.Horizontal) and (role == Qt.DisplayRole):
            return QVariant(self.headerdata[section])
        elif (orientation == Qt.Vertical) and (role == Qt.DisplayRole):
            return QVariant([i+1 for i in xrange(self.rowCount()+1)][section])
        return QVariant()
    def getRow(self, index):
        return self.rawdata[index]
    def sort(self, col, order):
        self.emit(SIGNAL('layoutAboutToBeChanged()'))
        self.rawdata = sorted(self.rawdata, key=operator.itemgetter(col))
        if order == Qt.AscendingOrder:
            self.rawdata.reverse()
        self.emit(SIGNAL('layoutChanged()'))

# MainWindow -----------------------------------------------------------------------------------------------------------------
class Window(QMainWindow):
    def __init__(self):
        super(Window, self).__init__()
        self.initUI()
    def initUI(self):
    # init variables
        self.ApkInstallPath = ''
        self.ApkPath = ''
        self.killProcVar = False
        self.deviceConnected = False

        print '{:*^60}'.format('ANDROID')
        DBridge.Adb(adb)._shell('echo "TEST"')
        DBridge.Adb(adb, fastboot)._root()
        print 'BusyBox:     {}'.format(DBridge.Custom(adb,fastboot)._GetBusyboxVersion())
        print 'Root:        {}'.format(DBridge.Custom(adb,fastboot)._GetRootVersion())
        print
        print '{:*^60}'.format('ENVIRONMENT VARIABLES')
        print 'ANDROID_DATA:        {}'.format(ANDROID_DATA())
        print 'ANDROID_ROOT:        {}'.format(ANDROID_ROOT())
        print 'EXTERNAL_STORAGE:    {}'.format(EXTERNAL_STORAGE())
        print 'SD_EXT_DIRECTORY:    {}'.format(SD_EXT_DIRECTORY())
        print
    # main layout
        self.hLayout = QHBoxLayout()
        self.hLayout.setDirection(QBoxLayout.RightToLeft)
        self.hLayout.setContentsMargins(0,0,0,0)
        self.vLayout = QVBoxLayout()
        self.vLayout.setContentsMargins(2,2,2,2)
        self.btnLayout = QVBoxLayout()
        self.btnLayout.setContentsMargins(2,2,2,2)
    # central widget
        self.centralWidget = QWidget(self)
        self.centralWidget.setLayout(self.hLayout)
        self.setCentralWidget(self.centralWidget)
    # statusbar
        self._lblStatus = QLabel()
        self._label = QLabel()
        self.statusBar().setFixedHeight(18)
        self.statusBar().addPermanentWidget(self._label)
        self.statusBar().addWidget(self._lblStatus)
    # table
        self._tableView = QTableView()
        self._tableView.setAlternatingRowColors(True)
        self._tableView.setSortingEnabled(True)
        self._tableView.setSelectionBehavior(QAbstractItemView.SelectRows)
        self._tableView.setVerticalScrollMode(QAbstractItemView.ScrollPerPixel)
        self._tableView.setHorizontalScrollMode(QAbstractItemView.ScrollPerPixel)
        self._tableView.setShowGrid(False)
        self._tableView.setWordWrap(False)
        self._tableView.horizontalHeader().setVisible(True)
        self._tableView.horizontalHeader().setHighlightSections(False)
        #self._tableView.horizontalHeader().setResizeMode(QHeaderView.ResizeToContents)
        #self._tableView.verticalHeader().hide()        
    # timer
        self.timer = QTimer()
        self.timer.timeout.connect(self.refreshStatusbar)
        self.timer.start(5000)
        self.timer2 = QTimer()
        self.timer2.timeout.connect(self.fill_INFO)
    # textedit
        self._textEdit = QTextEdit()
        self._textEdit.setWordWrapMode(QTextOption.NoWrap)
        self._textEdit.setReadOnly(True)
    # menu / actions
        self.makeMenu()
        #self.makeActions()
        self.MenuMode = None
    # QProcess
        self.qprocess = QProcess()
        self.qprocess.readyRead.connect(self.readFromProcess)
    # progress Dialog
        self.pgwidget = ProgressWidget()
    # adblock Dialog
        self.hostswidget = HostsWidget()
    # style
        #QApplication.setStyle(QStyleFactory.create('Cleanlooks')) #Plastique,...
    # geometry
        self.resize(750, 400)
        qr = self.frameGeometry()
        cp = QDesktopWidget().availableGeometry().center()
        qr.moveCenter(cp)
        self.move(qr.topLeft())
        self.setAttribute(Qt.WA_DeleteOnClose)
    # refresh statusbar
        self.refreshStatusbar()

# BEGIN: CREATE-MENU ---------------------------------------------------------------------
    def makeMenu(self):
        self.menu = self.menuBar()
        self.setStyleSheet("""
           QMenuBar {background-color: rgb(49,49,49); color: rgb(255,255,255); border: 1px solid #000;}
           QMenuBar::item {background-color: rgb(49,49,49); color: rgb(255,255,255);}
           QMenuBar::item::selected {background-color: rgb(30,30,30);}
           QMenu {background-color: rgb(49,49,49); color: rgb(255,255,255); border: 1px solid #000;}
           QMenu::item::selected {background-color: rgb(30,30,30);}
           """)
    ## File
        fileMenu = self.menu.addMenu('&File')
        fileMenu.addAction("Download \'Android-SDK\'",self.slotDownloadSDK)
        fileMenu.addAction("Download \'Megatools\'",self.slotDownloadMegatools)
        fileMenu.addSeparator()
        fileMenu.addAction('Set \'Megatools\'-Path',self.slotmegadlPath)
        fileMenu.addAction("Set \'Android-SDK\'-Path",self.slotandroidsdkPath)
        fileMenu.addSeparator()
        # adb restart
        fileMenu.addAction('Restart Adb-Server',self.slotRestartAdb)
        fileMenu.addSeparator()
        # terminal
        fileMenu.addAction('Root-Shell',self.slotAdbShell)
        fileMenu.addSeparator()
        # exit
        fileMenu.addAction('&Exit',self.close)
    ## Adb
        adbMenu = self.menu.addMenu('&Adb')
        # reboot
        adbMenu.addAction('Reboot',self.adbReboot)
        # reboot recovery
        adbMenu.addAction('Reboot in recovery',self.adbRecovery)
        # reboot bootloader
        adbMenu.addAction('Reboot in bootloader',self.adbBootloader)
        # shutdown
        adbMenu.addAction('Shutdown',self.adbShutdown)
        adbMenu.addSeparator()
        # hot reboot
        adbMenu.addAction('Hot reboot',self.hotreboot)
    ## Fastboot
        fastbootMenu = self.menu.addMenu('&Fastboot')
        # reboot
        fastbootMenu.addAction('Reboot',self.fastbootReboot)
        # reboot bootloader
        fastbootMenu.addAction('Reboot in bootloader',self.fastbootBootloader)
        # shutdown
        fastbootMenu.addAction('Shutdown',self.fastbootShutdown)
        fastbootMenu.addSeparator()
        # boot kernel
        fastbootMenu.addAction('Boot kernel',self.slotBootKernel)
        # boot recovery
        fastbootMenu.addAction('Boot recovery',self.slotBootRecovery)
        fastbootMenu.addSeparator()
        # flash kernel
        fastbootMenu.addAction('Flash kernel',self.slotFlashKernel)
        # flash recovery
        fastbootMenu.addAction('Flash recovery',self.slotFlashRecovery)
    ## Manager
        managerMenu = self.menu.addMenu('&Manager')
        # App-Manager new
        managerMenu.addAction('Backup-ADB',self.runBackupADB)
        # App-Manager classic
        self.AppManager = managerMenu.addAction('&App-Manager',self.slotAppManager)
        self.AppManager.setCheckable(True)
    ## Edit-File
        editMenu = self.menu.addMenu('&Edit-Files')
        # build.prop
        editMenu.addAction('build.prop',self.slotbuildprop)
        # packages.xml
        editMenu.addAction('packages.xml',self.slotpackagesxml)
        # packages.list
        editMenu.addAction('packages.list',self.slotpackageslist)
    ## Scripts
        scriptMenu = self.menu.addMenu('&Scripts')
        # clean android
        scriptMenu.addAction('Clean Android',self.slotcleanAndroid)
        scriptMenu.addSeparator()
        # adblock
        scriptMenu.addAction('Block Ads with hosts-file',self.slotAdBlock)
        # zipalign
        scriptMenu.addAction('Zipalign',self.slotzipalign)
        # permission-fix
        scriptMenu.addAction('Permission-fix',self.slotFixPermissions)
        # take screenshot
        scriptMenu.addAction('Take screenshot',self.slotscreenshot)
        # restore bootsplash
        scriptMenu.addAction('Restore bootsplash', self.slotFlashSplash)
        # change MAC
        scriptMenu.addAction('Change MAC Address', self.slotchangeMAC)
        scriptMenu.addSeparator()
        # root device
        scriptMenu.addAction('Root device (experimental)',self.slotrootdevice)
        scriptMenu.addSeparator()
        # install zipalign binary and init.d script
        scriptMenu.addAction('Install zipalign binary and init.d script',self.slotinstallZipalign)
        scriptMenu.addSeparator()
        # wipe battery-stats
        scriptMenu.addAction('Wipe battery-stats',self.slotbattery)
        # wipe dalvik-cache
        scriptMenu.addAction('Wipe dalvik-cache',self.slotdalvik)
    ## System-Info'
        infoMenu = self.menu.addMenu('&System-Info')
        # browse android system
        infoMenu.addAction('Open AndroidExplorer',self.runFileBrowser)
        infoMenu.addSeparator()
        # storage
        self.deviceINFO = infoMenu.addAction('Device/Storage info',self.slotINFO)
        self.deviceINFO.setCheckable(True)
        # - TEST -
        self.procInfos = infoMenu.addAction('/proc/*',self.slotProcInfos)
        self.procInfos.setCheckable(True)
        # props
        self.getProps = infoMenu.addAction('Get props', self.slotgetProps)
        self.getProps.setCheckable(True)
        infoMenu.addSeparator()
        # logcat
        self.log = infoMenu.addAction('Logcat',self.slotlogcat)
        self.log.setCheckable(True)
    ## Download
        downMenu = self.menu.addMenu('&Download / Flash')
        cwmDownMenu = downMenu.addMenu('Recovery')
        # stock recovery 2.3.5
        cwmDownMenu.addAction('Stock Recovery (2.3.5)',self.slotStockRecov)
        cwmDownMenu.addSeparator()
        # clockworkmod recovery 5027 w/ touch
        cwmDownMenu.addAction('ClockworkMod 5027 Touch',self.slotcwm5touch)
        # clockworkmod recovery 6010
        cwmDownMenu.addAction('ClockworkMod 6010',self.slotcwm6)
        # clockworkmod recovery 6010 w/ charge
        cwmDownMenu.addAction('ClockworkMod 6010 w/ Charge',self.slotcwm6wcharge)
        kernelDownMenu = downMenu.addMenu('Kernel')
        kStockDownMenu = kernelDownMenu.addMenu('Stock')
        # stock kernel 2.3.5
        kStockDownMenu.addAction('Stock, (2.3.5)',self.slotk235)
        # stock kernel 2.3.6 w/ oc
        kStockDownMenu.addAction('Stock, OC (844) (2.3.6)',self.slotk236)
        # stock kernel (lucky86) w/ oc
        kStockDownMenu.addAction('Stock, OC (729) Lucky',self.slotkluckyStock)
        kCMDownMenu = kernelDownMenu.addMenu('CM7')
        # cyanogenmod kernel (lucky86) w/ oc
        kCMDownMenu.addAction('CM7, OC (729) Lucky',self.slotkluckyCM)
        # cyanogenmod kernel (supertoast) w/ oc
        kCMDownMenu.addAction('CM7, OC (844) Toast',self.slotktoastCM)
        downMenu.addSeparator()
        downMenu.addSeparator()
        # flash bootanimation
        bAnimMenu = downMenu.addMenu('Bootanimation')
        bAnimStockMenu = bAnimMenu.addMenu('Stock')
        bAnimStockMenu.addAction('Choose bootanimation', self.slotFlashAnimStock)
        bAnimCMMenu = bAnimMenu.addMenu('CM7')
        bAnimCMMenu.addAction('Choose bootanimation', self.slotFlashAnimCM)
    ## Help
        helpMenu = self.menu.addMenu('&Help')
        helpMenu.addAction('Howto - Android ADB Setup',self.slotHowtoADBSetup)
        helpMenu.addSeparator()
        helpMenu.addAction('Check for Updates', self.slotUpdateApp)
        helpMenu.addSeparator()
        # log
        helpMenu.addAction('Log', self.slotLog)
        # about
        helpMenu.addAction('About', self.slotAbout)
# END: CREATE-MENU -----------------------------------------------------------------------

# BEGIN: CALL-APPS -----------------------------------------------------------------------
    def runMegaDL(self, url):
        if not url:
            return
        if not mega:
            QMessageBox().information(self, 'Info', '\'megadl\' not found! (Please install \'Megatools\')')
            DBridge.logging.debug('\'megadl\' not found! (Please install \'Megatools\')')
            return
        if not ospath.isdir(DownloadDir): os.makedirs(DownloadDir)
        if 'Server returned error ENOENT' in DBridge.MyProcess('{0} --path {1} {2}'.format(mega,DownloadDir,url)):
            DBridge.logging.debug('megadl: File not found!')

    def runEditor(self, cmd):
        DBridge.MyProcess('{0} {1} {2}'.format(Python,ospath.join(ResDir,'QtEditor.py'),cmd))

    def runFileBrowser(self):
        if (OS == 'lin') or (OS == 'win'):
            DBridge.MyProcess('{0} {1}'.format(Python,ospath.join(ResDir,'AndroidExplorer','AndroidExplorer.py')))
        else:
            QMessageBox().information(self, 'Info', 'Sorry, for Linux and Windows only!')
            return

    def runBackupADB(self):
        DBridge.MyProcess('{0} {1}'.format(Python,ospath.join(ResDir,'BackupADB.py')))
# END: CALL-APPS -------------------------------------------------------------------------

# BEGIN: MESSAGES/STATUSBAR --------------------------------------------------------------        
    def msgBoxNoBusybox(self):
        QMessageBox().information(self, 'Attention!', 'BusyBox was not found!')
        
    def msgBoxDone(self, done=''):
        if done:
            QMessageBox().information(self,'',done)
        else:
            QMessageBox().information(self,'','Done!')
            
    def msgBoxFailed(self, failed=''):
        if failed:
            QMessageBox().information(self,'',failed)
        else:
            QMessageBox().information(self,'','Failed!')
            
    def msgBox(self, title='Attention!', text='Continue?', info_warning='info'):
        if info_warning == 'info':
            ret = QMessageBox.information(self, title, text, '&Ok', '&Cancel', '', 0, 1)
        elif info_warning == 'warn':
            ret = QMessageBox.warning(self, title, text, '&Ok', '&Cancel', '', 0, 1)
        else:
            return False
        if ret == 0:
            return True
        else:
            return False
        
    def msgBoxInput(self, Title, Text, Detailed=''):
        mb = MyMessageBox()
        mb.setWindowTitle(unicode(Title))
        mb.setText(unicode(Text))
        if Detailed:
            mb.setDetailedText(unicode(Detailed))
        mb.exec_()
            
    def msgStatusBar(self, msg):
        self.statusBar().showMessage(msg)
        
    def lblStatusBar(self, msg):
        self._lblStatus.setText(msg)

    def refreshStatusbar(self):
        device = DBridge.Custom(adb,fastboot)._GetAttached()
        if not device:
            self._label.setText('no device found')
        else:
            self._label.setText('{0[0]} ({0[1]})'.format(device))
# END: MESSAGES/STATUSBAR ----------------------------------------------------------------

# BEGIN: RESET-LAYOUTS -------------------------------------------------------------------
    def clearLayout(self, layouts=None):
        if layouts == None:
            layouts = [self.hLayout, self.vLayout, self.btnLayout]
        try:
            for l in layouts:
                while l.count() > 0:
                    item = l.takeAt(0)
                    if not item:
                        continue
                    w = item.widget()
                    if w:
                        w.setParent(None)
        except TypeError: pass
        finally:
            try:
                self._tableView.model().removeAllRows()
            except:
                pass
            self.qprocess.kill()
            self.lblStatusBar('')
            self.MenuMode = None
            self.killProcVar = True

    def clearChkBoxes(self, checkbox=None):
        checkboxes = [self.AppManager,self.deviceINFO,self.procInfos,self.getProps,self.log]
        for cb in checkboxes:
            if checkbox:
                if cb == checkbox:
                    continue
            cb.setChecked(False)
        self.clearLayout()
# END: RESET-LAYOUTS ---------------------------------------------------------------------

# BEGIN: ADB/CONTEXTMENU/INFO - FUNTIONS -------------------------------------------------
    def StartAdbServer(self):
        DBridge.Adb(adb,'cmd')._start()
    def KillAdbServer(self):
        DBridge.Adb(adb,'cmd')._kill()
    def RestartAdbServer(self):
        self.KillAdbServer()
        self.StartAdbServer()

    def hotreboot(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] == 'fastboot': return
        DBridge.logging.debug('hot reboot')
        DBridge.Adb(adb)._shell('kill system_server && system_server')
    def adbRemount(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] == 'fastboot': return
        DBridge.Adb(adb,'cmd')._remount()
        DBridge.Custom(adb,fastboot).waitfordevice()
    def adbReboot(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] == 'fastboot': return
        DBridge.Adb(adb,'cmd')._reboot()
        DBridge.Custom(adb,fastboot).waitfordevice()
    def adbRecovery(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] == 'fastboot': return
        DBridge.Adb(adb,'cmd')._reboot('recovery')
        DBridge.Custom(adb,fastboot).waitfordevice()
    def adbBootloader(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] == 'fastboot': return
        DBridge.Adb(adb,'cmd')._reboot('bootloader')
        DBridge.Custom(adb,fastboot).waitfordevice()
    def adbShutdown(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] == 'fastboot': return
        DBridge.Adb(adb,'cmd')._shutdown()

    def fastbootShutdown(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'cmd')._shutdown()
    def fastbootReboot(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'cmd')._reboot()
        DBridge.Custom(adb,fastboot).waitfordevice()
    def fastbootBootloader(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'cmd')._reboot('bootloader')
        DBridge.Custom(adb,fastboot).waitfordevice()
    def fastbootKernel(self,fname):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'cmd')._boot(fname)
        DBridge.Custom(adb,fastboot).waitfordevice()
    def fastbootRecovery(self, fname):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'cmd')._boot(fname)
        DBridge.Custom(adb,fastboot).waitfordevice()
    def fastbootflashKernel(self, fname):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'out')._flash('boot', fname)
        DBridge.Custom(adb,fastboot).waitfordevice()
    def fastbootflashRecovery(self, fname):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if DBridge.Custom(adb,fastboot)._GetAttached()[1] != 'fastboot': return
        DBridge.Fastb(fastboot,'out')._flash('recovery', fname)
        DBridge.Custom(adb,fastboot).waitfordevice()

    def getRights(self,afile):
        if not afile: return
        try:
            perm = DBridge.Adb(adb)._shell('ls -l {0}'.format(afile)).split()[0][1:]
            a,b,c,d = 0,0,0,0
            # Owner
            if 'r' in perm[0:3]: a += 4
            if 'w' in perm[0:3]: a += 2
            if 'x' in perm[0:3]: a += 1
            if 'S' in perm[0:3]: d += 4
            if 's' in perm[0:3]: a += 1; d += 4
            # Group
            if 'r' in perm[3:6]: b += 4
            if 'w' in perm[3:6]: b += 2
            if 'x' in perm[3:6]: b += 1
            if 'S' in perm[3:6]: d += 2
            if 's' in perm[3:6]: b += 1; d += 2
            # Other
            if 'r' in perm[6:9]: c += 4
            if 'w' in perm[6:9]: c += 2
            if 'x' in perm[6:9]: c += 1
            if 'T' in perm[6:9]: d += 1
            if 't' in perm[6:9]: c += 1; d += 1
            rights = ''.join([str(d),str(a),str(b),str(c)])
        except: rights = False
        finally: return rights

    def getOwner(self,afile):
        # 2=owner/3=group
        if not afile: return
        try:
            ret = bool
            ret = DBridge.Adb(adb)._shell('ls -la {0}'.format(afile)).split()
            ret = '{0}.{1}'.format(ret[2],ret[3])
        except: ret = False
        finally: return ret

    def chmod_chown(self,afile,rights=None,owner=None):
        try:
            if rights != None:
                chmod = DBridge.Adb(adb)._shell('chmod {0} {1}'.format(rights,afile))
            if owner != None:
                chown = DBridge.Adb(adb)._shell('chown {0} {1}'.format(owner,afile))
            if (rights == None) and (owner == None):
                rights = self.getRights(afile); owner = self.getOwner(afile)
                chmod = DBridge.Adb(adb)._shell('chmod {0} {1}'.format(rights,afile))
                chown = DBridge.Adb(adb)._shell('chown {0} {1}'.format(owner,afile))
            if 'No such file or directory' in chmod: d = 'Failed'
            else: d = 'Done'
            if 'No such file or directory' in chown: n = 'Failed'
            else: n = 'Done'
        except: d = 'Failed'; n = 'Failed'
        finally:
            DBridge.logging.debug('CHMOD: {0}, {1}'.format(rights,d))
            DBridge.logging.debug('CHOWN: {0}, {1}'.format(owner,n))

    def install(self, pkgname, value=None):
        if not pkgname: return
        ret = False
        busybox = False
        busybox = DBridge.Custom(adb,fastboot)._HasBusybox()
        App = ospath.join(unicode(self.ApkInstallPath),unicode(pkgname)+'.apk')
        if value == None:
            o = DBridge.Adb(adb, 'cmd')._install(App)
            self.pgwidget.plainTextEdit.appendPlainText(unicode(o))
            if DBridge.Custom(adb,fastboot)._HasInstalled(App,o):
                ret = True
        elif value == 'rst':
            if DBridge.Custom(adb,fastboot)._HasInstalled(App,DBridge.Adb(adb,'out')._install(App,'-r')):
                DBridge.Custom(adb,fastboot)._remount('data')
                DBridge.logging.debug('RESTORE DATA')
                zFile = App.replace('.apk','.tar')
                zName = pkgname.replace('.apk','.tar')
                if DBridge.Custom(adb,fastboot)._HasPushed(zFile,'/data/local/tmp'):
                    DBridge.Adb(adb)._shell('su -c \"tar xf \'/data/local/tmp/{0}\' -C /data/data\"'.format(zName))
                    if busybox:
                        DBridge.Adb(adb)._shell('busybox rm -f \'/data/local/tmp/{0}\''.format(zName))
                    else:
                        DBridge.Adb(adb)._shell('rm \'/data/local/tmp/{0}\''.format(zName))
                self.slotpermission(DBridge.Aapt(aapt).PackageLabel(App), False)
                ret = True
        elif value == 'rstD':
            DBridge.Custom(adb,fastboot)._remount('data')
            DBridge.logging.debug('RESTORE DATA')
            zFile = App.replace('.apk','.tar')
            zName = pkgname.replace('.apk','.tar')
            if DBridge.Custom(adb,fastboot)._HasPushed(zFile,'/data/local/tmp'):
                DBridge.Adb(adb)._shell('su -c \"tar xf \'/data/local/tmp/{0}\' -C /data/data\"'.format(zName))
                if busybox:
                    DBridge.Adb(adb)._shell('busybox rm -f \'/data/local/tmp/{0}\''.format(zName))
                else:
                    DBridge.Adb(adb)._shell('rm \'/data/local/tmp/{0}\''.format(zName))
                self.slotpermission(DBridge.Aapt(aapt).PackageLabel(App), False)
                ret = True
        elif value == 'sys':
            DBridge.Custom(adb,fastboot)._remount('system')
            if DBridge.Custom(adb,fastboot)._HasPushed(App,'/system/app/{0}.t'.format(pkgname)):
                DBridge.Adb(adb,'cmd')._shell('mv /system/app/{0}.t /system/app/{0}'.format(pkgname))
                self.chmod_chown('/system/app/{0}'.format(pkgname),'644','0.0')
                ret = True
        else:
            if DBridge.Custom(adb,fastboot)._HasInstalled(App,DBridge.Adb(adb,'out')._install(App,value)):
                ret = True
        return ret

    def uninstall(self,pkgname, pkgpath, keep=False):
        if not (pkgname and pkgpath): return
        mtd = pkgpath.split('/')[1]
        busybox = False
        busybox = DBridge.Custom(adb,fastboot)._HasBusybox()
        if keep:
            if not DBridge.Custom(adb,fastboot)._HasUninstalled(pkgname,DBridge.Adb(adb)._shell('pm uninstall -k {0}'.format(pkgname))):
                DBridge.Custom(adb,fastboot)._remount(mtd)
                if busybox:
                    DBridge.Adb(adb,'out')._shell('busybox rm -f {0}'.format(pkgpath))
                else:
                    DBridge.Adb(adb,'out')._shell('rm {0}'.format(pkgpath))
            ret=True
        else:
            if not DBridge.Custom(adb,fastboot)._HasUninstalled(pkgname,DBridge.Adb(adb)._shell('pm uninstall {0}'.format(pkgname))):
                DBridge.Custom(adb,fastboot)._remount(mtd)
                DBridge.Custom(adb,fastboot)._remount('data')
                if busybox:
                    DBridge.Adb(adb,'out')._shell('busybox rm -f {0}'.format(pkgpath))
                    DBridge.Adb(adb,'out')._shell('busybox rm -rf /data/data/{0}'.format(pkgname))
                else:
                    DBridge.Adb(adb,'out')._shell('rm {0}'.format(pkgpath))
                    DBridge.Adb(adb,'out')._shell('rm -r /data/data/{0}'.format(pkgname))
            ret=True
        return ret

    def backup(self, pkgname, pkgpath, value = 'AppData'):
        if not (pkgname and pkgpath): return
        realAppName = ''
        ret = False
        mtd = pkgpath.split('/')[1]
        DBridge.Custom(adb,fastboot)._remount(mtd)
        if DBridge.Custom(adb,fastboot)._HasBusybox():
            realpkgpath = DBridge.Adb(adb)._shell('busybox realpath {0}'.format(pkgpath))
        else:
            realpkgpath = pkgpath
        outdir  = ospath.join(BackupDir,mtd)
        outfile = ospath.join(outdir,pkgname)
        apkOut  = outfile+'.apk'
        tarOut  = outfile+'.tar'

        if not ospath.isdir(outdir): os.makedirs(outdir)
        DBridge.logging.debug('BACKUP: {0}'.format(pkgname))
        if value == 'App':
            if DBridge.Custom(adb,fastboot)._HasPulled(realpkgpath,apkOut):
                try:
                    realAppName = DBridge.Aapt(aapt).AppLabel(apkOut)
                    AppVersion = DBridge.Aapt(aapt).VersionName(apkOut)
                except IOError:
                    realAppName = pkgname                
                if realAppName == ' ':
                    realAppName = pkgname
                if '/' in realAppName:
                    realAppName = realAppName.replace('/',',')
                if ospath.isfile(apkOut):
                    move(apkOut,ospath.join(outdir,'{0} {1}.apk'.format(realAppName, AppVersion)))
                    DBridge.logging.debug('APP: Done')
                    ret = True
                else:
                    return ret
            else:
                DBridge.logging.debug('APP: Failed')
        elif value == 'Data':
            DBridge.Adb(adb)._shell('busybox tar -hvcf /data/local/tmp/{0}.tar {0} -C /data/data'.format(pkgname))
            if DBridge.Custom(adb,fastboot)._HasPulled('/data/local/tmp/{0}.tar'.format(pkgname), tarOut):
                DBridge.Adb(adb)._shell('busybox rm -f /data/local/tmp/{0}.tar'.format(pkgname))
            if ospath.isfile(tarOut):
                DBridge.logging.debug('DATA: Done')
                ret = True
            else:
                DBridge.logging.debug('DATA: Failed')
        elif value == 'AppData':
            if DBridge.Custom(adb,fastboot)._HasPulled(realpkgpath,apkOut):
                realAppName = DBridge.Aapt(aapt).AppLabel(apkOut)
                AppVersion = DBridge.Aapt(aapt).VersionName(apkOut)
                if realAppName == ' ':
                    realAppName = pkgname
                if ospath.isfile(apkOut):
                    move(apkOut,ospath.join(outdir,'{0} {1}.apk'.format(realAppName, AppVersion)))
                    DBridge.logging.debug('APP: Done')
                    ret = True
            else:
                DBridge.logging.debug('APP: Failed')
            DBridge.Adb(adb)._shell('busybox tar -hvcf /data/local/tmp/{0}.tar {0} -C /data/data'.format(pkgname))
            if DBridge.Custom(adb,fastboot)._HasPulled('/data/local/tmp/{0}.tar'.format(pkgname), tarOut):
                DBridge.Adb(adb)._shell('busybox rm -f /data/local/tmp/{0}.tar'.format(pkgname))
            if ospath.isfile(tarOut):
                move(tarOut,ospath.join(outdir,'{0} {1}.tar'.format(realAppName, AppVersion)))
                if ospath.isdir(outfile):
                    rmtree(outfile)
                if ospath.isfile(realAppName+'.tar'):
                    DBridge.logging.debug('DATA: Done')
                    ret = True
            else:
                DBridge.logging.debug('DATA: Failed')
        else: pass
        return ret

    def freeze(self,package):
        if not package: return
        DBridge.logging.debug('FREEZE: {0}'.format(package))
        if 'disabled' in DBridge.Adb(adb)._shell('pm disable {0}'.format(package)):
            return True
        else: return False

    def unfreeze(self,package):
        if not package: return
        DBridge.logging.debug('UNFREEZE: {0}'.format(package))
        if 'enabled' in DBridge.Adb(adb)._shell('pm enable {0}'.format(package)):
            return True
        else: return False

    def movetouser(self,package):
        if not package: return
        ret=bool
        busybox = False
        try:
            busybox = DBridge.Custom(adb,fastboot)._HasBusybox()
            pkg = ospath.basename(package)
            pkg_new = pkg.replace('-2.apk','-1.apk')
            dex_old = package[1:].replace('/','@')+'@classes.dex'
            DBridge.Custom(adb,fastboot)._remount('system'); DBridge.Custom(adb,fastboot)._remount('data')
            DBridge.Adb(adb,'cmd')._shell('cp -f {0} /cache/download/{1}'.format(package,pkg_new))
            if busybox:
                DBridge.Adb(adb,'cmd')._shell('busybox rm -f {0}'.format(package))
                DBridge.Adb(adb,'cmd')._shell('busybox rm -f /data/dalvik-cache/{0}'.format(dex_old))
            else:
                DBridge.Adb(adb,'cmd')._shell('rm {0}'.format(package))
                DBridge.Adb(adb,'cmd')._shell('rm /data/dalvik-cache/{0}'.format(dex_old))
            msg=DBridge.Adb(adb,'out')._shell('pm install -r -f /cache/download/{0}'.format(pkg_new))
            if busybox:
                DBridge.Adb(adb,'cmd')._shell('busybox rm -f /cache/download/{0}'.format(pkg_new))
            else:
                DBridge.Adb(adb,'cmd')._shell('rm /cache/download/{0}'.format(pkg_new))
            if msg == 'Done': ret=True; DBridge.logging.debug('CONVERT TO USER-APP: Done')
            elif msg == 'Failed': ret=False; DBridge.logging.debug('CONVERT TO USER-APP: Failed')
        except: pass
        finally: return ret

    def movetosystem(self,pkgname,pkgpath):
        if not (pkgname and pkgpath): return
        ret=bool
        try:
            pkg = ospath.basename(l)
            pkg_new = pkg.replace('-2.apk','.apk').replace('-1.apk','.apk')
            DBridge.Custom(adb,fastboot)._remount('system'); DBridge.Custom(adb,fastboot)._remount('data')
            DBridge.Adb(adb,'cmd')._shell('cp -f {0} /system/app/{1}.t'.format(pkgpath,pkg_new))
            msg=DBridge.Adb(adb,'out')._shell('pm uninstall -k {0}'.format(pkgname))

            DBridge.Adb(adb,'cmd')._shell('mv /system/app/{0}.t /system/app/{0}'.format(pkg_new))
            self.chmod_chown('/system/app/{0}'.format(pkg_new),'644','0.0')
            if msg == 'Done': ret=True; DBridge.logging.debug('CONVERT TO SYSTEM-APP: Done')
            elif msg == 'Failed': ret=False; DBridge.logging.debug('CONVERT TO SYSTEM-APP: Failed')
        except: pass
        finally: return ret

    def mtdBackup(self,mtd):
        if not mtd: return
        ret = False
        try:
            if 'mtd' in mtd:
                mtd = int(str(mtd).replace('mtd', ''))
            cmd = DBridge.Adb(adb)._shell('cat /proc/mtd | grep mtd{0}'.format(mtd)).replace(':','').replace('\"','').split()
            DBridge.Adb(adb,'cmd')._shell('\"cat /dev/mtd/{0[0]} > {1}/{0[3]}.img\"'.format(cmd, EXTERNAL_STORAGE()))
            if DBridge.Custom(adb,fastboot)._HasPulled('{0}/{1[3]}.img'.format(EXTERNAL_STORAGE(), cmd), 'backup/mtd/{0[3]}.img'.format(cmd)):
                if DBridge.Custom(adb,fastboot)._HasBusybox():
                    DBridge.Adb(adb,'cmd')._shell('busybox rm -f {0}/{1[3]}.img'.format(EXTERNAL_STORAGE(), cmd))
                else:
                    DBridge.Adb(adb,'cmd')._shell('rm {0}/{1[3]}.img'.format(EXTERNAL_STORAGE(), cmd))
                ret=True
        except: pass
        return ret

    def backupcustom(self, name, path):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        ret = False
        outfile = ospath.join(BackupDir, 'custom', ospath.basename(path))
        try:
            mtd = path.split('/')[1]
            DBridge.Custom(adb,fastboot)._remount(mtd)
            if DBridge.Custom(adb,fastboot)._HasPulled(path,outfile):
                ret = True
        except: pass
        return ret      

    def ByteConvert(self, item, value='M'):
        out = 0.0
        item = item.replace(',','.').replace(' ','')
        if   item.endswith(('k','K','kB','KB')):out = float(item[:-1])*1024
        elif item.endswith(('M','MB')):         out = float(item[:-1])*(1024**2)
        elif item.endswith(('G','GB')):         out = float(item[:-1])*(1024**3)
        else:                                   out = float(item)*1024
        if   value == 'B': return '{:.2f} B'.format(out*1024)
        elif value == 'K': return '{:.2f} KB'.format(out/1024)
        elif value == 'M': return '{:.2f} MB'.format(out/(1024**2))
        elif value == 'G': return '{:.2f} GB'.format(out/(1024**3))
        else:              return '{:.2f}'.format(out)
# END: ADB/CONTEXTMENU/INFO - FUNTIONS ---------------------------------------------------

# BEGIN: TABLE-FUNCTIONS -----------------------------------------------------------------
    def mainTableView(self, data, header, disable_column=0):
        self._tableView.setModel(MyTableModel(sorted(data), header))        
        self._tableView.setStyleSheet("""
            QHeaderView::section{
                    background-color: qlineargradient(x1:0, y1:0, x2:0, y2:1,
                                                      stop:0 #616161, stop: 0.5 #505050,
                                                      stop: 0.6 #434343, stop:1 #656565);
                        color: white;
                        padding-left: 4px;
                        border: 1px solid #6c6c6c;
                     }
            """)
        for row in xrange(self._tableView.model().rowCount()):
            self._tableView.setRowHeight(row, IconSize)
    def getSelectedRows(self):
        data = []
        for i in self._tableView.selectionModel().selectedRows():
            data.append(self._tableView.model().getRow(i.row()))
        return data
# END: TABLE-FUNCTIONS -------------------------------------------------------------------
    
# BEGIN: LIST-APPS/DALVIK/etc. -----------------------------------------------------------
    def listAppsRaw(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        cmd = 'pm list packages'
        return filter(None, DBridge.Adb(adb)._shell(cmd).replace('package:','').splitlines())
    def listApps(self,value=None):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        cmd = 'pm list packages -f'
        if value != None:  cmd += ' | grep -v {0}'.format(value)
        apps = filter(None, DBridge.Adb(adb)._shell(cmd).replace('package:','').splitlines())
        return [(x.split('=')[1],x.split('=')[0]) for x in apps]

    def listUselessDalvik(self):
        apps = [x.split('=')[0][1:] for x in DBridge.Adb(adb)._shell('pm list packages -f').replace('package:','').splitlines()]
        dalvik = [x for x in DBridge.Adb(adb)._shell('ls /data/dalvik-cache')
                  .replace('@classes.dex','').replace('@','/').splitlines() if not x.endswith('.jar')]
        useless_dalvik = [ospath.join('/data','dalvik-cache',x.replace('/','@')) for x in list(set(dalvik)-set(apps))]
        return useless_dalvik

    def listFreezeApps(self,value):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        pkgs = filter(None, DBridge.Adb(adb)._shell('pm list packages -f').replace('package:','').splitlines())
        new  = filter(None, DBridge.Adb(adb)._shell('pm list packages -{0}'.format(value)).replace('package:','').splitlines())
        pkgs = [(x.split('=')[1],x.split('=')[0]) for x in pkgs]
        return [(x,y) for x,y in pkgs for item in new if x == item]

    def listMTD(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        cmd = DBridge.Adb(adb)._shell('cat /proc/mtd').replace(':', '').replace('\"\"', '.').replace('\"', '').splitlines()[1:]
        return zip([x.split()[0] for x in cmd], \
                   [x.split()[3].replace('.',' ') for x in cmd])

    def listPROP(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        cmd = filter(None,DBridge.Adb(adb)._shell('getprop').replace('[','').replace(']','').replace(' ','').splitlines())
        return [(x.split(':')[0],x.split(':')[1]) for x in cmd]

    def listDirectory(self, path):
        a = [unicode(x[:-4]) for x in os.listdir(path) if x.endswith('.apk')]
        b = [unicode(x[:-7]) for x in os.listdir(path) if x.endswith('.tar')]
        n=[]
        m=''
        for x in a:
            pkgName = DBridge.Aapt(aapt).AppLabel(ospath.join(unicode(path), x+'.apk'))
            m = ' '
            if x in b:
                m = x+'.tar'
            n.append((pkgName,x+'.apk',m))
        return n

    def listApkDirectory(self, path):
        n=[]
        for x in os.listdir(path):
            if x.endswith('.apk'):
                pkgName = DBridge.Aapt(aapt).AppLabel(ospath.join(unicode(path), unicode(x)))
                n.append((pkgName,unicode(x[:-4])))
        return n

    def listAppsFixed(self):
        cmdApp = 'pm list packages -f'
        apps = filter(None, DBridge.Adb(adb)._shell(cmdApp).replace('package:','').splitlines())
        a = []
        for x in apps:
            try:
                CODEPATH, PKGNAME = x.split('=')
                DATAPATH = '/data/data/{0}'.format(PKGNAME)
                #PKGOCTAL, PKGUID = DBridge.Adb(adb)._shell('busybox stat -c %a,%u {0}'.format(CODEPATH)).split(',')
                d = DBridge.Adb(adb)._shell('busybox ls -ldi {0}'.format(CODEPATH)).split()
                PKGOCTAL, PKGUID = d[0], d[3]
                a.append((PKGNAME,CODEPATH,PKGUID,PKGOCTAL))
            except ValueError:
                continue
        return a

    def listZipaligned(self):
        QMessageBox().information(self, 'Clear Android', 'Please wait...')
        cmdApp = 'pm list packages -f'
        apps = filter(None, DBridge.Adb(adb)._shell(cmdApp).replace('package:','').splitlines())
        if not DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(ResDir,'zipalign'),'/data/local/'):
            DBridge.logging.debug('ERROR: could not copy zipalign to /data/local!')            
        self.chmod_chown('/data/local/zipalign','755','0.0')
        l=[]
        for app in apps:
            path, name = app.split('=')
            data = DBridge.Adb(adb)._shell('/data/local/zipalign -c -v 4 {}'.format(path))
            zipaligned = re.findall(r'Verification\s+(.*)', data)
            result = 'False'
            if len(zipaligned) > 0:            
                if 'succesful' in zipaligned:
                    result = 'True'
            l.append((name, path, result))
        return l
# END: LIST-APPS/DALVIK/etc. -------------------------------------------------------------

# BEGIN: ADB/SDK/MEGATOOLS ---------------------------------------------------------------
    def download(self, cmd):
        from threading import Thread
        def down((url, path)):
            return str(urllib.urlretrieve(url, path)[0])
        t = Thread(target=down, args=[cmd])
        self.msgStatusBar('Download runs in the background')
        t.start()

    def slotDownloadSDK(self):
        if not ospath.isdir(DownloadDir): os.makedirs(DownloadDir)
        if OS == 'win':
            url, path = 'installer_r22.3-windows.exe', ospath.join(DownloadDir, 'SDK.exe')
        elif OS == 'lin':
            url, path = 'android-sdk_r22.3-linux.tgz', ospath.join(DownloadDir, 'SDK.tgz')
        elif OS == 'mac':
            url, path = 'android-sdk_r22.3-macosx.zip', ospath.join(DownloadDir, 'SDK.zip')
        else:
            return
        self.download(('http://dl.google.com/android/{0}'.format(url),path))

    def slotDownloadMegatools(self):
        if not ospath.isdir(DownloadDir): os.makedirs(DownloadDir)
        if OS == 'win':
            files = urllib.urlretrieve('http://megatools.megous.com/builds/megatools-1.9.91-win32.zip',
                                       ospath.join(DownloadDir, 'Megatools.zip'))
            if ospath.isfile(str(files[0])):
                self.msgBoxDone('Download complete!')
            else:
                self.msgBoxFailed('Download failed!')
        elif OS == 'lin':
            '''
                suse, debian, fedora, redhat, centos, mandrake, mandriva, rocks,
                slackware, yellowdog, gentoo, unitedlinux, turbolinux, ubuntu
            '''
            if bit == 32:
                if distr == 'ubuntu':   dist = 'ubuntu-i386'
                elif distr == 'debian': dist = 'debian-wheezy-i386'
                elif distr == 'fedora': dist = 'fedora-i386'
                elif distr == 'suse':   dist = 'suse-i586'
                else:
                    QMessageBox().information(self, 'Attention!', 'Your distribution is not supported!')
                    return
            elif bit == 64:
                if distr == 'ubuntu':   dist = 'ubuntu-amd64'
                elif distr == 'debian': dist = 'debian-wheezy-amd64'
                elif distr == 'fedora': dist = 'fedora-x86_64'
                elif distr == 'suse':   dist = 'suse-x86_64'
                else:
                    QMessageBox().information(self, 'Attention!', 'Your distribution is not supported!')
                    return
            else:
                return
            files = urllib.urlretrieve('http://megatools.megous.com/builds/megatools-1.9.91-{0}.tar.gz'.format(dist),
                                       ospath.join(DownloadDir, 'Megatools.tar.gz'))
            if ospath.isfile(str(files[0])):
                self.msgBoxDone('Download complete!')
            else:
                self.msgBoxFailed('Download failed!')
        elif OS == 'mac':
            QMessageBox().information(self, 'Attention!', 'Your distribution is not supported!')
            return
        else:
            return

    def slotandroidsdkPath(self):
        self.androidsdk = QFileDialog.getExistingDirectory(self, 'Set \'Android-SDK (/adt/sdk/)\'-directory')
        if not self.androidsdk:
            return
        EditConfigMap('android','androidsdk',self.androidsdk)
        
    def slotmegadlPath(self):
        self.megadl = QFileDialog.getExistingDirectory(self, 'Set \'Megatools\'-directory')
        if not self.megadl:
            return
        EditConfigMap('megatools','megatools',self.megadl)
        
    def slotRestartAdb(self):
        self.RestartAdbServer()
        self.refreshStatusbar()

    def slotAdbShell(self):
        if OS == 'win':
            DBridge.MyProcess('start cmd /c \"{0}\" shell'.format(adb))
        elif OS == 'lin':
            DBridge.MyProcess('x-terminal-emulator -e \"{0}\" shell'.format(adb))
        else:
            return
# END: ADB/SDK/MEGATOOLS -----------------------------------------------------------------       

# BEGIN: BOOT/FLASH - KERNEL/RECOVERY ----------------------------------------------------
    def slotBootKernel(self):        
        self.bootImage(True)

    def slotBootRecovery(self):
        self.bootImage(False)

    def bootImage(self, default=True):
        self.clearLayout()
        fname = QFileDialog.getOpenFileName(self, 'Open File', \
                                            'Open image file', \
                                            self.tr('Image Files (*.img)'))
        if not fname.isEmpty():
            if not DBridge.Custom(adb,fastboot).checkForDevice():
                self.msgBoxFailed('Cannot continue: no device found!')
                return
            if self.msgBox('Reboot into bootloader'):
                self.msgStatusBar('reboot into bootloader')
                self.adbBootloader()
                self.msgStatusBar('boot new image...')
                if default:
                    self.fastbootKernel(fname)
                else:
                    self.fastbootRecovery(fname)
                self.msgStatusBar('reboot device')
                self.fastbootReboot()
                self.msgBoxDone()
            else: pass
        else: return

    def slotFlashKernel(self):
        self.flashImage(True)

    def slotFlashRecovery(self):        
        self.flashImage(False)    

    def flashImage(self, default=True):
        self.clearLayout()
        fname = QFileDialog.getOpenFileName(self, 'Open File', \
                                            'Open image file', \
                                            self.tr('Image Files (*.img)'))
        if not fname.isEmpty():
            if not DBridge.Custom(adb,fastboot).checkForDevice():
                self.msgBoxFailed('Cannot continue: no device found!')
                return
            if self.msgBox('Reboot into bootloader'):
                self.msgStatusBar('reboot into bootloader')
                self.adbBootloader()
                self.msgStatusBar('flash new image...')
                if default:
                    self.fastbootflashKernel(fname)
                else:
                    self.fastbootflashRecovery(fname)
                self.msgStatusBar('reboot device')
                self.fastbootReboot()
                self.msgBoxDone()
            else: pass
        else: return        
# END: BOOT/FLASH - KERNEL/RECOVERY ------------------------------------------------------

# BEGIN: CONTEXTMENU ---------------------------------------------------------------------
    def contextBackup(self,value='AppData'):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Backup'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.backup(name,path,value):
                    self.pgwidget.plainTextEdit.appendPlainText('Backup: {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Backup: {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextUninstall(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Uninstall'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.uninstall(name, path):
                    self.pgwidget.plainTextEdit.appendPlainText('Uninstall: {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Uninstall: {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            self.AppManagerChkBoxChanged()

    def contextUninstallKeep(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Uninstall (keep data)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.uninstall(name, path,True):
                    self.pgwidget.plainTextEdit.appendPlainText('Uninstall (keep): {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Uninstall (keep): {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            self.AppManagerChkBoxChanged()

    def contextFreeze(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Freeze'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.freeze(name):
                    self.pgwidget.plainTextEdit.appendPlainText('Freeze: {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Freeze: {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            self.AppManagerChkBoxChanged()

    def contextUnfreeze(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Unfreeze'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.unfreeze(name):
                    self.pgwidget.plainTextEdit.appendPlainText('Unfreeze: {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Unfreeze: {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            self.AppManagerChkBoxChanged()

    def contextConvUser(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Convert to User-App'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.movetouser(path):
                    self.pgwidget.plainTextEdit.appendPlainText('Convert (user): {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Convert (user): {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            self.AppManagerChkBoxChanged()

    def contextConvSystem(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Convert to System-App'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.movetosystem(name, path):
                    self.pgwidget.plainTextEdit.appendPlainText('Convert (system): {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Convert (system): {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            self.AppManagerChkBoxChanged()

    def contextBackupMTD(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Backup partition'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                mtd, name, = self.getSelectedRows()[i]
                if self.mtdBackup(mtd):
                    self.pgwidget.plainTextEdit.appendPlainText('Backup: {0}, Done'.format(name))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Backup: {0}, Failed'.format(name))
                i+=1
                self.pgwidget.pgBar.setValue(i)
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstall(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]
                if self.install(fname):
                    self.pgwidget.plainTextEdit.appendPlainText('Install: {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Install: {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstallRestore(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install (restore data)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]
                if self.install(fname,'rst'):
                    self.pgwidget.plainTextEdit.appendPlainText('Install (restore): {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Install & Restore: {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstallLock(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install (lock app)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]
                if self.install(fname,'-l'):
                    self.pgwidget.plainTextEdit.appendPlainText('Install (lock): {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Install (lock): {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstallReinstall(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install (keep data)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]
                if self.install(fname,'-r'):
                    self.pgwidget.plainTextEdit.appendPlainText('Install (keep): {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Install (keep): {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstallSDCARD(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install (sdcard)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]
                if self.install(fname,'-s'):
                    self.pgwidget.plainTextEdit.appendPlainText('Install (SDCard): {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Install (SDCard): {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstallSYSTEM(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install (system)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]
                if self.install(fname,'sys'):
                    self.pgwidget.plainTextEdit.appendPlainText('Install (System): {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Install (System): {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextInstallRestoreDATA(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Install (restore data only)'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, _, _, _, _ = self.getSelectedRows()[i]                
                if self.install(fname,'rstD'):
                    self.pgwidget.plainTextEdit.appendPlainText('Restore (Data): {0}, Done'.format(label))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Restore (Data): {0}, Failed'.format(label))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextFixPermissions(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Fix'): return
        self.slotpermission(self.getSelectedRows())

    def contextZipalign(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Zipalign'): return
        self.slotzipalign(self.getSelectedRows())

    def contextRename(self):
        if not self.msgBox('Rename'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                fname, label, pkgname, version, _, _ = self.getSelectedRows()[i]
                if label == ' ':
                    label = pkgname
                oldName = ospath.join(unicode(self.ApkPath),fname+'.apk')
                newName = ospath.join(unicode(self.ApkPath),'{0} {1}.apk'.format(label,version))
                if oldName == newName:
                    self.pgwidget.plainTextEdit.appendPlainText('Rename: {0}, Skip'.format(fname))
                else:
                    move(oldName,newName)
                    if ospath.isfile(newName):
                        self.pgwidget.plainTextEdit.appendPlainText('Rename: {0}, Done'.format(fname))
                    else:
                        self.pgwidget.plainTextEdit.appendPlainText('Rename: {0}, Failed'.format(fname))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)
            header, data = self.parseApk(unicode(self.ApkPath))
            self.mainTableView(data, header)
            self._tableView.model().setIcons(1)
            self._tableView.setVisible(False)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
            self.extractLogo(unicode(self.ApkPath))

    def contextBackupCustom(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Backup'): return
        i=0
        self.pgwidget.show()
        try:
            while i < len(self.getSelectedRows()):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, path = self.getSelectedRows()[i]
                if self.backupcustom(name,path):
                    self.pgwidget.plainTextEdit.appendPlainText('Backup: {0}, Done'.format(path))
                else:
                    self.pgwidget.plainTextEdit.appendPlainText('Backup: {0}, Failed'.format(path))
                i+=1
                self.pgwidget.pgBar.setValue(i)
                qApp.processEvents()
        finally:
            self.pgwidget.BtnClose.setEnabled(True)

    def contextMenuEvent(self, event):
        menu = QMenu()
        backupAction        = menu.addAction('backup')
        backup_AppAction    = menu.addAction('backup (app only)')
        backup_DataAction   = menu.addAction('backup (data only)')
        uninstallAction     = menu.addAction('uninstall')
        uninstallkeepAction = menu.addAction('uninstall (keep data)')
        freezeAction        = menu.addAction('freeze')
        unfreezeAction      = menu.addAction('unfreeze')
        convUserAction      = menu.addAction('convert to user app')
        convSystemAction    = menu.addAction('convert to system app')
        mtdAction           = menu.addAction('backup partition(s)')
        installAction       = menu.addAction('install')
        install_RstAction   = menu.addAction('install (restore data)')
        install_LAction     = menu.addAction('install (forward-lock)')
        install_RAction     = menu.addAction('reinstall (keep data)')
        install_SAction     = menu.addAction('install (SDCard)')
        install_SysAction   = menu.addAction('install (System)')
        restoreDataAction   = menu.addAction('restore data only')
        fixpermissionAction = menu.addAction('fix permission')
        zipalignAction      = menu.addAction('zipalign')
        renameAction        = menu.addAction('rename')
        backupcustomAction  = menu.addAction('backup')

        for d in [backupAction,backup_AppAction,backup_DataAction,uninstallAction,uninstallkeepAction,
                  freezeAction,unfreezeAction,convUserAction,convSystemAction,mtdAction,installAction,
                  install_RstAction,install_LAction,install_RAction,install_SAction,install_SysAction,
                  restoreDataAction,fixpermissionAction,zipalignAction,renameAction,backupcustomAction]:
            d.setVisible(False)

        if self.MenuMode == 0:
            backupAction.setVisible(True)
            backup_AppAction.setVisible(True)
            backup_DataAction.setVisible(True)
        elif self.MenuMode == 1:
            uninstallAction.setVisible(True)
            uninstallkeepAction.setVisible(True)
        elif self.MenuMode == 2:
            freezeAction.setVisible(True)
        elif self.MenuMode == 3:
            unfreezeAction.setVisible(True)
        elif self.MenuMode == 4:
            convUserAction.setVisible(True)
        elif self.MenuMode == 5:
            convSystemAction.setVisible(True)
        elif self.MenuMode == 6:
            mtdAction.setVisible(True)
        elif self.MenuMode == 7:
            installAction.setVisible(True)
            install_RstAction.setVisible(True)
            install_LAction.setVisible(True)
            install_RAction.setVisible(True)
            install_SAction.setVisible(True)
            install_SysAction.setVisible(True)
            restoreDataAction.setVisible(True)
        elif self.MenuMode == 8:
            fixpermissionAction.setVisible(True)
        elif self.MenuMode == 9:
            zipalignAction.setVisible(True)
        elif self.MenuMode == 10:
            renameAction.setVisible(True)
        elif self.MenuMode == 11:
            backupcustomAction.setVisible(True)
        else:
            self.MenuMode = None
            return

        self.pgwidget.plainTextEdit.clear()
        self.pgwidget.pgBar.setMaximum(len(self.getSelectedRows()))
        self.pgwidget.BtnClose.setEnabled(False)

        action = menu.exec_(self.mapToGlobal(event.pos()))
        if   action == backupAction:        self.contextBackup('AppData')
        elif action == backup_AppAction:    self.contextBackup('App')
        elif action == backup_DataAction:   self.contextBackup('Data')
        elif action == uninstallAction:     self.contextUninstall()
        elif action == uninstallkeepAction: self.contextUninstallKeep()
        elif action == freezeAction:        self.contextFreeze()
        elif action == unfreezeAction:      self.contextUnfreeze()
        elif action == convUserAction:      self.contextConvUser()
        elif action == convSystemAction:    self.contextConvSystem()
        elif action == mtdAction:           self.contextBackupMTD()
        elif action == installAction:       self.contextInstall()
        elif action == install_RstAction:   self.contextInstallRestore()
        elif action == install_LAction:     self.contextInstallLock()
        elif action == install_RAction:     self.contextInstallReinstall()
        elif action == install_SAction:     self.contextInstallSDCARD()
        elif action == install_SysAction:   self.contextInstallSYSTEM()
        elif action == restoreDataAction:   self.contextInstallRestoreDATA()
        elif action == fixpermissionAction: self.contextFixPermissions()
        elif action == zipalignAction:      self.contextZipalign()
        elif action == renameAction:        self.contextRename()
        elif action == backupcustomAction:  self.contextBackupCustom()
        else: return
# END: CONTEXTMENU -----------------------------------------------------------------------

# BEGIN: ADB-HELPER ----------------------------------------------------------------------
    def unzip(self, source_filename, dest_dir, pattern):        
        with zipfile.ZipFile(source_filename) as zf:
            for name in zf.namelist():
                if name.find(pattern) != -1:
                    zf.extract(name, dest_dir)
                
    def extractLogo(self, ApkDir):        
        apps = sorted([unicode(ospath.join(ApkDir, x)) for x in os.listdir(ApkDir) if x.endswith('.apk')])
        for app in apps:
            logo = DBridge.Aapt(aapt).IconPath(app)
            path1, name1 = ospath.split(app)
            path2, name2 = ospath.split(logo)
            new_name = ospath.join(CacheDir, name1.replace('.apk','.png'))
            old_name = ospath.join(CacheDir, logo)
            try:
                self.unzip(app, CacheDir, logo)
            except zipfile.BadZipfile:
                continue
            if ospath.isfile(old_name):
                move(old_name, new_name)
            qApp.processEvents()
            if ospath.isfile(new_name):
                self._tableView.model().emit(SIGNAL('layoutChanged()'))
        for root, dirs, files in os.walk(CacheDir):
            for f in dirs:
                rmtree(ospath.join(root, f))
            for f in files:
                if f.endswith('.png') or f.endswith('.xml'):
                    continue
                os.remove(ospath.join(root, f))

    def parseApk(self, ApkDir):
        apps = [ospath.join(ApkDir,x) for x in os.listdir(ApkDir) if x.endswith('.apk')]
        appList = []
        for app in apps:
            path, name = ospath.split(app)
            data = DBridge.Aapt(aapt).AppData(app)
            pkgLabel = re.findall('application-label:\'(.*?)\'', data)
            pkgName = re.findall('package: name=\'(.*?)\'', data)
            versionName = re.findall('versionName=\'(.*?)\'', data)
            sdkVersion = re.findall('sdkVersion:\'(.*?)\'', data)
            pkgSize = str(round(float(ospath.getsize(app))/1024**2, 2))+' MB'
            
            if pkgLabel:
                pkgLabel = pkgLabel[0]
            else:
                pkgLabel = ' '
            if pkgName:
                pkgName = pkgName[0]
            else:
                pkgName = ' '
            if versionName:
                versionName = versionName[0]
            else:
                versionName = ' '
            if sdkVersion:
                sdkVersion = sdkVersion[0]
            else:
                sdkVersion = ' '
            if not pkgSize:
                pkgSize = ' '
            appList.append((name[:-4], pkgLabel, pkgName, versionName, pkgSize, sdkVersion))
        header = ['Filename', 'Label', 'Packagename', 'Version', 'Size', 'SDK']
        return header, appList
        
    def getIcons(self, applist):
        def adbhelper(busyboxBin, name,path):
            DBridge.logging.debug('ICON: {}'.format(path))
            out = DBridge.Adb(adb)._shell('su -c \"am broadcast -a org.myklos.adbhelper -e data \'command=package&value={0}\' > /dev/null && \
                                             {1} base64 $EXTERNAL_STORAGE/tmp/adbhelper.png; \
                                             echo \'####\'; \
                                             {1} base64 $EXTERNAL_STORAGE/tmp/adbhelper.xml\"'.format(path,busyboxBin))
            if 'No such file or directory' in out:
                DBridge.logging.debug('base64: $EXTERNAL_STORAGE/tmp/adbhelper(.png/.xml): No such file or directory')
                return
            png, xml = out.replace('\r\n','').split('####')
            if not (png and xml): return
            try:
                png = base64.decodestring(png)
                xml = base64.decodestring(xml)
            except base64.binascii.Error:
                DBridge.logging.debug('no correct base64')
                return
            # ICON   ---------
            if not ospath.isfile(ospath.join(CacheDir,'{0}.png'.format(name))):
                with open(ospath.join(CacheDir,'{0}.png'.format(name)), 'wb') as f:
                    f.write(png)
            else:
                pass
            # XML   ----------
            if not ospath.isfile(ospath.join(CacheDir,'{0}.xml'.format(name))):
                with open(ospath.join(CacheDir,'{0}.xml'.format(name)), 'wb') as f:
                    f.write(xml)
            else:
                pass

        if not DBridge.Custom(adb,fastboot).checkForDevice(): return        
        if not ospath.isdir(CacheDir): os.makedirs(CacheDir)
        busyboxBin = 'busybox'
        if 'busybox' in DBridge.Adb(adb)._shell('ls /data/local/tmp'):
            busyboxBin = '/data/local/tmp/busybox'
        elif 'applet not found' in DBridge.Adb(adb)._shell('busybox base64 --help'):
                DBridge.logging.debug('base64 applet not found, please update BusyBox')
                DBridge.logging.debug('try to use local BusyBox version...')
                DBridge.Adb(adb)._push(ospath.join(RootDir, 'busybox'),'/data/local/tmp')
                self.chmod_chown('/data/local/tmp/busybox','755','0.0')
                busyboxBin = '/data/local/tmp/busybox'
        DBridge.Adb(adb)._shell('mkdir $EXTERNAL_STORAGE/tmp')

        # Create List of Icons and XMLs
        self.killProcVar = False
        oldAppList = []
        foundIcons,deleteIcons=[],[]
        foundXMLs,deleteXMLs=[],[]
        icons = [unicode(x[:-4]) for x in os.listdir(CacheDir) if x.endswith('.png')]
        xmls = [unicode(x[:-4]) for x in os.listdir(CacheDir) if x.endswith('.xml')]

        for i,x in enumerate(applist):
            if len(x) == 2:
                name, path = x
            elif len(x) == 4:
                name, path, _, _ = x
            elif len(x) == 5:
                _, name, path, _, _ = x
            else:
                continue
            # old app-list
            oldAppList.append((name,path))
            # icons
            for j in xrange(len(icons)):
                if name == icons[j]:
                    foundIcons.append((name, path))
            # xmls
            for j in xrange(len(xmls)):
                if name == xmls[j]:
                    foundXMLs.append((name, path))

        iconlist = list(set(oldAppList)-set(foundIcons))
        xmllist = list(set(oldAppList)-set(foundXMLs))
        applist = sorted(list(set(iconlist+xmllist)))

        # Delete unused Icons ans XMLs
        allApps = self.listAppsRaw()
        dellistIcons = list(set(icons)-set(allApps))
        for item in dellistIcons:
            print 'DEL (*.png): {}'.format(item)
            DBridge.logging.debug('DEL (*.png): {}'.format(item))
            os.remove(ospath.join(CacheDir, item+'.png'))
        dellistXMLs = list(set(xmls)-set(allApps))
        for item in dellistXMLs:
            print 'DEL (*.xml): {}'.format(item)
            DBridge.logging.debug('DEL (*.xml): {}'.format(item))
            os.remove(ospath.join(CacheDir, item+'.xml'))

        # Check for icons and xmls
        if not iconlist and not xmllist: return

        # Install ADB-Helper
        if helperApp == True:
            if not 'org.myklos.adbhelper' in DBridge.Adb(adb)._shell('pm list packages'):
                DBridge.Adb(adb, 'out')._install(ospath.join(ResDir,'ADBHelper.apk'))

        # Get Icons/XMLs
        i=0
        while i < len(applist):
            if self.killProcVar:
                DBridge.killProcess()
                break
            name, path = applist[i]
            adbhelper(busyboxBin,name,path)
            i+=1
            qApp.processEvents()
            self._tableView.model().emit(SIGNAL('layoutChanged()'))        
# END: ADB-HELPER ------------------------------------------------------------------------

# BEGIN: APP-MANAGER ---------------------------------------------------------------------
    def slotAppManager(self):
        #if not DBridge.Custom(adb,fastboot).checkForDevice():
        #    self.clearChkBoxes()
        #    return
        if self.AppManager.isChecked():
            self.clearChkBoxes(self.AppManager)
        else:
            self.clearChkBoxes()
            return
        self.AppManagerChk = ['Backup','Uninstall','Freeze','Unfreeze','Convert to User-App','Convert to System-App',
                              'Backup MTD','Install','Fix Permissions','ZipAlign','Rename Apps', 'Backup SMS,WLAN,etc.']
        for i in xrange(len(self.AppManagerChk)):
            self.AppManagerChk[i] = QRadioButton(self.AppManagerChk[i])
            self.btnLayout.addWidget(self.AppManagerChk[i])
            self.AppManagerChk[i].clicked.connect(self.AppManagerChkBoxChanged)
        self.vLayout.addLayout(self.btnLayout)
        self.vLayout.addStretch(1)
        self.hLayout.addLayout(self.vLayout)
        self.hLayout.addWidget(self._tableView)

    def AppManagerChkBoxChanged(self):
        global helperApp        
        self.killProcVar = True
        for i in xrange(len(self.AppManagerChk)):
            if i in [0,1,2,3,4,5,6,8,9,11]:
                if self.AppManagerChk[i].isChecked():
                    if not DBridge.Custom(adb,fastboot).checkForDevice():
                        return
        if helperApp == 'null':
            if self.msgBox('Install ADB-Helper?'):
                helperApp = True
            else:
                helperApp = False
        
        if self.AppManagerChk[0].isChecked():
            self.MenuMode = 0
            apps = self.listApps()
            self.mainTableView(apps,['Packagename', 'Path'])
            self._tableView.model().setIcons(1)
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE: backup apps')
            self.getIcons(apps)
        elif self.AppManagerChk[1].isChecked():
            self.MenuMode = 1
            apps = self.listApps()
            self.mainTableView(apps,['Packagename', 'Path'])
            self._tableView.model().setIcons(1)
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE: uninstall apps')
            self.getIcons(apps)
        elif self.AppManagerChk[2].isChecked():
            self.MenuMode = 2
            apps = self.listFreezeApps('e')
            self.mainTableView(apps,['Packagename', 'Path'])
            self._tableView.model().setIcons(1)
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE: freeze apps')
            self.getIcons(apps)
        elif self.AppManagerChk[3].isChecked():
            self.MenuMode = 3
            apps = self.listFreezeApps('d')
            self.mainTableView(apps,['Packagename', 'Path'])
            self._tableView.model().setIcons(1)
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE: unfreeze apps')
            self.getIcons(apps)
        elif self.AppManagerChk[4].isChecked():
            self.MenuMode = 4
            apps = self.listApps('data')
            self.mainTableView(apps,['Packagename', 'Path'])
            self._tableView.model().setIcons(1)
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE:convert to user app')
            self.getIcons(apps)
        elif self.AppManagerChk[5].isChecked():
            self.MenuMode = 5
            apps = self.listApps('system')
            self.mainTableView(apps,['Packagename', 'Path'])
            self._tableView.model().setIcons(1)
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE:convert to system app')
            self.getIcons(apps)
        elif self.AppManagerChk[6].isChecked():
            self.MenuMode = 6
            self.mainTableView(self.listMTD(),['Partition', 'Name'])
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self.lblStatusBar('MODE: backup partition')
        elif self.AppManagerChk[7].isChecked():
            self.MenuMode = 7
            self.ApkInstallPath = QFileDialog.getExistingDirectory(self, 'Select Directory')
            if self.ApkInstallPath == '': return
            header, data = self.parseApk(unicode(self.ApkInstallPath))
            self.mainTableView(data, header)
            self._tableView.model().setIcons(1)
            self._tableView.setVisible(False)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
            self.lblStatusBar('MODE: install apps')
            self.extractLogo(unicode(self.ApkInstallPath))
        elif self.AppManagerChk[8].isChecked():
            self.MenuMode = 8
            apps = self.listAppsFixed()
            self.mainTableView(apps,['Packagename', 'Path', 'UID', 'Rights'])
            self._tableView.model().setIcons(1)
            self._tableView.setVisible(False)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
            self.lblStatusBar('MODE: fix permissions')
            self.getIcons(apps)
        elif self.AppManagerChk[9].isChecked():
            self.MenuMode = 9
            apps = self.listZipaligned()
            self.mainTableView(apps,['Packagename', 'Path', 'ZipAligned'])
            self._tableView.model().setIcons(1)
            self._tableView.setVisible(False)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
            self.lblStatusBar('MODE: zipalign')
            self.getIcons(apps)            
        elif self.AppManagerChk[10].isChecked():
            self.MenuMode = 10
            self.ApkPath = QFileDialog.getExistingDirectory(self, 'Select Directory')
            if self.ApkPath == '': return
            header, data = self.parseApk(unicode(self.ApkPath))
            self.mainTableView(data, header)
            self._tableView.model().setIcons(1)
            self._tableView.setVisible(False)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
            self.lblStatusBar('MODE: rename')
            self.extractLogo(unicode(self.ApkPath))
        elif self.AppManagerChk[11].isChecked():
            self.MenuMode = 11
            tblData = [('WLAN',             '/data/misc/wifi/wpa_supplicant.conf'),
                       ('SMS',              '/data/data/com.android.providers.telephony/databases/mmssms.db'),
                       ('CONTACTS',         '/data/data/com.android.providers.contacts/databases/contacts2.db'),
                       ('USER-DICTIONARY',  '/data/data/com.android.providers.userdictionary/databases/user_dict.db'),
                       ('SYSTEM-SETTINGS',  '/data/data/com.android.providers.settings/databases/settings.db')]
            self.mainTableView(tblData,['Name', 'Path'])
            self._tableView.horizontalHeader().setStretchLastSection(True)
        else: return
# END: APP-MANAGER -----------------------------------------------------------------------

# BEGIN: EDIT-FILES ----------------------------------------------------------------------
    def PullFile(self, package):
        if not package: return
        if DBridge.Custom(adb,fastboot)._HasBusybox():
            prop = DBridge.Adb(adb)._shell('busybox realpath \"{0}\"'.format(package)).strip()
        else: pass
        if not ospath.isdir(TempDir):
            os.makedirs(TempDir)
        pkg = ospath.join(TempDir,ospath.basename(package))
        mtd = package.split('/')[1]
        DBridge.Custom(adb,fastboot)._remount(mtd)
        if DBridge.Custom(adb,fastboot)._HasPulled(prop, pkg):
            return True
        else:
            return False

    def PushFile(self, package):
        if not package: return
        if DBridge.Custom(adb,fastboot)._HasBusybox():
            prop = DBridge.Adb(adb)._shell('busybox realpath \"{0}\"'.format(package)).strip()
        else: pass
        if not ospath.isdir(TempDir):
            os.makedirs(TempDir)
        pkg = ospath.join(TempDir,ospath.basename(package))
        mtd = package.split('/')[1]
        if self.msgBox('Warning!','Upload the modified file?','warn'):
            DBridge.Custom(adb,fastboot)._remount(mtd)
            if DBridge.Custom(adb,fastboot)._HasPushed(pkg, prop):
                self.chmod_chown(prop)
                self.msgBoxDone()
                DBridge.logging.debug('Done')
            else:
                DBridge.logging.debug('Failed to push file to {}'.format(prop))
                ret = False
        else:
            return
        
    def slotbuildprop(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        self.PullFile('/system/build.prop')
        editor = MyEditor(ospath.join(TempDir,'build.prop'))
        self.hLayout.addWidget(editor)
        i=0
        while editor.actionRunning():
            if i==0: qApp.processEvents()
            sleep(0.002)
        self.PushFile('/system/build.prop')

    def slotpackagesxml(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        self.PullFile('/data/system/packages.xml')
        editor = MyEditor(ospath.join(TempDir,'packages.xml'))
        self.hLayout.addWidget(editor)
        i=0
        while editor.actionRunning():
            if i==0: qApp.processEvents()
            sleep(0.002)
        self.PushFile('/data/system/packages.xml')

    def slotpackageslist(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        self.PullFile('/data/system/packages.list')
        editor = MyEditor(ospath.join(TempDir,'packages.list'))
        self.hLayout.addWidget(editor)
        i=0
        while editor.actionRunning():
            if i==0: qApp.processEvents()
            sleep(0.002)
        self.PushFile('/data/system/packages.list')
# END: EDIT-FILES ------------------------------------------------------------------------

# BEGIN: SCRIPT-COLLECTION ---------------------------------------------------------------
    def slotcleanAndroid(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        QMessageBox().information(self, 'Clear Android', 'Please wait...')
        fnames = ['/cache/download','/data/anr','/data/tombstones','/data/system/usagestats','/data/system/dropbox','$EXTERNAL_STORAGE/DCIM/.thumbnails']
        fnames += self.listUselessDalvik()
        fnames += DBridge.Adb(adb)._shell('busybox find /data/data -type d -iname \'cache*\'').splitlines()
        fnames += DBridge.Adb(adb)._shell('busybox find \'$EXTERNAL_STORAGE/Android/data\' -type d -iname \'cache*\'').splitlines()
        cache_addedSize = 0
        text = ''
        fnames_new = []
        for i,name in enumerate(fnames):
            name = name.replace('(','\(').replace(')','\)')
            try:
                cache_size = DBridge.Adb(adb)._shell('busybox du -sh {0}'.format(unicode(name))).split()[0]
                if (cache_size in ['du:','2.0K','4.0K','8.0K']) or ('find:' in name):
                    continue
                text += '{0} {1}\n'.format(cache_size, unicode(name))
                cache_addedSize += float((self.ByteConvert(cache_size).replace('MB','')))
                fnames_new.append(name)
            except ValueError:
                continue
        fnames = fnames_new
        text += 'TOTAL: {0}MB'.format(str(cache_addedSize))
        if cache_addedSize == 0:
            QMessageBox().information(self, 'Clear Android', 'Nothing found!')
            return
        self.msgBoxInput('About', 'Found: {0}'.format(len(fnames)), text)
        if self.msgBox('Continue?','delete everything?','info'):
            try:
                self.pgwidget.plainTextEdit.clear()
                self.pgwidget.show()
                self.pgwidget.BtnClose.setEnabled(False)
                self.pgwidget.plainTextEdit.appendPlainText('Running...')
                qApp.processEvents()
                DBridge.Custom(adb,fastboot)._remount('data')
                if not DBridge.Custom(adb,fastboot)._HasBusybox():
                    self.msgBoxNoBusybox()
                    return
                self.pgwidget.pgBar.setMaximum(len(fnames))
                cache_addedSize = 0
                for i,name in enumerate(fnames):
                    if self.pgwidget.getKillProcVar():
                        self.pgwidget.setKillProcVar()
                        return
                    try:
                        cache_size = DBridge.Adb(adb)._shell('busybox du -sh {0}'.format(unicode(name))).split()[0]
                        if (cache_size in ['du:','2.0K','4.0K','8.0K']) or ('find:' in name):
                            i+=1
                            continue
                        self.pgwidget.plainTextEdit.appendPlainText('{0} {1}'.format(cache_size, unicode(name)))
                        qApp.processEvents()
                        if DBridge.Custom(adb,fastboot)._HasBusybox():
                            if 'Not a directory' in DBridge.Adb(adb)._shell('busybox rm -rf {0}/*'.format(unicode(name))):
                                DBridge.Adb(adb)._shell('busybox rm -f {0}'.format(unicode(name)))
                        else:
                            if 'Not a directory' in DBridge.Adb(adb)._shell('rm -r {0}/*'.format(unicode(name))):
                                DBridge.Adb(adb)._shell('rm {0}'.format(unicode(name)))
                        qApp.processEvents()
                        DBridge.logging.debug('Cleared: {0}'.format(name))
                        cache_addedSize += float((self.ByteConvert(cache_size).replace('MB','')))
                    except ValueError:
                        continue
                    self.pgwidget.pgBar.setValue(i+1)
                self.pgwidget.plainTextEdit.appendPlainText('CLEANED: {0}MB'.format(str(cache_addedSize)))
            finally:
                self.pgwidget.BtnClose.setEnabled(True)
            self.msgStatusBar('Cleared!')
        else:
            return

    def updateHosts(self):
        urls = ['https://adaway.org/hosts.txt',
                'http://winhelp2002.mvps.org/hosts.txt',
                'http://someonewhocares.org/hosts/zero/hosts',            
                'http://hosts-file.net/.%5Cad_servers.txt',
                'http://pgl.yoyo.org/adservers/serverlist.php?hostformat=hosts&showintro=1&mimetype=plaintext',
                'http://www.malwaredomainlist.com/hostslist/hosts.txt']
        text = ''        
        self.msgStatusBar('Downloading ad-blocking hosts files...')
        for url in urls:
            self.msgStatusBar('Current: {}'.format(url))
            try:
                text += urllib.urlopen(url).read()
            except IOError:
                continue
        self.msgStatusBar('Parsing, cleaning, de-duplicating, sorting...')
        text = re.sub(r'(?m)^.*\#.*\n?', '', text)
        text = re.sub(r'[0-9]+(?:\.[0-9]+){3}\s+', '0.0.0.0 ', text)
        text = re.sub(r'localhost', '0.0.0.0 ', text)
        text = re.sub(r'0.0.0.0 0.0.0.0', '0.0.0.0', text)
        text = '\n'.join(filter(None, sorted(list(set(text.splitlines())))))
        self.msgStatusBar('Write combined hosts file...')
        hosts = ospath.join(TempDir, 'hosts')
        with open(hosts,'w') as f:
            f.write(text)
        self.pgwidget.BtnClose.setEnabled(True)
        self.msgStatusBar('')
        
    def slotAdBlock(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        if not ospath.isdir(TempDir):
            os.makedirs(TempDir)
        hosts = ospath.join(TempDir,'hosts')
        if ospath.isfile(hosts):
            os.remove(hosts)
        self.updateHosts()
        stat_hosts = DBridge.Adb(adb)._shell('busybox stat -t /system/etc/hosts').split()[1]
        hostsSizeAndroid = 0
        if not 'No such file or directory' in stat_hosts:
            hostsSizeAndroid = round(float(stat_hosts)/1024, 2)
        if ospath.isfile(hosts):
            hostsSizeLocal = round(float(ospath.getsize(hosts))/1024, 2)
            msg = 'Download complete!\nContinue...\n\n'
            self.msgBox('Update hosts-file...', msg+'OLD: {}kB\nNEW: {}kB'.format(hostsSizeAndroid, hostsSizeLocal), info_warning='info')
##            if hostsSizeLocal > hostsSizeAndroid:
##                self.msgBox('Update hosts-file...', msg+'OLD: {}kB\nNEW: {}kB'.format(hostsSizeAndroid, hostsSizeLocal), info_warning='info')
##            elif hostsSizeLocal <= hostsSizeAndroid:
##                self.msgBox('Update hosts-file...', msg+'OLD: {}kB\nNEW: {}kB\n\nYou don\'t need to update the hosts-file!'
##                            .format(hostsSizeAndroid, hostsSizeLocal), info_warning='info')
##                return
            text = self.hostswidget.exec_()
            if text == '/system/etc/hosts':
                DBridge.Custom(adb, fastboot)._remount('system')
                DBridge.Adb(adb,'out')._push(hosts,text)
                self.chmod_chown('/system/etc/hosts','644','0.0')
            elif text == '/data/data/hosts':
                DBridge.Custom(adb, fastboot)._remount('data')
                DBridge.Custom(adb, fastboot)._remount('system')
                DBridge.Adb(adb,'out')._push(hosts,text)
                self.chmod_chown('/data/data/hosts','644','0.0')
                DBridge.Adb(adb,'cmd')._shell('rm /system/etc/hosts')
                DBridge.Adb(adb,'cmd')._shell('busybox ln -s /data/data/hosts /system/etc/hosts')
            else:
                return
            if 'hosts' in DBridge.Adb(adb,'cmd')._shell('ls {0}'.format(ospath.dirname(text))):
                msg = 'Install hosts-file to {}\n\nFinished!'.format(text)
            else:
                msg = 'Install hosts-file to {}\n\nFailed!'.format(text)
            QMessageBox().information(self, 'Install...', msg)              
        else:
            self.msgBoxFailed('Download failed!')
            return      
        
    def slotzipalign(self, PKGLINES=None, window=True):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not DBridge.Custom(adb,fastboot)._HasBusybox(): self.msgBoxNoBusybox(); return        
        if PKGLINES:
            pass
        else:
            PKGLINES = self.listApps()
        TOTAL = len(PKGLINES)
        self.pgwidget.pgBar.setMaximum(TOTAL)
        if not DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(ResDir,'zipalign'),'/data/local/'):
            print 'ERROR: could not copy zipalign to /data/local!'
            DBridge.logging.debug('ERROR: could not copy zipalign to /data/local!')
        self.chmod_chown('/data/local/zipalign','755','0.0')
        self.pgwidget.plainTextEdit.clear()
        if window: self.pgwidget.show()
        self.pgwidget.BtnClose.setEnabled(False)
        start = 'Zipaligning...'
        print start
        self.pgwidget.plainTextEdit.appendPlainText(start)
        qApp.processEvents()
        DBridge.logging.debug(start)
        DBridge.Adb(adb)._remount()

        for i,x in enumerate(PKGLINES):
            if self.pgwidget.getKillProcVar():
                self.pgwidget.setKillProcVar()
                return
            if len(x) == 2:
                PKGNAME, CODEPATH = x
            elif len(x) == 3:
                PKGNAME, CODEPATH, _ = x
            else:
                continue
            DBridge.Adb(adb)._shell('./data/local/zipalign -c 4 {0}'.format(CODEPATH))
            DBridge.Adb(adb)._shell('./data/local/zipalign -f 4 {0} /data/local/pkg.apk'.format(CODEPATH))
            DBridge.Adb(adb)._shell('busybox cp -f /data/local/pkg.apk {0}'.format(CODEPATH))
            DBridge.Adb(adb)._shell('busybox rm -f /data/local/pkg.apk')
            self.pgwidget.plainTextEdit.appendPlainText(unicode('({0} of {1}) zipaligned {2}'.format(i+1,TOTAL,PKGNAME)))
            qApp.processEvents()
            print '({0} of {1}) zipaligned {2}'.format(i+1,TOTAL,PKGNAME)
            DBridge.logging.debug('({0} of {1}) [!] zipaligned {2}'.format(i+1,TOTAL,PKGNAME))
            self.pgwidget.pgBar.setValue(i+1)
        DBridge.Adb(adb)._sync()

        complete = 'Zipalign complete!'
        DBridge.logging.debug(complete)
        self.msgStatusBar(complete)
        self.pgwidget.plainTextEdit.appendPlainText(complete)
        self.pgwidget.BtnClose.setEnabled(True)

    def slotFixPermissions(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not self.msgBox('Fix'): return
        self.slotpermission()

    def slotpermission(self, PKGLINES=None, window=True):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if not DBridge.Custom(adb,fastboot)._HasBusybox(): self.msgBoxNoBusybox(); return
        if PKGLINES:
            pass
        else:
            PKGLINES = self.listApps()
        self.pgwidget.BtnClose.setEnabled(False)
        self.pgwidget.plainTextEdit.clear()
        if window: self.pgwidget.show()
        TOTAL = len(PKGLINES)
        self.pgwidget.pgBar.setMaximum(TOTAL)

        outText = 'Fixing permissions...'
        self.pgwidget.plainTextEdit.appendPlainText(outText)
        qApp.processEvents()
        print outText
        DBridge.logging.debug(outText)
        DBridge.Adb(adb)._remount()
        for i,x in enumerate(PKGLINES):
            if self.pgwidget.getKillProcVar():
                self.pgwidget.setKillProcVar()
                return
            if len(x) == 2:
                PKGNAME, CODEPATH = x
            elif len(x) == 4:
                PKGNAME, CODEPATH, _, _ = x
            else:
                continue
            DATAPATH = '/data/data/{0}'.format(PKGNAME)
            PKGGID = PKGUID = re.findall('.*?serId=\"(.*?)\"',DBridge.Adb(adb)._shell('busybox grep {0} /data/system/packages.xml'.format(CODEPATH)))[0]
            self.pgwidget.plainTextEdit.appendPlainText('{0} ({1}, {2})'.format(CODEPATH,PKGNAME,PKGUID))
            print '{0} ({1}, {2})'.format(CODEPATH,PKGNAME,PKGUID)
            APPDIR = DBridge.Adb(adb)._shell('busybox dirname {0}'.format(DATAPATH))
            if APPDIR == '/system/app':
                DBridge.Adb(adb)._shell('busybox chown 0 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('busybox chown :0 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('busybox chmod 644 {0}'.format(CODEPATH))
            elif APPDIR == '/data/app':
                DBridge.Adb(adb)._shell('busybox chown 1000 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('busybox chown :1000 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('busybox chmod 644 {0}'.format(CODEPATH))
            elif APPDIR == '/data/app-private':
                DBridge.Adb(adb)._shell('busybox chown 1000 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('busybox chown :{0} {1}'.format(PKGUID,CODEPATH))
                DBridge.Adb(adb)._shell('busybox chmod 640 {0}'.format(CODEPATH))

            DBridge.Adb(adb)._shell('busybox chmod 755 {0}'.format(DATAPATH))
            DBridge.Adb(adb)._shell('busybox chown -R {0} {1}'.format(PKGUID,DATAPATH))
            DBridge.Adb(adb)._shell('busybox chown -R :{0} {1}'.format(PKGUID,DATAPATH))
            DBridge.Adb(adb)._shell('busybox chown {0} {1}'.format(PKGUID,CODEPATH))
            DBridge.Adb(adb)._shell('busybox chown :{0} {1}'.format(PKGUID,CODEPATH))

            DIRS = DBridge.Adb(adb)._shell('busybox find {0} -mindepth 1 -type d'.format(DATAPATH)).splitlines()
            for f in DIRS:
                PERM=755
                FNAME=DBridge.Adb(adb)._shell('busybox basename {0}'.format(f)).splitlines()
                if 'lib' in FNAME:
                    DBridge.Adb(adb)._shell('busybox chmod 755 {0}'.format(f))
                    PKGUID=1000
                    PKGGID=1000
                    PERM=755
                elif 'shared_prefs' in FNAME:
                    DBridge.Adb(adb)._shell('busybox chmod 771 {0}'.format(f))
                    PERM=660
                elif 'databases' in FNAME:
                    DBridge.Adb(adb)._shell('busybox chmod 771 {0}'.format(f))
                    PERM=660
                elif 'cache' in FNAME:
                    DBridge.Adb(adb)._shell('busybox chmod 771 {0}'.format(f))
                    PERM=600
                else:
                    DBridge.Adb(adb)._shell('busybox chmod 771 {0}'.format(f))
                    PERM=771

                DBridge.Adb(adb)._shell('busybox chown {0} {1}'.format(PKGUID,f))
                DBridge.Adb(adb)._shell('busybox chown :{0} {1}'.format(PKGGID,f))
                DBridge.Adb(adb)._shell('busybox find {0} -type f -maxdepth 1 ! -perm {1} -exec busybox chmod {1} {2} \';\''.format(f,PERM,'{}'))
                DBridge.Adb(adb)._shell('busybox find {0} -type f -maxdepth 1 ! -user {1} -exec busybox chown {1} {2} \';\''.format(f,PKGUID,'{}'))
                DBridge.Adb(adb)._shell('busybox find {0} -type f -maxdepth 1 ! -group {1} -exec busybox chown :{1} {2} \';\''.format(f,PKGGID,'{}'))
            self.pgwidget.plainTextEdit.appendPlainText(unicode('({0} of {1}) fixed {2}'.format(i+1,TOTAL,PKGNAME)))
            self.pgwidget.pgBar.setValue(i+1)
        DBridge.Adb(adb)._sync()

        outText = 'Fix permissions complete!'
        self.pgwidget.BtnClose.setEnabled(True)
        self.pgwidget.plainTextEdit.appendPlainText(outText)
        qApp.processEvents()
        print outText
        DBridge.logging.debug(outText)
        self.msgStatusBar(outText)

    def slotscreenshot(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
##        device_file = '/data/local/fbdump.png'
##        host_file = ospath.join(ScreenshotDir, 'screenshot-{1}.png'.format(strftime('%H%M%S', gmtime())))
##        if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(ResDir, 'fb2png'),'/data/local/'):
##            self.chmod_chown('/data/local/fb2png','755')
##            DBridge.Adb(adb)._shell('/data/local/fb2png /data/local/fbdump.png')
##            
##            if not ospath.isdir(ScreenshotDir):
##                os.makedirs(ScreenshotDir)
##            DBridge.Custom(adb,fastboot)._HasPulled(device_file, host_file)
        host_file = ospath.join(ScreenshotDir, 'screenshot-{0}.png'.format(strftime('%H%M%S', gmtime())))
        print host_file
        if not ospath.isdir(ScreenshotDir):
            os.makedirs(ScreenshotDir)            
        DBridge.Adb(adb,'cmd')._shell('screencap -p | perl -pe \"s\/\\x0D\\x0A\/\\x0A\/g\" > \"{0}\"'.format(host_file))
        #self.msgBoxDone()

    def slotFlashSplash(self):
        if not DBridge.Custom(adb, fastboot).checkForDevice(): return
        self.clearLayout()
        if self.msgBox('Flash splash-screen'):        
            if DBridge.Custom(adb, fastboot)._rwStatus('system') == 'ro':
                DBridge.Custom(adb, fastboot)._remount('system')
            # PUSH load_oemlogo/oemlogo.mbn
            if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(BootsplashDir,'load_oemlogo'), '/system/bin/load_oemlogo'):
                self.chmod_chown('/system/bin/load_oemlogo','0755','0.0')
            if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(BootsplashDir,'oemlogo.mbn'), '/system/media/oemlogo.mbn'):
                self.chmod_chown('/system/media/oemlogo.mbn','0755','0.0')
            # EXEC load_oemlogo
            DBridge.Adb(adb,'cmd')._shell('/system/bin/load_oemlogo')
            self.msgBoxDone()
        else: return         

    def slotchangeMAC(self):
        if not DBridge.Custom(adb, fastboot).checkForDevice(): return
        self.clearLayout()
        oldMAC,newMAC,macPath = '','',''
        if DBridge.Custom(adb,fastboot)._HasBusybox():
            macs = ['/system/wifi/nvram.txt','/custpack/JRD_custres/wlan/nvram.txt']
            for mac in macs:
                out = DBridge.Adb(adb)._shell('\"cat {} | busybox grep macaddr\"'.format(mac))
                if (not 'No such file or directory' in oldMAC) and not macPath:
                    oldMAC = out; macPath = mac
        else:
            self.msgBoxNoBusybox()
            return
        if 'No such file or directory' in oldMAC:
            QMessageBox().information(self,'','No such file or directory\n\n({})'.format(macPath))
            return
        oldMAC = oldMAC.split('=')[1]
        text, ok = QInputDialog.getText(self, 'Change MAC Adress', oldMAC, QLineEdit().Normal, oldMAC)
        if ok:
            newMAC = str(text)
        else:
            return
        DBridge.Adb(adb)._shell('\"busybox cp {0} {0}.bak\"'.format(macPath))
        DBridge.Adb(adb)._shell('\"busybox sed -i \'s/{0}/{1}/g\' {2}\"'.format(oldMAC,newMAC,macPath))
        self.msgBoxDone()

    def slotrootdevice(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        if self.msgBox('Try to root your Android-Phone'):
            if ('0' or 'root') in DBridge.Adb(adb,'out')._shell('id'):
                DBridge.Adb(adb)._remount()
                ## SU
                if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(RootDir,'su'),'/system/xbin/su'):
                    self.chmod_chown('/system/xbin/su','6755','0.0')
                    DBridge.Adb(adb,'out')._shell('cd /system/bin; ln -s /system/xbin/su su')
                else:
                    DBridge.logging.debug('Failed to copy \'su\' to \'/system/xbin\'')
                ## BUSYBOX
                if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(RootDir,'busybox'),'/system/xbin/busybox'):
                    self.chmod_chown('/system/xbin/busybox','6755','0.0')
                else:
                    DBridge.logging.debug('Failed to copy \'busybox\' to \'/system/xbin\'')
                ## SUPERUSER
                if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(RootDir,'Superuser.apk'),'/system/app/.'):
                    self.chmod_chown('/system/app/Superuser.apk','644','0.0')
                else:
                    DBridge.logging.debug('Failed to copy \'Superuser.apk\' to \'/system/app\'')
                self.msgBoxDone()
            else:
                DBridge.logging.debug('uid should be \'0\' or \'root\'')
                return
        else:
            return

    def slotinstallZipalign(self):
        def chkBin():
            fnames = ['/system/bin','/system/xbin']
            fnames_new = []
            for i,name in enumerate(fnames):
                fnames_new += DBridge.Adb(adb)._shell('busybox find {0} -type f -iname \'zipalign\''.format(name)).splitlines()
            return bool(filter(lambda x: 'zipalign' in x, fnames_new))
        def chkScript():
            fnames = DBridge.Adb(adb)._shell('busybox find /system/etc/init.d/ -type f -iname \'*zipalign*\'').splitlines()
            return bool(filter(lambda x: 'zipalign' in x, fnames))        
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        if self.msgBox('Install zipalign-script to init.d?'):
            if chkBin() and chkScript():
                self.msgBoxDone('Already installed!')
                return
            else:
                if chkBin():
                    DBridge.Custom(adb,fastboot)._remount('system')
                    if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(ResDir,'99-zipalign'),'/system/etc/init.d/'):
                        self.chmod_chown('/system/etc/init.d/99-zipalign','755','0.0')
                        self.msgBoxDone()
                    else:
                        DBridge.Adb(adb)._push(ospath.join(ResDir, '99-zipalign'),'/data/local/tmp')
                        DBridge.Adb(adb)._shell('su -c "cp /data/local/tmp/99-zipalign /system/etc/init.d/"')
                        self.chmod_chown('/system/etc/init.d/99-zipalign','755','0.0')                    
                    if not chkScript():
                        DBridge.logging.debug('Failed to copy \'99-zipalign\' to \'/system/etc/init.d/\'')
                else:
                    DBridge.Custom(adb,fastboot)._remount('system')
                    if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(ResDir,'zipalign'),'/system/xbin/'):
                        self.chmod_chown('/system/xbin/zipalign','755','0.0')
                    else:
                        DBridge.Adb(adb)._push(ospath.join(ResDir, 'zipalign'),'/data/local/tmp')
                        DBridge.Adb(adb)._shell('su -c "cp /data/local/tmp/zipalign /system/xbin/"')
                        self.chmod_chown('/system/xbin/zipalign','755','0.0')
                    if not chkBin():
                        DBridge.logging.debug('Failed to copy \'zipalign\' to \'/system/xbin/\'')
                    else:
                        if DBridge.Custom(adb,fastboot)._HasPushed(ospath.join(ResDir,'99-zipalign'),'/system/etc/init.d/'):
                            self.chmod_chown('/system/etc/init.d/99-zipalign','755','0.0')
                        else:
                            DBridge.logging.debug('Failed to copy \'99-zipalign\' to \'/system/etc/init.d/\'')
                        self.msgBoxDone()
            return
        else:
            return
                

    def slotbattery(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        if self.msgBox('Wipe battery-stats'):
            DBridge.Custom(adb,fastboot)._remount('data')
            if DBridge.Custom(adb,fastboot)._HasBusybox():
                DBridge.Adb(adb,'cmd')._shell('busybox rm -f /data/system/batterystats.bin')
            else:
                DBridge.Adb(adb,'cmd')._shell('rm /data/system/batterystats.bin')
            if self.msgBox('Warning!','Do you want to reboot your device?','warn'): self.adbReboot()
            self.msgBoxDone('Cleared')
        else: return

    def slotdalvik(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        self.clearLayout()
        if self.msgBox('Wipe dalvik-cache'):
            self.pgwidget.plainTextEdit.clear()
            self.pgwidget.show()
            self.pgwidget.BtnClose.setEnabled(False)
            self.pgwidget.plainTextEdit.appendPlainText('Running...')
            DBridge.Custom(adb,fastboot)._remount('data')
            fnames = []
            if not DBridge.Custom(adb,fastboot)._HasBusybox():
                self.msgBoxNoBusybox()
                return
            fnames = DBridge.Adb(adb)._shell('busybox find /data/dalvik-cache -type f -iname \'*.dex\'').splitlines()
            self.pgwidget.pgBar.setMaximum(len(fnames))
            try:
                for i,name in enumerate(fnames):
                    if self.pgwidget.getKillProcVar():
                        self.pgwidget.setKillProcVar()
                        return
                    self.pgwidget.plainTextEdit.appendPlainText(unicode(name))
                    if DBridge.Custom(adb,fastboot)._HasBusybox():
                        DBridge.Adb(adb)._shell('busybox rm -f {0}/*'.format(unicode(name)))
                    else:
                        DBridge.Adb(adb)._shell('rm {0}/*'.format(unicode(name)))
                    qApp.processEvents()
                    DBridge.logging.debug('Cleared: {0}'.format(name))
                    self.pgwidget.pgBar.setValue(i+1)
            finally:
                self.pgwidget.BtnClose.setEnabled(True)
            if self.msgBox('Warning!','Do you want to reboot your device?','warn'): self.adbReboot()
            self.msgStatusBar('Cleared!')
            qApp.processEvents()
        else: return
# END: SCRIPT-COLLECTION -----------------------------------------------------------------

# BEGIN: STORAGE-INFO --------------------------------------------------------------------
    def slotINFO(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice():
            self.clearChkBoxes()
            return
        if self.deviceINFO.isChecked():
            self.clearChkBoxes(self.deviceINFO)
        else:
            self.clearChkBoxes()
            return
        self.myDeviceInfo = MyDeviceInfo()
        self.hLayout.addWidget(self.myDeviceInfo)
        self.myDeviceInfo.chkBox.stateChanged.connect(self.InfoChkBox)
        self.fill_INFO()

    def InfoChkBox(self):
        if self.myDeviceInfo.chkBox.isChecked():
            self.timer2.start(5000)
        else:
            self.timer2.stop()

    def fill_INFO(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice():
            return
        print 'update screen!'
        def getSize(name):
            busybox = DBridge.Custom(adb,fastboot)._HasBusybox()
            head = ['Filesystem','Size','Used','Free','%Used']
            fallback = [' ','0 K','0 K','0 K','0']
            if busybox:
                text = DBridge.Adb(adb)._shell('busybox df \'{0}\''.format(name))
            else:
                text = DBridge.Adb(adb)._shell('df \'{0}\''.format(name))
            if 'can\'t find' in text or 'No such file or directory' in text:
                text = fallback
            else:
                text = text.splitlines()
            for x in xrange(len(text)):
                text[x] = text[x].replace(' %','').replace('%','')
            if len(text) > 2:
                text = (text[1]+text[2]).split()
            elif len(text) == 2:
                text = text[1].split()
            elif len(text) <= 1:
                text = fallback
            try:
                if busybox:
                    filesystem = text[-1]
                else:
                    filesystem = text[0]
                size = self.ByteConvert(text[1])
                used = self.ByteConvert(text[2])
                free = self.ByteConvert(text[3])
                used_perc = int((float(used.split()[0])/float(size.split()[0]))*100)
                text = [filesystem,size,used,free,used_perc]
            except:
                text = fallback
            return zip(head,text)
        d = self.myDeviceInfo
        props = dict(self.listPROP())
        try:
            serialno = props['ro.serialno']
            if not serialno or serialno == ' ':
                serialno = DBridge.Adb(adb)._serial()
            d.editSerial.setText(serialno)
        except KeyError:
            d.editSerial.setText('')
        try: d.editModel.setText(props['ro.product.model'])
        except KeyError: d.editModel.setText('')
        try: d.editDevice.setText(props['ro.product.device'])
        except KeyError: d.editDevice.setText('')
        try: d.editBrand.setText(props['ro.product.brand'])
        except KeyError: d.editBrand.setText('')
        try: d.editManufacturer.setText(props['ro.product.manufacturer'])
        except KeyError: d.editManufacturer.setText('')
        try: d.editBaseband.setText(props['gsm.version.baseband'])
        except KeyError: d.editBaseband.setText('')
        try: d.editBootloader.setText(props['ro.bootloader'])
        except KeyError: d.editBootloader.setText('')
        try: d.editModVer.setText(props['ro.modversion'])
        except KeyError: d.editModVer.setText('')
        try: d.editRelease.setText('{0}, {1}'.format(props['ro.build.version.release'],
                                                     props['ro.build.version.incremental']))
        except KeyError: d.editRelease.setText('')
        try: d.editBuild.setText(props['ro.build.product'])
        except KeyError: d.editBuild.setText('')
        try: d.editOperator.setText('{0}, {1}'.format(props['gsm.operator.alpha'],
                                                      props['gsm.sim.operator.alpha']))
        except KeyError: d.editOperator.setText('')

        #d.editRoot.setText(str(DBridge.Custom(adb,fastboot)._HasRootAccess()))
        d.editRoot.setText(str(DBridge.Adb(adb)._shell('id').strip()))
        d.editBusybox.setText(str(DBridge.Custom(adb,fastboot)._GetBusyboxVersion()))

        sizesDATA = dict(getSize(ANDROID_DATA()))
        d.pgBarDATA.setValue(int(sizesDATA['%Used']))
        d.totalDATA.setText(sizesDATA['Size'])
        d.freeDATA.setText(sizesDATA['Free'])
        d.usedDATA.setText(sizesDATA['Used'])

        sizesSYSTEM = dict(getSize(ANDROID_ROOT()))
        d.pgBarSYSTEM.setValue(int(sizesSYSTEM['%Used']))
        d.totalSYSTEM.setText(sizesSYSTEM['Size'])
        d.freeSYSTEM.setText(sizesSYSTEM['Free'])
        d.usedSYSTEM.setText(sizesSYSTEM['Used'])

        sizesSDCARD = dict(getSize(EXTERNAL_STORAGE()))
        d.pgBarSDCARD.setValue(int(sizesSDCARD['%Used']))
        d.totalSDCARD.setText(sizesSDCARD['Size'])
        d.freeSDCARD.setText(sizesSDCARD['Free'])
        d.usedSDCARD.setText(sizesSDCARD['Used'])

        sizesSDEXT = dict(getSize(SD_EXT_DIRECTORY()))
        d.pgBarSDEXT.setValue(int(sizesSDEXT['%Used']))
        d.totalSDEXT.setText(sizesSDEXT['Size'])
        d.freeSDEXT.setText(sizesSDEXT['Free'])
        d.usedSDEXT.setText(sizesSDEXT['Used'])
# END: STORAGE-INFO ----------------------------------------------------------------------

# BEGIN: PROC-INFO -----------------------------------------------------------------------
    def slotProcInfos(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice():
            self.clearChkBoxes()
            return
        if self.procInfos.isChecked():
            self.clearChkBoxes(self.procInfos)
        else:
            self.clearChkBoxes()
            return
        self.procInfosChk = ['filesystem','mounts','partitions','cmdline']
        for i in xrange(len(self.procInfosChk)):
            self.procInfosChk[i] = QRadioButton(self.procInfosChk[i])
            self.btnLayout.addWidget(self.procInfosChk[i])
            self.procInfosChk[i].clicked.connect(self.procInfosChkBoxChanged)
        self.vLayout.addLayout(self.btnLayout)
        self.vLayout.addStretch(1)
        self.hLayout.addLayout(self.vLayout)
        self.hLayout.addWidget(self._textEdit)

    def procInfosChkBoxChanged(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice(): return
        if self.procInfosChk[0].isChecked():
            self._textEdit.setParent(None)
            self.hLayout.addWidget(self._tableView)
            out = []
            l = [line.strip().split() for line in DBridge.Adb(adb)._shell('df').splitlines()]
            for i in xrange(len(l)):
                if len(l[i]) == 7:
                    out.append(l[i][:-2]+[l[i][-2]+' '+l[i][-1]])
                elif len(l[i]) == 1:
                    out.append(l[i]+l[i+1])
                elif len(l[i]) == 5:
                    continue
                else:
                    out.append(l[i])
            self.mainTableView(out[1:],out[0])
            self._tableView.setVisible(False)
            self._tableView.horizontalHeader().setResizeMode(0, QHeaderView.Stretch)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
        elif self.procInfosChk[1].isChecked():
            self._textEdit.setParent(None)
            self.hLayout.addWidget(self._tableView)
            out = [line.split(' ') for line in DBridge.Adb(adb)._shell('cat /proc/mounts').splitlines()]
            self.mainTableView(out,['device','mount-point','file-system type','read/write','dummy','dummy'])
            self._tableView.setVisible(False)
            self._tableView.horizontalHeader().setResizeMode(0, QHeaderView.Stretch)
            self._tableView.resizeColumnsToContents()
            self._tableView.setVisible(True)
        elif self.procInfosChk[2].isChecked():
            self._textEdit.setParent(None)
            self.hLayout.addWidget(self._tableView)
            mounts = []
            for line in DBridge.Adb(adb)._shell('cat /proc/mtd').splitlines()[1:]:
                lineSplit = line.split()
                mounts.append([lineSplit[0].replace('mtd','mtdblock').replace(':',''),lineSplit[3],lineSplit[1],lineSplit[2]])
            partitions = []
            for line in DBridge.Adb(adb)._shell('cat /proc/partitions').splitlines():
                lineSplit = line.split()
                for item in mounts:
                    if lineSplit[-1] in item[0]:
                        partitions.append([lineSplit[2]])
            out = []
            for i in xrange(5):
                out.append(mounts[i]+partitions[i])
            self.mainTableView(out,['device','name','size','erasesize','blocks'])
            self._tableView.setVisible(False)
            self._tableView.resizeColumnsToContents()
            self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)
            self._tableView.setVisible(True)
        elif self.procInfosChk[3].isChecked():
            self._tableView.setParent(None)
            self.hLayout.addWidget(self._textEdit)
            self._textEdit.clear()
            self._textEdit.setPlainText(DBridge.Adb(adb)._shell('cat /proc/cmdline'))
        else: return
# END: PROC-INFO -------------------------------------------------------------------------

    def slotgetProps(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice():
            self.clearChkBoxes()
            return
        if self.getProps.isChecked():
            self.clearChkBoxes(self.getProps)
        else:
            self.clearChkBoxes()
            return
        self.hLayout.addWidget(self._tableView)
        self._tableView.setEditTriggers(QAbstractItemView.NoEditTriggers)
        self.mainTableView(self.listPROP(),['Entry', 'Value'])
        self._tableView.horizontalHeader().setResizeMode(QHeaderView.Stretch)


# BEGIN: LOGCAT --------------------------------------------------------------------------
    def slotlogcat(self):
        if not DBridge.Custom(adb,fastboot).checkForDevice():
            self.clearChkBoxes()
            return
        if self.log.isChecked():
            self.clearChkBoxes(self.log)
        else:
            self.clearChkBoxes()
            return
        self.btnStop = QPushButton('Start')
        self.btnStop.setCheckable(True)
        self.logChk = ['ALL','(V)erbose','(D)ebug','(I)nfo','(W)arn','(E)error']
        for i in xrange(len(self.logChk)):
            self.logChk[i] = QRadioButton(self.logChk[i])
            self.btnLayout.addWidget(self.logChk[i])
            self.logChk[i].clicked.connect(self.CheckBoxChanged)
        self.btnLayout.addWidget(self.btnStop)
        self.btnStop.clicked.connect(self.slotbtnStop)
        self.vLayout.addLayout(self.btnLayout)
        self.vLayout.addStretch(1)
        self.hLayout.addLayout(self.vLayout)
        self.hLayout.addWidget(self._textEdit)
        self._textEdit.clear()

    def slotbtnStop(self):
        if self.btnStop.text() == 'Stop':
            self.qprocess.kill()
            self.btnStop.setChecked(False)
            self.btnStop.setText('Start')
        else:
            cmd = self.CheckBoxChanged()
            if not cmd: return
            self._textEdit.clear()
            self.btnStop.setText('Stop')
            self.btnStop.setChecked(True)
            self.qProc(cmd)

    def CheckBoxChanged(self):
        tag = ["","'V/'","'D/'","'I/'","'W/'","'E/'"]
        if OS == 'lin':
            cmd = '{0} logcat | grep '.format(adb)
        elif OS == 'win':
            cmd = '{0} logcat | find '.format(adb)
        else:
            return
        if self.logChk[0].isChecked():
            return '{0} logcat'.format(adb)
        else:
            for i in xrange(len(self.logChk)):
                if i == 0: continue
                if self.logChk[i].isChecked():
                    return cmd+tag[i]

    def qProc(self, cmd):
        self.qprocess.setProcessChannelMode(QProcess.MergedChannels)
        if OS == 'lin':
            cmd = unicode(cmd)
        self.qprocess.start(cmd)
        self.qprocess.waitForStarted()
        while (self.qprocess.state() == QProcess.Running):
            qApp.processEvents()
            sleep(0.002)

    def readFromProcess(self):
        hList = [("V/",Qt.black),("D/",Qt.darkBlue),("I/",Qt.darkGreen),("W/",Qt.darkMagenta),("E/",Qt.darkRed)]
        #highlightSyntax(hList, self._textEdit)
        self._textEdit.insertPlainText(str(self.qprocess.readAll()))
        self._textEdit.moveCursor(QTextCursor.End)
# END: LOGCAT ----------------------------------------------------------------------------

# BEGIN: DOWNLOAD & FLASH ----------------------------------------------------------------
    def proceedFlashing(self, fileName, default=True):
        if ospath.isfile(ospath.join(DownloadDir,fileName)):
            DBridge.logging.debug(fileName)
            self.msgStatusBar('Download: Done')
            if not DBridge.Custom(adb,fastboot).checkForDevice():
                self.msgBoxFailed('Cannot continue: no device found!')
                return
            if self.msgBox('Warning!','Do you want to flash the file?','warn'):
                self.msgStatusBar('reboot into bootloader')
                self.adbBootloader()
                self.msgStatusBar('Flashing file...')
                if default:
                    self.fastbootflashKernel(ospath.join(DownloadDir,fileName))
                else:
                    self.fastbootflashRecovery(ospath.join(DownloadDir,fileName))
                self.msgStatusBar('reboot device')
                self.fastbootReboot()
                self.msgStatusBar('Flashing complete!')
                self.msgBoxDone()
            else: pass
        else: self.msgBoxFailed('Download: Failed'); return
        
    def slotStockRecov(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # 'recovery-2.3.5.img'
        self.runMegaDL('https://mega.co.nz/#!45sSgIQQ!Lup3JC0x4kz3TMKZ825TUD1Zu41o11TEl_uop5SWoXo')
        self.proceedFlashing('recovery-2.3.5.img', False)

    def slotcwm5touch(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # cwm-5027-touch.img
        self.runMegaDL('https://mega.co.nz/#!NxMTEQYD!EttGzQBnmG_WZPRKSD-s5ykx0jgRZ8BwxTT1j0HOIMY')
        self.proceedFlashing('cwm-5027-touch.img', False)

    def slotcwm6(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # cwm-6010.img
        # mod: https://mega.co.nz/#!YoNzkLqB!GyG3-iQq8TjZOxZofhFlw0DIHbRey3o68AzNaS9N4G8
        # normal: https://mega.co.nz/#!Rssk0ZaZ!ZsYKZzbtIIhg79A66cvek3N4AHIy1kcENXvr9IUntqY
        self.runMegaDL('https://mega.co.nz/#!Rssk0ZaZ!ZsYKZzbtIIhg79A66cvek3N4AHIy1kcENXvr9IUntqY')
        self.proceedFlashing('cwm-6010.img', False)

    def slotcwm6wcharge(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # cwm-6010-with-charge.img
        self.runMegaDL('https://mega.co.nz/#!F1FE2KKa!UPtkoj6-TJhxbJxJtUEnsC2R8glHCvy_dro0wLu0a7M')
        self.proceedFlashing('cwm-6010-with-charge.img', False)

    def slotk235(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # boot-2.3.5.img
        self.runMegaDL('https://mega.co.nz/#!9kkmXAyR!GF_BhDiRwerCKeQu0IBJiwlRHmkpPDvb6TNXvdYSX14')
        self.proceedFlashing('boot-2.3.5.img', True)

    def slotk236(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # boot-oc-init-unsecure-2.3.6.img
        self.runMegaDL('https://mega.co.nz/#!18FTjZYC!LiSu0jhBr_vgUzZPApZ2cRiaing8RTTcw9SfUCfxnIA')
        self.proceedFlashing('boot-oc-init-unsecure-2.3.6.img', True)

    def slotkluckyStock(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # boot-lucky-stock.img
        self.runMegaDL('https://mega.co.nz/#!R4sGzDAC!RVi3lRz8zDTmYzF-Le7iXkbly6QCN1BSn6L9r2x-rJI')
        self.proceedFlashing('boot-lucky-stock.img', True)

    def slotkluckyCM(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # boot-lucky-cm.img
        self.runMegaDL('https://mega.co.nz/#!sxdA1LIR!D_Tq01mh8Srb9JVLxxlS4jJR4BYrjlM9yYGMuO1VaFE')
        self.proceedFlashing('boot-lucky-cm.img', True)

    def slotktoastCM(self):
        self.clearLayout()
        self.msgStatusBar('Downloading...')
        # selftoasted-oc-kernel-boot-844.img
        self.runMegaDL('https://mega.co.nz/#!w10xzbQR!ZeAiAGgJxfnbj0MDP7gJsTuciehZz0LtsEuTLiQW7Qg')
        self.proceedFlashing('selftoasted-oc-kernel-boot-844.img', True)


    def flashAnimation(self, fname, default=True):
        if not fname: return False
        # STOCK ANDROID        
        if default:
            if DBridge.Custom(adb, fastboot)._rwStatus('cust') == 'ro':
                DBridge.Custom(adb, fastboot)._remount('cust')
            if DBridge.Custom(adb,fastboot)._HasPushed(fname, '/cust/o2/de/media/bootanimation.zip'):
                self.chmod_chown('/cust/o2/de/media/bootanimation.zip','0644','0.0')
            else:
                DBridge.logging.debug('Failed to copy \'{0}\' to \'/cust/o2/de/media/\''.format(fname))
                return False
        else:
            if DBridge.Custom(adb, fastboot)._rwStatus('system') == 'ro':
                DBridge.Custom(adb, fastboot)._remount('system')
        # CYANOGENMOD
            if DBridge.Custom(adb,fastboot)._HasPushed(fname, '/system/media/bootanimation.zip'):
                self.chmod_chown('/system/media/bootanimation.zip','0644','0.0')
            else:
                DBridge.logging.debug('Failed to copy \'{0}\' to \'/system/media/\''.format(fname))
                return False
        return True
    
    def slotFlashAnimStock(self):
        fname = QFileDialog.getOpenFileName(self, 'Open File', \
                                            'Open animation file', \
                                            self.tr('Animation animation (*.zip)'))
        if not fname.isEmpty():
            if not DBridge.Custom(adb, fastboot).checkForDevice():
                self.msgBoxFailed('Cannot continue: no device found!')
                return
            if self.msgBox('Flash animation-screen (Stock-ROM)'):
                if self.flashAnimation(fname, True):
                    self.msgBoxDone()
                else:
                    self.msgBoxFailed()
            else: pass
        else: return

    def slotFlashAnimCM(self):
        fname = QFileDialog.getOpenFileName(self, 'Open File', \
                                            'Open animation file', \
                                            self.tr('Animation Files (*.zip)'))
        if not fname.isEmpty():
            if not DBridge.Custom(adb, fastboot).checkForDevice():
                self.msgBoxFailed('Cannot continue: no device found!')
                return
            if self.msgBox('Flash animation-screen (CM-ROM)'):
                if self.flashAnimation(fname, False):
                    self.msgBoxDone()
                else:
                    self.msgBoxFailed()
            else: pass
        else: return 
# END: DOWNLOAD & FLASH ------------------------------------------------------------------
    
    def slotHowtoADBSetup(self):
        webbrowser.open_new_tab(r'http://processors.wiki.ti.com/index.php/Android_ADB_Setup')

    def slotUpdateApp(self):
        url = 'http://www.android-hilfe.de/root-hacking-modding-fuer-huawei-ideos-x3/238249-tool-yaix3t-yet-another-ideos-x3-toolkit.html'
        try:
            data = urllib.urlopen(url).read()
        except Exception, e:
            QMessageBox().information(self,'Check for Update',str(e))
            return
        version_re = re.findall(r'Download PyX3.+(\d{8}).tar.[gz|bz2]', data)
        downloadLink_re = re.findall(r'.*<a href=\"https://mega.co.nz/#(.+)\" target=\"_blank\">Download PyX3', data)
        ##if downloadLink_re:
        ##    md5hash_re = re.findall(r'MD5\s+:(.*?)<br.*>\s+<a href=\"https://mega.co.nz/#{0}\" target=\"_blank\">Download PyX3'.format(downloadLink_re[0]), data)
        if version_re:
            if (len(version_re) == 1):
                version = version_re[0]
            elif (len(version_re) == 2):
                version = version_re[1]
            elif (len(version_re) == 3):
                version = version_re[2]
        if downloadLink_re:
            if (len(downloadLink_re) == 1):
                downloadLink = 'https://mega.co.nz/#'+downloadLink_re[0]
            elif (len(downloadLink_re) == 2):
                downloadLink = 'https://mega.co.nz/#'+downloadLink_re[1]
            elif (len(downloadLink_re) == 3):
                downloadLink = 'https://mega.co.nz/#'+downloadLink_re[2]
        if float(version) > float(__version__.replace('rev ','')):
            #if self.msgBox('Check for Update','Update available!\nVersion: {0}\nMD5: {1}\n\nDownload ?'.format('rev '+version,md5hash),'info'):
            if self.msgBox('Check for Update','Update available!\nVersion: {0}\n\nDownload ?'.format('rev '+version),'info'):
                self.msgStatusBar('Downloading...')
                self.runMegaDL(downloadLink)
                if ospath.isfile(ospath.join(DownloadDir,'PyX3-{0}.tar.gz'.format(version))) or \
                   ospath.isfile(ospath.join(DownloadDir,'PyX3-{0}.tar.bz2'.format(version))):
                    self.msgBoxDone('Download complete!')
                    DBridge.logging.debug('Download complete!')
                else:
                    self.msgBoxFailed('Download failed!')
                    DBridge.logging.debug('Download failed!')
            else:
                return
        else:
            QMessageBox().information(self,'Check for Update','No update available!')

    def slotLog(self):
        self.clearLayout()
        editor = MyEditor(ospath.join(ScriptDir,'PyX3.log'))
        self.hLayout.addWidget(editor)

    def slotAbout(self):
        try:
            with open(ospath.join(ScriptDir,'README'), 'r') as chlog:
                self.msgBoxInput("About", """<b>{0}</b> {1}
                                                             <p>Copyright &copy; {2}
                                                             All rights reserved.
                                                             <p>Developed by {3}.
                                                             <p>Python {4} - Qt {5} - PyQt {6} on {7}""".format(__title__,
                                                             __version__,__copyright__,__author__,platform.python_version(),
                                                             QT_VERSION_STR, PYQT_VERSION_STR, platform.system()),chlog.read())
        except IOError: pass

    def closeEvent(self, e):
        ret = QMessageBox.information(self,'Quit...','Are you sure to quit?','&Ok','&Cancel','',0,1)
        if ret == 0:
            if self.timer.isActive():
                self.timer.stop()
            elif self.timer2.isActive():
                self.timer2.stop()
            self.qprocess.kill()
            DBridge.terminate()
            if ospath.isdir(TempDir):
                if os.listdir(TempDir) == []:
                    os.rmdir(TempDir)
            DBridge.logging.debug('PyX3 was closed')
            DBridge.logging.shutdown()
            e.accept()
        else:
            e.ignore()
            
# BEGIN: MAIN ----------------------------------------------------------------------------
def main():
    app = QApplication(sys.argv)
    w   = Window()
    w.setWindowTitle('{0} - {1}'.format(__title__,__version__))
    w.setWindowIcon(QIcon(ospath.join(ImageDir,'PyX3.png')))
    w.show()
    sys.exit(app.exec_())

if __name__ == '__main__':
    try:
        main()
    except SystemExit as err:
        if err.args[0] is True: raise
# END: MAIN ------------------------------------------------------------------------------
