#!/usr/bin/python2
# -*- coding: utf-8 -*-

try:
    import os
    import posixpath
    import sys
    import re
    import platform
    import stat
    import codecs
    import glob
    import time
    import ConfigParser
    import subprocess
    import operator
    import multiprocessing
    from multiprocessing import pool
    import functools
    from gtk import icon_theme_get_default
    from time import (sleep, gmtime, strftime)
    from collections import OrderedDict
    from PyQt4.QtGui import *
    from PyQt4.QtCore import *

    # Debug-Script
    from res import DebugBridge as DBridge

except ImportError as e:
    print "[!] Required module missing. %s" % e.args[0]
    sys.exit(-1)

reload(sys)
sys.setdefaultencoding('UTF-8')
sys.tracebacklimit = 0


'''
This file is part of PyX3 - Huawei X3 Toolkit

    Copyright (C) 2013-2018 ElTonno @ Android-Hilfe.de

    PyX3 is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by the
    Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    PyX3 is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
    See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program. If not, see <http://www.gnu.org/licenses/>.
'''

__title__ = 'AndroidExplorer'
__version__ = 'rev 20181011'
__author__ = 'ElTonno @ Android-Hilfe.de'
__copyright__ = '2013-2018'

# --> set user & directories
sudoGUI = 'gksudo'
activeUser = os.getenv('USER')                                  # "<USER>" / "root"
if 'root' in activeUser:
    activeUser = os.getenv('SUDO_USER')
# ---
f = sys.argv[0]
ScriptDir = unicode(posixpath.dirname(posixpath.realpath(f)))   #/home/<USER>/Desktop/PyX3/res/AndroidExplorer
ConfDir = ScriptDir                                             #/home/<USER>/Desktop/PyX3/res/AndroidExplorer
ResDir = posixpath.join(ScriptDir, 'res')                       #/home/<USER>/Desktop/PyX3/res/AndroidExplorer/res
ImageDir = posixpath.join(ScriptDir, 'images')                  #/home/<USER>/Desktop/PyX3/res/AndroidExplorer/images
TempDir = posixpath.join(ScriptDir, 'tmp')                      #/home/<USER>/Desktop/PyX3/res/AndroidExplorert/tmp
Home = u'/home/' + activeUser                                   #/home/<USER>
HomeTrash = posixpath.join(Home, '.local/share/Trash/files')    #/home/<USER>/.local/share/Trash/files
MyFile = unicode(posixpath.basename(f))                         #__main__.py
FullFile = unicode(posixpath.abspath(posixpath.realpath(f)))    #/home/<USER>/Desktop/PyX3/res/AndroidExplorer/__main__.py
Python = unicode(posixpath.abspath(sys.executable))             #/usr/bin/python
PythonDir = posixpath.dirname(Python)                           #/usr/bin
SysDir = '/usr/bin'
# <--

# --> ICONs
MainIcon = posixpath.join(ImageDir, 'AndroidExplorer.png')
# places
reload_Icon      = posixpath.join(ImageDir, 'reload.svg')
up_Icon          = posixpath.join(ImageDir, 'up.svg')
favorites_Icon   = posixpath.join(ImageDir, 'favorites.svg')
home_Icon        = posixpath.join(ImageDir, 'home.svg')
root_Icon        = posixpath.join(ImageDir, 'folder.svg')
# mimes
empty_Icon       = posixpath.join(ImageDir, 'empty.png')
file_Icon        = posixpath.join(ImageDir, 'file.png')
folder_Icon      = posixpath.join(ImageDir, 'folder.png')
audio_Icon       = posixpath.join(ImageDir, 'audio.png')
video_Icon       = posixpath.join(ImageDir, 'video.png')
image_Icon       = posixpath.join(ImageDir, 'image.png')
package_Icon     = posixpath.join(ImageDir, 'package.png')
script_Icon      = posixpath.join(ImageDir, 'script.png')
python_Icon      = posixpath.join(ImageDir, 'python.svg')
html_Icon        = posixpath.join(ImageDir, 'html.png')
document_Icon    = posixpath.join(ImageDir, 'document.png')
spreadsheet_Icon = posixpath.join(ImageDir, 'spreadsheet.png')
# <--

def timetest(func):
    def func_wrapper(*args, **kwargs):
        s = time.time()
        result = func(*args, **kwargs)
        e = time.time()
        print "{0:.3f}s, {1}, {2}".format((e-s),func.__name__,args)
    return func_wrapper

def run(func):
    class MyThread(QThread):
        def run(self, *args, **kwargs):
            return func(*args, **kwargs)
    @functools.wraps(func)
    def async_func(*args, **kwargs):
        mythread = MyThread()
        mythread.start()
        result = mythread.run(*args, **kwargs)
        return result
    return async_func

# SETTINGS ###################################################################################################
if not posixpath.isfile(posixpath.join(ConfDir, 'settings.cfg')):
    cfgfile = codecs.open(posixpath.join(ConfDir, 'settings.cfg'), "w", "utf-8")
    Config = ConfigParser.ConfigParser()
    Config.add_section('android')
    Config.set('android', 'androidsdk', posixpath.join(Home, 'adt', 'sdk'))
    Config.add_section('connection')
    Config.set('connection', 'device_ip', '#192.168.1.10')
    Config.add_section('bookmarks_local')
    Config.add_section('bookmarks_remote')
    Config.add_section('config')
    Config.set('config', 'progress_autoclose', 'True')
    Config.set('config', 'progress_autoclose_timeout', 2)
    Config.set('config', 'progress_minimized', 'True')
    Config.write(cfgfile)
    cfgfile.close()

def EditConfigMap(section, option, value):
    Config = ConfigParser.ConfigParser()
    Config.readfp(codecs.open(posixpath.join(ConfDir, 'settings.cfg'), "r", "utf-8"))
    Config.set(section, option, value)
    with codecs.open(posixpath.join(ConfDir, 'settings.cfg'), "wb", "utf-8") as configfile:
        Config.write(configfile)

def ReadConfigMap(section):
    dict1 = {}
    Config = ConfigParser.ConfigParser()
    Config.readfp(codecs.open(posixpath.join(ConfDir, 'settings.cfg'), "r", "utf-8"))
    for option in Config.options(section):
        try:
            dict1[option] = Config.get(section, option)
            if dict1[option] == -1:
                print 'skip: {}'.format(option)
        except:
            print 'exception on {}!'.format(option)
            dict1[option] = None
    return dict1

# SET BINARIES ###############################################################################################
adb,fastboot,aapt = "","",""
for d in [SysDir,posixpath.join(ReadConfigMap('android')['androidsdk'], 'platform-tools'),ResDir]:
    for x in ["adb","fastboot","aapt"]:
        b = posixpath.join(d, x)
        if posixpath.isfile(b):
            if (x == "adb") and (adb == ""): adb = b
            elif (x == "fastboot") and (fastboot == ""): fastboot = b
            elif (x == "aapt") and (aapt == ""): aapt = b
            else: pass

device_ip = posixpath.join(ReadConfigMap('connection')['device_ip'])
progress_autoclose = posixpath.join(ReadConfigMap('config')['progress_autoclose'])
progress_minimized = posixpath.join(ReadConfigMap('config')['progress_minimized'])
progress_autoclose_timeout = int(posixpath.join(ReadConfigMap('config')['progress_autoclose_timeout']))

# USEFUL GLOBAL-FUNCTIONS ####################################################################################
def ANDROID_DATA():
    return DBridge.Adb(adb)._ANDROID_DATA()

def ANDROID_ROOT():
    return DBridge.Adb(adb)._ANDROID_ROOT()

def EXTERNAL_STORAGE():
    return DBridge.Adb(adb)._EXTERNAL_STORAGE()

def SD_EXT_DIRECTORY():
    return DBridge.Adb(adb)._SD_EXT_DIRECTORY()

def isWritable(dirname):
    try:
        print "{0}".format(dirname)
        print os.access(dirname, os.W_OK)
        os.access(dirname, os.W_OK)
    except IOError:
        return False
    return True

def isExternalDrive(path):
## Problem: Groß-/Kleinschreibung unter /dev/disk/by-label (Seagate/SEAGATE)
    byLabel = '/dev/disk/by-label'
    byUUid = '/dev/disk/by-uuid'
    p = ''
    if posixpath.isdir(byLabel):
        p = byLabel
    elif posixpath.isdir(byUUid):
        p = byUUid
    else:
        return False
    if ("/media" in path) or ("/mnt" in path) or ("/run" in path):
        return True
    elif posixpath.isdir(p):
        if len([y for y in [x for x in os.listdir(p)] if y in path]) > 0:
            return True
    else:
        return False

def getExternalDrives():
    byLabel = '/dev/disk/by-label'
    byUUid = '/dev/disk/by-uuid'
    p = ''
    if posixpath.isdir(byLabel):
        p = byLabel
    elif posixpath.isdir(byUUid):
        p = byUUid
    else:
        return False
    m = DBridge.MyProcess('mount')
    drives = []
    for x in os.listdir(p):
        d = os.readlink(posixpath.join(p,x)).replace('../..','/dev')
        if not 'sda' in d:
            r = re.findall('{}.on.(.+).type'.format(d), m)
            if len(r) > 0:
                drives.append(r[0])
    return drives

def getUserPath(value):
    path = DBridge.MyProcessWait('xdg-user-dir '+value)
    c = (posixpath.isdir(path.strip()) if path else None)
    return (path.strip() if c else None)

def getTextEditor():
    #return posixpath.join(ResDir,'SciTE')
    #mime = posixpath.join(Home, '.local/share/applications/mimeapps.list')
    mime = posixpath.join(Home, '.config/mimeapps.list')
    mimeApps = []
    with open(mime, 'r') as f:
        mimeApps = re.findall('text/plain=(.*).desktop', f.read())
        if len(mimeApps) >= 1:
            return mimeApps[0]

def getTerminal():
    mime = posixpath.join(Home, '.config/mimeapps.list')
    mimeApps = []
    with open(mime, 'r') as f:
        mimeApps = re.findall('application/x-shellscript=(.*).desktop', f.read())
        if len(mimeApps) >= 1:
            return mimeApps[0].split(';')[-1]

def getLauncherIcon(name):
    def recursive(p,n):
        #for (dir, _, files) in os.walk(p):
            #if not "48" in dir: continue
        for files in os.listdir(p):
            #for f in files:
            for x in ['.png','.xpm','.svg']:
                path = posixpath.join(p, files)
                if not path.endswith(x):
                    path+=x
                if (n in path) and (posixpath.exists(path)):
                    return path
                elif (n.lower() in path.lower()) and (posixpath.exists(path.lower())):
                    return path.lower()
    iconName = False
    with open(name, "r") as f:
        i = f.read().split('Icon=')
        if len(i) > 1:
            iconName = [i[1].split('\n')[0]]        
    if iconName:
        if iconName[0].startswith('/'):
            return iconName[0]
        else:
            icon_theme = icon_theme_get_default()
            try:
                iconInfo = icon_theme.lookup_icon(iconName[0], 48, 0)
                if iconInfo != None:
                    return iconInfo.get_filename()
            except gobject.GError, exc:
                  print "can't load icon", exc
            else:
                sysInfo = ['/usr/share/icons/hicolor/48x48/apps','/usr/share/icons/hicolor/scalable/apps','/usr/share/pixmaps']
                for p in sysInfo:
                    icon = recursive(p, iconName[0])
                    if icon: break
                if icon:
                    return icon
                return False

def human(Bytes):
    Bytes=float(Bytes)
    c,unit=0,["B", "KB", "MB", "GB", "TB"]
    while(Bytes>=1024):
        Bytes/=1024
        c+=1
    return "{0:.1f}{1}".format(Bytes,unit[c])

# PROGRESS-WIDGET ############################################################################################
class ProgressWidget(QWidget):
    def __init__(self, parent=None):
        global progress_minimized, progress_autoclose, progress_autoclose_timeout
        super(ProgressWidget, self).__init__(parent)
        self.killProcVar = False
        self.minimized = progress_minimized
        self.autoclose = progress_autoclose
        self.autoclose_timeout = progress_autoclose_timeout
        # Timer
        self.timer = QTimer()
        self.timer.timeout.connect(self.count)
        # geometry
        self.resize(408, 258)
        self.setWindowTitle('Info')
        self.setStyleSheet('font: 10pt; font-family: Mono; border-style: inset;')
        #self.move(QApplication.desktop().screen().rect().center()- self.rect().center())
        # TextEdit
        self.plainTextEdit = QPlainTextEdit()
        self.plainTextEdit.setReadOnly(True)
        self.plainTextEdit.setWordWrapMode(QTextOption.NoWrap)
##        self.plainTextEdit.textChanged.connect(self.sizeChange)
        # ProgressBar
        self.pgBar = QProgressBar()
        self.pgBar.setMaximumSize(QSize(16777215, 25))
        #self.pgBar.setStyleSheet('background-color: #579599;')
        #self.pgBar.setMinimum(0)
        # Button
        self.BtnClose = QPushButton('&Close')
        self.BtnClose.setMaximumSize(QSize(115, 30))
        self.BtnClose.clicked.connect(self.close)
        # Layout
        self.vLayout = QVBoxLayout()
        self.vLayout.setSpacing(0)
        self.vLayout.setContentsMargins(2, 2, 2, 2)
        self.hLayout = QHBoxLayout()
        self.hLayout.setSpacing(0)
        self.vLayout.addWidget(self.plainTextEdit)
        self.vLayout.addWidget(self.pgBar)
        self.hLayout.addWidget(self.BtnClose)
        self.vLayout.addLayout(self.hLayout)
        self.setLayout(self.vLayout)

    def setKillProcVar(self):
        self.killProcVar = False
        DBridge.killProcess()

    def getKillProcVar(self):
        return self.killProcVar

    def count(self):
        self.currentTime -= 1
        self.BtnClose.setText('&Close [{}]'.format(self.currentTime))
        if self.currentTime <= 0:
            self.BtnClose.setText('&Close [0]')
            self.timer.stop()
            self.close()

    def showEvent(self, QShowEvent):
        if self.minimized == 'True':
            self.showMinimized()
        if self.autoclose == 'True':
            self.BtnClose.setText('&Close [{}]'.format(self.autoclose_timeout))

    def startTimerEvent(self):
        self.BtnClose.setEnabled(True)
        self.currentTime = self.autoclose_timeout
        self.BtnClose.setText('&Close [{}]'.format(self.currentTime))
        self.timer.start(1000*1)

    def closeEvent(self, e):
        if self.BtnClose.isEnabled():
            self.killProcVar = False
            e.accept()
        else:
            if self.pgBar.value() == self.pgBar.maximum():
                ret = QMessageBox.warning(self, 'Cancel...', 'Cancel the process?', '&Ok', '&Cancel', '', 0, 1)
                if ret == 0:
                    self.killProcVar = True
                    e.accept()
                else:
                    self.killProcVar = False
                    self.timer.stop()
                    e.ignore()
            else:
                return

# PROPERTIES-DIALOG ##########################################################################################
class PropertiesDialog(QDialog):
    def __init__(self, parent=None):
        super(PropertiesDialog, self).__init__(parent)
        self.setStyleSheet('font: 10pt; font-family: Mono; border-style: inset;')
        Info = QWidget()
        Permission = QWidget()
        tabWidget = QTabWidget()
        tabWidget.addTab(Info, 'Info')
        tabWidget.addTab(Permission, 'Permission')
        tabWidget.setCurrentIndex(0)
        self.btnBox = QDialogButtonBox(self)
        self.btnBox.setStandardButtons(QDialogButtonBox.Cancel | QDialogButtonBox.Ok)
        self.btnBox.accepted.connect(self.btnBoxAccepted)
        self.btnBox.rejected.connect(self.btnBoxRejected)

        lblName = QLabel('Name:')
        self.editNameValue = QLineEdit('')
        lblLocation = QLabel('Location:')
        self.editLocationValue = QLineEdit('')
        lblType = QLabel('Type:')
        self.lblTypeValue = QLabel('')
        lblSize = QLabel('Size:')
        self.lblSizeValue = QLabel('')
        lblModified = QLabel('Modified:')
        self.lblModifiedValue = QLabel('')
        lblAccessed = QLabel('Accessed:')
        self.lblAccessedValue = QLabel('')
        lblOwner = QLabel('Owner:')
        self.editOwnerValue = QLineEdit('')
        lblGroup = QLabel('Group:')
        self.editGroupValue = QLineEdit('')
        lblOctal = QLabel('Octal:')
        self.lblOctalValue = QLabel('0000')
        lblText = QLabel('Text:')
        self.lblTextValue = QLabel('---------')
        lblChkOwner = QLabel('Owner:')
        lblChkGroup = QLabel('Group:')
        lblChkOther = QLabel('Other:')

        self.chkReadOwner = QCheckBox('Read')
        self.chkReadGroup = QCheckBox('Read')
        self.chkReadOther = QCheckBox('Read')
        self.chkWriteOwner = QCheckBox('Write')
        self.chkWriteGroup = QCheckBox('Write')
        self.chkWriteOther = QCheckBox('Write')
        self.chkExecOwner = QCheckBox('Execute')
        self.chkExecGroup = QCheckBox('Execute')
        self.chkExecOther = QCheckBox('Execute')
        self.chkUID = QCheckBox('Set UID')
        self.chkGID = QCheckBox('Set GID')
        self.chkSticky = QCheckBox('Set Sticky')

        vSpacer1 = QSpacerItem(20, 35, QSizePolicy.Minimum, QSizePolicy.Fixed)
        vSpacer2 = QSpacerItem(20, 35, QSizePolicy.Minimum, QSizePolicy.Fixed)
        vSpacer3 = QSpacerItem(20, 15, QSizePolicy.Minimum, QSizePolicy.Fixed)
        vSpacer4 = QSpacerItem(20, 30, QSizePolicy.Minimum, QSizePolicy.Fixed)
        vSpacer5 = QSpacerItem(20, 15, QSizePolicy.Minimum, QSizePolicy.Fixed)
        vSpacer6 = QSpacerItem(20, 15, QSizePolicy.Minimum, QSizePolicy.Fixed)
        hSpacer1 = QSpacerItem(40, 20, QSizePolicy.Fixed, QSizePolicy.Minimum)
        hSpacer2 = QSpacerItem(40, 20, QSizePolicy.Fixed, QSizePolicy.Minimum)
        hSpacer3 = QSpacerItem(40, 20, QSizePolicy.Fixed, QSizePolicy.Minimum)
        hSpacer4 = QSpacerItem(40, 20, QSizePolicy.Fixed, QSizePolicy.Minimum)

        vLayout1 = QVBoxLayout()
        vLayout2 = QVBoxLayout()
        vLayout3 = QVBoxLayout()
        hLayout1 = QHBoxLayout()
        hLayout2 = QHBoxLayout()
        hLayout3 = QHBoxLayout()
        hLayout4 = QHBoxLayout()
        hLayout5 = QHBoxLayout()
        fLayout  = QFormLayout()
        gLayout1 = QGridLayout()
        gLayout2 = QGridLayout()

        gLayout1.addWidget(lblName,           0, 0, 1, 1)
        gLayout1.addWidget(self.editNameValue,0, 1, 1, 1)
        gLayout1.addWidget(lblLocation,             1, 0, 1, 1)
        gLayout1.addWidget(self.editLocationValue,  1, 1, 1, 1)
        gLayout1.addWidget(lblType,                 2, 0, 1, 1)
        gLayout1.addWidget(self.lblTypeValue,       2, 1, 1, 1)
        gLayout1.addWidget(lblSize,                 3, 0, 1, 1)
        gLayout1.addWidget(self.lblSizeValue,       3, 1, 1, 1)
        gLayout1.addWidget(lblModified,             4, 0, 1, 1)
        gLayout1.addWidget(self.lblModifiedValue,   4, 1, 1, 1)
        gLayout1.addWidget(lblAccessed,             5, 0, 1, 1)
        gLayout1.addWidget(self.lblAccessedValue,   5, 1, 1, 1)
        gLayout2.addWidget(lblChkOwner,             0, 0, 1, 1)
        gLayout2.addWidget(lblChkGroup,             1, 0, 1, 1)
        gLayout2.addWidget(lblChkOther,             2, 0, 1, 1)
        gLayout2.addWidget(self.chkReadOwner,       0, 1, 1, 1)
        gLayout2.addWidget(self.chkReadGroup,       1, 1, 1, 1)
        gLayout2.addWidget(self.chkReadOther,       2, 1, 1, 1)
        gLayout2.addWidget(self.chkWriteOwner,      0, 2, 1, 1)
        gLayout2.addWidget(self.chkWriteGroup,      1, 2, 1, 1)
        gLayout2.addWidget(self.chkWriteOther,      2, 2, 1, 1)
        gLayout2.addWidget(self.chkExecOwner,       0, 3, 1, 1)
        gLayout2.addWidget(self.chkExecGroup,       1, 3, 1, 1)
        gLayout2.addWidget(self.chkExecOther,       2, 3, 1, 1)
        gLayout2.addWidget(self.chkUID,             0, 4, 1, 1)
        gLayout2.addWidget(self.chkGID,             1, 4, 1, 1)
        gLayout2.addWidget(self.chkSticky,          2, 4, 1, 1)

        fLayout.setWidget(0, QFormLayout.LabelRole, lblOctal)
        fLayout.setWidget(0, QFormLayout.FieldRole, self.lblOctalValue)
        fLayout.setWidget(1, QFormLayout.LabelRole, lblText)
        fLayout.setWidget(1, QFormLayout.FieldRole, self.lblTextValue)

        hLayout1.setSizeConstraint(QLayout.SetFixedSize)
        hLayout1.addWidget(tabWidget)
        hLayout2.addItem(hSpacer1)
        hLayout2.addLayout(gLayout1)
        hLayout2.addItem(hSpacer2)
        hLayout3.addItem(hSpacer3)
        hLayout3.addLayout(vLayout3)
        hLayout3.addItem(hSpacer4)
        hLayout4.addWidget(lblGroup)
        hLayout4.addWidget(self.editGroupValue)
        hLayout5.addWidget(lblOwner)
        hLayout5.addWidget(self.editOwnerValue)

        vLayout1.addItem(vSpacer1)
        vLayout1.addLayout(hLayout2)
        vLayout1.addItem(vSpacer2)
        vLayout2.addLayout(hLayout3)
        vLayout3.addItem(vSpacer5)
        vLayout3.addLayout(hLayout5)
        vLayout3.addLayout(hLayout4)
        vLayout3.addItem(vSpacer3)
        vLayout3.addLayout(gLayout2)
        vLayout3.addItem(vSpacer6)
        vLayout3.addLayout(fLayout)
        vLayout3.addItem(vSpacer4)

        Info.setLayout(vLayout1)
        Permission.setLayout(vLayout2)
        layout = QVBoxLayout()
        layout.setSpacing(0)
        layout.setContentsMargins(0, 0, 0, 0)
        layout.addWidget(tabWidget)
        layout.addWidget(self.btnBox)
        self.setLayout(layout)

        self.setMinimumSize(586, 328)
        self.setMaximumSize(586, 328)
        self.setWindowTitle('Info / Permissions')

        lbl = [self.editNameValue,self.editLocationValue,self.lblTypeValue,self.lblSizeValue,\
               self.lblAccessedValue,self.lblModifiedValue,self.editOwnerValue,self.editGroupValue]
        for l in lbl:
            l.setMinimumSize(QSize(300, 25))

        lbl = [lblName,lblLocation,lblType,lblSize,lblModified,lblAccessed]
        for l in lbl:
            l.setMinimumSize(QSize(100, 20))
            l.setMaximumSize(QSize(120, 20))

        lbl = [lblOwner,lblGroup,lblChkOwner,lblChkGroup,lblChkOther]
        for l in lbl:
            l.setMinimumSize(QSize(60, 20))
            l.setMaximumSize(QSize(60, 20))

        lbl = [lblOctal,lblText,self.lblOctalValue,self.lblTextValue]
        for l in lbl:
            l.setMinimumSize(QSize(60, 20))
            l.setMaximumSize(QSize(100, 20))

        self.setStyleSheet('QGridLayout{border: 1px solid;}')

        self.ret_new = []
        self.ret_old = []
        self.default = [self.chkReadOwner, self.chkWriteOwner, self.chkExecOwner, self.chkUID,
                            self.chkReadGroup, self.chkWriteGroup, self.chkExecGroup, self.chkGID,
                            self.chkReadOther, self.chkWriteOther, self.chkExecOther, self.chkSticky]
        for d in self.default:
            d.setMinimumSize(QSize(80, 20))
            d.setMaximumSize(QSize(110, 20))
            d.clicked.connect(self.chkHandleClicked)

        self.defOwnerGroup = ''
        self.defPerm = ''

    def clearLayout(self):
        for d in self.default:
            d.setChecked(False)

    def fillStat(self, n, local=True):
        if not n:
            return
        if local:
            a = DBridge.MyProcess(u'stat \"{0}\"'.format(n))
        else:        
            a = DBridge.Adb(adb)._shell(u'stat \"{0}\"'.format(n))
        name = re.findall(u'[Datei|File]:\s(.*)\s+', a)
        location = posixpath.split(n)[0]
        ftype = re.findall(u'Block:\s\d+\s+(.*)\s', a)
        size = re.findall(u'[Größe|Size]:\s(.[0-9]*)\s', a)
        dates = re.findall(u'\s(\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2})', a)
        if name:
            name = name[0].replace('“', '').replace('»', '').replace('//', '/')
            if '->' in name:
                name = name.replace('->', '\n->')
            name = name.rsplit('/')[-1]
        else:
            name = ''
        ftype = ('' if not ftype else ftype[0])
        if size:
            size = size[0]
            if size == '4096':
                s = DBridge.MyProcess(u'du -sb \"{0}\"'.format(n)).splitlines()
                s = [x for x in s if "Berechtigung" not in x][0].split()[0]
                size = s
        else:
            size = ''
        if dates and dates > 2:
            access = dates[0]
            modified = dates[1]
        else:
            access = ''
            modified = ''
        print 'Name:        {}'.format(name)
        print 'Location:    {}'.format(location)
        print 'Type:        {}'.format(ftype)
        print 'Size:        {}'.format(human(size))
        print 'Access:      {}'.format(access)
        print 'Modified:    {}'.format(modified)
        self.editNameValue.setText(unicode(name))
        self.editLocationValue.setText(unicode(location))
        self.lblTypeValue.setText(unicode(ftype))
        self.lblSizeValue.setText(unicode(human(size)))
        self.lblModifiedValue.setText(unicode(access))
        self.lblAccessedValue.setText(unicode(modified))

    def fillLayout(self, owner, group, perm):
        if not (owner and group and perm):
            return
        if len(perm) not in [9, 10, 11]:
            return
        # 'rwxr-x---' 9, '-rwxr-x---' 10, '-rwxr-x---+' 11, 'drwxr-x---' 10, 'drwxr-x---+' 11
        perm = perm.replace('d', '').replace('+', '')
        if len(perm) == 9:
            pass
        elif len(perm) == 10:
            perm = perm[1:]
        else:
            return
        self.defOwnerGroup = '.'.join([owner, group])
        self.defPerm = perm

        print 'Owner:       {}'.format(owner)
        print 'Group:       {}'.format(group)
        print 'Permission:  {}'.format(perm)
        self.clearLayout()

        # Owner
        self.editOwnerValue.setText(owner)
        if 'r' in perm[0:3]: self.chkReadOwner.setChecked(True)
        if 'w' in perm[0:3]: self.chkWriteOwner.setChecked(True)
        if 'S' in perm[0:3]: self.chkUID.setChecked(True)
        if 's' in perm[0:3]: self.chkUID.setChecked(True); self.chkExecOwner.setChecked(True)
        if 'x' in perm[0:3]: self.chkExecOwner.setChecked(True)

        # Group
        self.editGroupValue.setText(group)
        if 'r' in perm[3:6]: self.chkReadGroup.setChecked(True)
        if 'w' in perm[3:6]: self.chkWriteGroup.setChecked(True)
        if 'S' in perm[3:6]: self.chkGID.setChecked(True)
        if 's' in perm[3:6]: self.chkGID.setChecked(True); self.chkExecGroup.setChecked(True)
        if 'x' in perm[3:6]: self.chkExecGroup.setChecked(True)

        # Other
        if 'r' in perm[6:9]: self.chkReadOther.setChecked(True)
        if 'w' in perm[6:9]: self.chkWriteOther.setChecked(True)
        if 'T' in perm[6:9]: self.chkSticky.setChecked(True)
        if 't' in perm[6:9]: self.chkSticky.setChecked(True); self.chkExecOther.setChecked(True)
        if 'x' in perm[6:9]: self.chkExecOther.setChecked(True)
        self.chkHandleClicked()

    def getLayout(self):
        a,b,c = ['-', '-', '-'],['-', '-', '-'],['-', '-', '-']
        # Owner
        if self.chkReadOwner.isChecked():       a[0] = 'r'
        if self.chkWriteOwner.isChecked():      a[1] = 'w'
        if self.chkExecOwner.isChecked():       a[2] = 'x'
        if not self.chkExecOwner.isChecked() and \
             self.chkUID.isChecked():           a[2] = 'S'
        if self.chkExecOwner.isChecked() and \
             self.chkUID.isChecked():           a[2] = 's'
        # Group
        if self.chkReadGroup.isChecked():       b[0] = 'r'
        if self.chkWriteGroup.isChecked():      b[1] = 'w'
        if self.chkExecGroup.isChecked():       b[2] = 'x'
        if not self.chkExecGroup.isChecked() and \
             self.chkGID.isChecked():           b[2] = 'S'
        if self.chkExecGroup.isChecked() and \
             self.chkGID.isChecked():           b[2] = 's'
        # Other
        if self.chkReadOther.isChecked():       c[0] = 'r'
        if self.chkWriteOther.isChecked():      c[1] = 'w'
        if self.chkExecOther.isChecked():       c[2] = 'x'
        if not self.chkExecOther.isChecked() and \
             self.chkSticky.isChecked():        c[2] = 'T'
        if self.chkExecOther.isChecked() and \
             self.chkSticky.isChecked():        c[2] = 't'
        return [a, b, c]

    def getOctal(self):
        a, b, c, d = 0, 0, 0, 0
        perm = self.getLayout()
        # Owner
        if 'r' in perm[0]: a += 4
        if 'w' in perm[0]: a += 2
        if 'x' in perm[0]: a += 1
        if 'S' in perm[0]: d += 4
        if 's' in perm[0]: a += 1; d += 4
        # Group
        if 'r' in perm[1]: b += 4
        if 'w' in perm[1]: b += 2
        if 'x' in perm[1]: b += 1
        if 'S' in perm[1]: d += 2
        if 's' in perm[1]: b += 1; d += 2
        # Other
        if 'r' in perm[2]: c += 4
        if 'w' in perm[2]: c += 2
        if 'x' in perm[2]: c += 1
        if 'T' in perm[2]: d += 1
        if 't' in perm[2]: c += 1; d += 1

        return ''.join([str(d), str(a), str(b), str(c)])

    def getUser(self):
        return '.'.join([unicode(self.editOwnerValue.text()),
                         unicode(self.editGroupValue.text())])

    def getPerm(self):
        p = ''
        for x in self.getLayout():
            for y in x:
                p += str(y)
        return p

    def chkHandleClicked(self):
        self.lblOctalValue.setText(self.getOctal())
        self.lblTextValue.setText(self.getPerm())

    def btnBoxAccepted(self):
        if (self.defOwnerGroup == self.getUser()) and (self.defPerm == self.getPerm()):
            self.ret_new = [self.defPerm, self.defOwnerGroup]
            self.accept()
        else:
            self.ret_new = [self.getOctal(), self.getUser()]
            self.accept()

    def btnBoxRejected(self):
        self.close()

    def exec_(self):
        self.ret_old = [self.defPerm, self.defOwnerGroup]
        self.ret_new = [self.defPerm, self.defOwnerGroup]
        if QDialog.exec_(self) == QDialog.Accepted:
            return self.ret_new
        else:
            return self.ret_old

# MAIN-TABLE #################################################################################################
class MyTableModel(QAbstractTableModel):
    def __init__(self, parent, mylist, header, *args):
        QAbstractTableModel.__init__(self, parent, *args)
        self.mylist = mylist
        self.header = header
        self._setIcons = 0
        self._pathforIcon = ''

    def setIcons(self, n):
        self._setIcons = n

    def givePath(self, p):
        self._pathforIcon = p

    def rowCount(self, parent = QModelIndex()):
        try:
            return len(self.mylist)
        except:
            return 0

    def columnCount(self, parent = QModelIndex()):
        try:
            return len(self.mylist[0])
        except:
            return 0

    def removeAllRows(self, parent = QModelIndex()):
        self.mylist = []

    def data(self, index, role = Qt.DisplayRole):
        if index.isValid() and (role == Qt.DisplayRole):
            return self.mylist[index.row()][index.column()]
        elif (index.isValid()) and (role == Qt.DecorationRole):
            if (index.column() == 0):
                data = self.mylist[index.row()]
                icon = ''
                if data[0].endswith(('.png','.jpg','.jpeg','.gif','.svg','.ico','.bmp','.tiff')):
                    icon = image_Icon
                elif data[0].endswith(('.mp2','.mp3','.mpa','.m4a','.aac','.ac3','.flac','.ogg','.opus')):
                    icon = audio_Icon
                elif data[0].endswith(('.mpg','.mpeg','.m2v','.trp','.mp4','.mkv','.flv','.mov','.avi','.264','.265')):
                    icon = video_Icon
                elif data[0].endswith(('.tgz','.tar.gz','.tar.bz2','7z','.arj','.cab','.chm','.cpio','.dmg','.hfs',
                                        '.lzh','.lzma','.nsis','.udf','.wim','.xar','.z','.zip','.gzip','.tar','.apk',
                                       '.iso','.img')):
                    icon = package_Icon
                elif data[0].endswith(('.bash','.sh')):
                    icon = script_Icon
                elif data[0].endswith(('.py','.pyw')):
                    icon = python_Icon
                elif data[0].endswith(('.odt','.doc','.docx','.rtf','.ott','.pdf')):
                    icon = document_Icon
                elif data[0].endswith(('.ods','.gnumeric','.xls')):
                    icon = spreadsheet_Icon
                elif data[0].endswith(('.html','.htm','.xml')):
                    icon = html_Icon
                elif data[0].endswith('.desktop'):
                    if self._pathforIcon != '':
                        icon = getLauncherIcon(posixpath.join(self._pathforIcon,data[0]))
                elif data[-1].startswith('d'):
                    icon = folder_Icon
                else:
                    icon = file_Icon
                    if (not data[0].startswith('.')) and \
                       ('x' in data[-1]) and \
                       (not data[0].endswith(('.txt','.cfg','.conf','.ini','log'))):
                        icon = script_Icon
                if icon:
                    return QIcon(icon)
            else:
                return
        else:
            return

    def headerData(self, col, orientation, role):
        if (orientation == Qt.Horizontal) and (role == Qt.DisplayRole):
            return QVariant(self.header[col])
        return QVariant()

    def sort(self, col, order):
        """sort table by given column number col"""
        self.emit(SIGNAL("layoutAboutToBeChanged()"))
        self.mylist = sorted(self.mylist, key=operator.itemgetter(col))
        if order == Qt.DescendingOrder:
            self.mylist.reverse()
        self.emit(SIGNAL("layoutChanged()"))   

    def getRow(self, index):
        return self.mylist[index]

    def getData(self):
        return self.mylist

    def getColumn(self, index):
        return self.header[index]

class Table( QTableView ):
    def __init__( self, parent = None ):
        super( Table, self ).__init__( parent )
        self.keylist = []
    def event(self, event):        
        if (event.type() == QEvent.KeyPress):
            if event.key() == 16777236:
                self.emit(SIGNAL("mouseForward"))
                return True
            elif event.key() == 16777234:
                self.emit(SIGNAL("mouseBackward"))
                return True
##        elif (event.type() == QEvent.QMouseEvent):
##            self.emit(SIGNAL("mouseMoved"))
##            return True
        return QTableView.event(self, event)

class Label( QLabel ):
    def __init__( self, parent = None ):
        super( Label, self ).__init__( parent )
        self.setWindowFlags(Qt.SplashScreen)
        self.resize(16777215,20)
    def showAction(self):
        self.show()
    def hideAction(self):
        self.hide()

# MAIN-WINDOW ################################################################################################
class MyWindow(QMainWindow):
    def __init__(self):
        super(MyWindow, self).__init__()
        # geometry
        self.setWindowTitle('{0} - {1}'.format(__title__, __version__))
        self.resize(900, 530)
        #self.setStyleSheet('font: 10pt; font-family: Mono; border-style: inset')
        #QApplication.setStyle(QStyleFactory.create('clearlooks'))
        self.centralwidget = QWidget(self)

        self.systemTrayIcon = QSystemTrayIcon(self)
        self.systemTrayIcon.setIcon(QIcon(MainIcon))
        self.systemTrayIcon.setVisible(True)
        self.systemTrayIcon.activated.connect(self.on_systemTrayIcon_activated)

        # splitter
        self.splitter = QSplitter(self.centralwidget)
        self.splitter.setMinimumSize(QSize(0, 0))
        self.splitter.setOrientation(Qt.Horizontal)
        self.splitter.setOpaqueResize(True)
        self.splitter.setHandleWidth(4)
        self.splitter.setChildrenCollapsible(True)
        self.splitter.setSizes([1, 1])

        self.vLayoutWidget1 = QWidget(self.splitter)
        self.vLayoutWidget2 = QWidget(self.splitter)

        # buttons -> left
        self.tBtnRefresh1 = QToolButton()
        self.tBtnRefresh1.setText('O')
        self.tBtnRefresh1.setToolTip('Refresh')
        self.tBtnRefresh1.setIcon(QIcon(reload_Icon))

        self.lineEdit1 = QLineEdit()
        self.lineEdit1.setToolTip('Change directory')
        self.lineEdit1.setStyleSheet("selection-background-color: #579599;")

        self.tBtnHidden1 = QToolButton()
        self.tBtnHidden1.setCheckable(True)
        self.tBtnHidden1.setText('.')
        self.tBtnHidden1.setToolTip('Hidden directories')

        self.tBtnFav1 = QToolButton()
        self.tBtnFav1.setText('*')
        self.tBtnFav1.setToolTip('Xdg user directories')
        self.tBtnFav1.setIcon(QIcon(favorites_Icon))

        self.tBtnHome1 = QToolButton()
        self.tBtnHome1.setText('~')
        self.tBtnHome1.setToolTip('Home directory')
        self.tBtnHome1.setIcon(QIcon(home_Icon))

        self.tBtnRoot1 = QToolButton()
        self.tBtnRoot1.setText('/')
        self.tBtnRoot1.setToolTip('Root directory')
        self.tBtnRoot1.setIcon(QIcon(root_Icon))

        self.tBtnBack1 = QToolButton()
        self.tBtnBack1.setText('..')
        self.tBtnBack1.setToolTip('Go up')
        self.tBtnBack1.setIcon(QIcon(up_Icon))

        self.tBtnHist1 = QToolButton()
        self.tBtnHist1.setToolTip('last directories')
        self.tBtnHist1.setIcon(QIcon(QApplication.style().standardIcon(\
                                     QStyle.SP_ToolBarVerticalExtensionButton)))

        self.sb1 = QLabel('')
        #self.sb1.setFixedHeight(12)
        self.sb1.setAlignment(Qt.AlignLeft)
        self.sb1.setStyleSheet('font: 9pt;')

        self.sb3 = QLabel('')
        #self.sb3.setFixedHeight(12)
        self.sb3.setAlignment(Qt.AlignRight)
        self.sb3.setStyleSheet('font: 9pt;')

        # buttons -> right
        self.tBtnRefresh2 = QToolButton()
        self.tBtnRefresh2.setText('O')
        self.tBtnRefresh2.setToolTip('Refresh')
        self.tBtnRefresh2.setIcon(QIcon(reload_Icon))

        self.lineEdit2 = QLineEdit()
        self.lineEdit2.setToolTip('Change directory')
        self.lineEdit2.setStyleSheet("selection-background-color: #579599;")

        self.tBtnRW = QToolButton()
        self.tBtnRW.setText('r/w')
        self.tBtnRW.setToolTip('Remount')

        self.tBtnHidden2 = QToolButton()
        self.tBtnHidden2.setCheckable(True)
        self.tBtnHidden2.setText('.')
        self.tBtnHidden2.setToolTip('Hidden directories')

        self.tBtnFav2 = QToolButton()
        self.tBtnFav2.setText('*')
        self.tBtnFav2.setToolTip('Bookmarks')
        self.tBtnFav2.setIcon(QIcon(favorites_Icon))

        self.tBtnHome2 = QToolButton()
        self.tBtnHome2.setText('~')
        self.tBtnHome2.setToolTip('Go to SD Card')
        self.tBtnHome2.setIcon(QIcon(home_Icon))

        self.tBtnRoot2 = QToolButton()
        self.tBtnRoot2.setText('/')
        self.tBtnRoot2.setToolTip('Root directory')
        self.tBtnRoot2.setIcon(QIcon(root_Icon))

        self.tBtnBack2 = QToolButton()
        self.tBtnBack2.setText('..')
        self.tBtnBack2.setToolTip('Go up')
        self.tBtnBack2.setIcon(QIcon(up_Icon))

        self.tBtnHist2 = QToolButton()
        self.tBtnHist2.setToolTip('last directories')
        self.tBtnHist2.setIcon(QIcon(QApplication.style().standardIcon(\
                                     QStyle.SP_ToolBarVerticalExtensionButton)))

        self.toolBar1 = QToolBar()
        bar1 = [self.tBtnBack1,self.tBtnRefresh1,self.tBtnHome1,\
                self.tBtnRoot1,self.tBtnFav1,self.tBtnHist1,self.lineEdit1]
        for item in bar1:
            self.toolBar1.addWidget(item)

        self.toolBar2 = QToolBar()
        bar2 = [self.tBtnBack2,self.tBtnRefresh2,self.tBtnHome2,self.tBtnRoot2,\
                self.tBtnFav2,self.tBtnHist2,self.lineEdit2,self.tBtnRW]
        for item in bar2:
            self.toolBar2.addWidget(item)

        for item in bar1+bar2:
            if (item == self.lineEdit1) or (item == self.lineEdit2):
                item.setMinimumSize(QSize(100, 0))
            else:
                item.setMinimumSize(QSize(25, 0))
                item.setMaximumSize(QSize(25, 16777215))

        self.sb2 = QLabel('')
        #self.sb2.setFixedHeight(12)
        self.sb2.setAlignment(Qt.AlignLeft)
        self.sb2.setStyleSheet('font: 9pt;')

        self.sb4 = QLabel('')
        #self.sb4.setFixedHeight(12)
        self.sb4.setAlignment(Qt.AlignRight)
        self.sb4.setStyleSheet('font: 9pt;')

        self.tblView1 = Table()
        self.tblView1.setMinimumSize(QSize(0, 0))
        self.tblView1.setBaseSize(QSize(-1, 0))
        self.tblView1.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
        self.tblView1.setProperty('showDropIndicator', False)
        self.tblView1.setAlternatingRowColors(True)
        self.tblView1.setSelectionBehavior(QAbstractItemView.SelectRows)
        self.tblView1.setVerticalScrollMode(QAbstractItemView.ScrollPerItem)
        self.tblView1.setHorizontalScrollMode(QAbstractItemView.ScrollPerItem)
        self.tblView1.setTabKeyNavigation(False)
        self.tblView1.setShowGrid(False)
        self.tblView1.setWordWrap(True)
        self.tblView1.setFrameShadow(QFrame.Plain)
        self.tblView1.horizontalHeader().setVisible(True)
        self.tblView1.horizontalHeader().setHighlightSections(True) # Default: False
        self.tblView1.verticalHeader().setVisible(False)
        self.tblView1.verticalHeader().setHighlightSections(False)
        self.tblView1.horizontalHeader().setStyleSheet("QHeaderView::section{font: 9pt; font-family:Mono; border-radius:0px; border-style: inset}")
        self.tblView1.setStyleSheet("border: 0px; alternate-background-color: #F7F7F7; selection-background-color: #579599")

        self.tblView2 = Table()
        self.tblView2.setMinimumSize(QSize(0, 0))
        self.tblView2.setBaseSize(QSize(-1, 0))
        self.tblView2.setVerticalScrollBarPolicy(Qt.ScrollBarAlwaysOn)
        self.tblView2.setProperty('showDropIndicator', False)
        self.tblView2.setAlternatingRowColors(True)
        self.tblView2.setSelectionBehavior(QAbstractItemView.SelectRows)
        self.tblView2.setVerticalScrollMode(QAbstractItemView.ScrollPerItem)
        self.tblView2.setHorizontalScrollMode(QAbstractItemView.ScrollPerItem)
        self.tblView2.setTabKeyNavigation(False)
        self.tblView2.setShowGrid(False)
        self.tblView2.setWordWrap(True)
        self.tblView2.setFrameShadow(QFrame.Plain)
        self.tblView2.horizontalHeader().setVisible(True)
        self.tblView2.horizontalHeader().setHighlightSections(True) # Default: False
        self.tblView2.verticalHeader().setVisible(False)
        self.tblView2.verticalHeader().setHighlightSections(False)
        self.tblView2.horizontalHeader().setStyleSheet("QHeaderView::section{font: 9pt; font-family:Mono; border-radius:0px; border-style: inset}")
        self.tblView2.setStyleSheet("border: 0px; alternate-background-color: #F7F7F7; selection-background-color: #579599;")

        # set layout
        self.vLayout1 = QVBoxLayout(self.vLayoutWidget1)
        self.vLayout1.setSpacing(1)
        self.vLayout1.setContentsMargins(0, 0, 0, 0)
        self.vLayout1.addWidget(self.toolBar1)
        self.vLayout1.addWidget(self.tblView1)
        self.hLayout1 = QHBoxLayout()
        self.hLayout1.addWidget(self.sb1)
        self.hLayout1.addWidget(self.sb3)
        self.vLayout1.addLayout(self.hLayout1)

        self.vLayout2 = QVBoxLayout(self.vLayoutWidget2)
        self.vLayout2.setSpacing(1)
        self.vLayout2.setContentsMargins(0, 0, 0, 0)
        self.vLayout2.addWidget(self.toolBar2)
        self.vLayout2.addWidget(self.tblView2)
        self.hLayout2 = QHBoxLayout()
        self.hLayout2.addWidget(self.sb2)
        self.hLayout2.addWidget(self.sb4)
        self.vLayout2.addLayout(self.hLayout2)

        self.gLayout = QGridLayout(self.centralwidget)
        self.gLayout.setContentsMargins(1, 1, 1, 1)
        self.gLayout.setSpacing(2)
        self.gLayout.addWidget(self.splitter, 0, 0, 1, 1)
        self.setCentralWidget(self.centralwidget)


        # VARIABLES-PRE-ADB
        self.on_offTable2(False)
        self.deviceConnected = False
        if DBridge.Custom(adb, fastboot).checkForDevice():
            self.deviceConnected = True
            self.on_offTable2(True)
        else:
            if device_ip[0].isdigit():
                DBridge.Adb(adb, fastboot)._connect(device_ip)
                if DBridge.Custom(adb, fastboot).checkForDevice():
                    print 'Connect to: '+device_ip
                    self.deviceConnected = True
        if self.deviceConnected:
            self.rootAccess = (True if DBridge.Custom(adb, fastboot)._HasRootAccess() else False)
            # restarts the adbd daemon with root permissions
            DBridge.Adb(adb, fastboot)._root()
        else:
            self.splitter.setSizes([1, 0])
            self.resize(600, 530)
        # VARIABLES
        self.srcSize = 0.0
        self.transfered = 0
        self.push_pull_value = 65536
        self.currLine1 = 0
        self.currLine2 = 0
        self.getEditor = getTextEditor()
        self.path1 = Home
        self.pathX1 = ['',Home]
        self.path2 = EXTERNAL_STORAGE()
        self.rootPath2 = ANDROID_ROOT()
        self.pathX2 = ['',self.path2]
        self.copyList = []
        self.moveList = []
        self.contextVar = 0
        self.ShowHidden1 = False
        self.ShowHidden2 = False
        self.mylist = []
        self.lineHistory1 = []
        self.lineHistory2 = []
        self.results = []

        # LEFT-TABLE
        self.tblView1.customContextMenuRequested.connect(self.contextMenu1)
        self.tblView1.setContextMenuPolicy(Qt.CustomContextMenu)
        self.tblView1.doubleClicked.connect(self.onDoubleClick1)
        self.connect(self.tblView1, SIGNAL("mouseForward"), self.mouseFor)
        self.connect(self.tblView1, SIGNAL("mouseBackward"), self.mouseBack)
        #self.connect(self.tblView1, SIGNAL("mouseMoved"), self.mouseMoved)
        self.tBtnRefresh1.clicked.connect(self.onBtnRefreshClick1)
        self.lineEdit1.setText(unicode(self.path1))
        self.lineEdit1.textChanged.connect(self.onLineEdit1)
        self.tBtnFav1.clicked.connect(self.MenuFavorites1)
        self.tBtnHist1.clicked.connect(self.MenuHistory1)
        self.tBtnRoot1.clicked.connect(self.onBtnRootClick1)
        self.tBtnHome1.clicked.connect(self.onBtnHomeClick1)
        self.tBtnBack1.clicked.connect(self.onBtnBackClick1)

        # RIGHT-TABLE
        self.tblView2.customContextMenuRequested.connect(self.contextMenu2)
        self.tblView2.setContextMenuPolicy(Qt.CustomContextMenu)
        self.tblView2.doubleClicked.connect(self.onDoubleClick2)
        self.connect(self.tblView2, SIGNAL("mouseForward"), self.mouseFor)
        self.connect(self.tblView2, SIGNAL("mouseBackward"), self.mouseBack)
        self.tBtnRefresh2.clicked.connect(self.onBtnRefreshClick2)
        self.lineEdit2.setText(unicode(self.path2))
        self.lineEdit2.textChanged.connect(self.onLineEdit2)
        self.tBtnRW.clicked.connect(self.onBtnRW)
        self.tBtnFav2.clicked.connect(self.MenuFavorites2)
        self.tBtnHist2.clicked.connect(self.MenuHistory2)
        self.tBtnRoot2.clicked.connect(self.onBtnRootClick2)
        self.tBtnHome2.clicked.connect(self.onBtnHomeClick2)
        self.tBtnBack2.clicked.connect(self.onBtnBackClick2)

        self.splitter.splitterMoved.connect(self.splitterSize)
        self.lbl = QLabel()
        self.lbl.setWindowFlags(Qt.SplashScreen)

        # INIT GUI
        self.loadBookmarks()
        self.pgwidget = ProgressWidget()
        self.propdialog = PropertiesDialog()
        self.tableView1()
        self.setTextStatusBar1(self.path1)
        self.tblView1.setFocus(True)
        if self.deviceConnected:
            self.tableView2()
            self.setTextStatusBar2(self.path2)
        self.move(QApplication.desktop().screen().rect().center()- self.rect().center())


    def on_offTable2(self,on_off=False):
        for t in [self.tblView2,self.lineEdit2,self.tBtnRW,self.tBtnHidden2,self.tBtnFav2,
                self.tBtnHome2,self.tBtnRoot2,self.tBtnBack2,self.tBtnHist2]:
                    t.setEnabled(on_off)
        #print '  window geometry:', (self.width(), self.height(), self.x(), self.y())
        #print '  splitter sizes:', self.splitter.sizes()
        if on_off:
            self.resize(900, 530)
            self.splitter.setSizes([550, 530, 0, 0])
        else:
            self.resize(600, 530)
            self.splitter.setSizes([1, 0])

# SPLITTER-LABEL #############################################################################################
    def splitterSize(self):
        v1 = self.vLayoutWidget1.size().width()
        v2 = self.vLayoutWidget2.size().width()
        Size = float(v1 + v2)
        text = '{0}|{1}'.format(int((100/Size)*v1), int((100/Size)*v2))
        self.lbl.setText(text)
        self.lbl.show()
        QTimer.singleShot(2000, self.lbl.hide)

# STATUSBAR ##################################################################################################
    def getSize(self, name, tbl):
        head,fallback = ['Size', 'Used', 'Free'],['0', '0', '0']
        cmd = u'df \"{0}\"'.format(name)
        if tbl == 0:
            text = unicode(DBridge.MyProcess(cmd))
        elif tbl == 1:
            text = DBridge.Adb(adb)._shell(cmd)
        else:
            return
        if (not text) or ('can\'t find' or 'No such file or directory') in text:
            return
        text = text.splitlines()
        for x in xrange(len(text)):
            text[x] = text[x].replace(' %', '').replace('%', '')
        if   len(text) > 2:     text = (text[1]+text[2]).split()
        elif len(text) == 2:    text = text[1].split()
        elif len(text) <= 1:    text = fallback
        try:
            #1-size, 2-used, 3-free
            text = [text[1], text[2], text[3]]
        except:
            text = fallback
        return zip(head, text)    

    @timetest
    def setTextStatusBar1(self, path):                
        if len(path.split('/')) <= 2: return
        sizes = self.getSize(path, 0)
        s = DBridge.MyProcess(u'du -sb \"{0}\"'.format(path))
        if len(s) > 0:
            s = list(set(re.findall('(\d.*)\t',s)))
            if len(s) > 0:
                s = s[0]
        if sizes:
            try:
                sizes = dict(sizes)
                size = human(int(sizes['Size'])*1024)
                free = human(int(sizes['Free'])*1024)
                used = human(int(sizes['Used'])*1024)
                realFolderSize = human(float(s))
                self.sb1.setText(' Dir: {3} | Size: {0} | Free: {1} | Used: {2}'.format(size, free, used, realFolderSize))
            except KeyError:
                self.sb1.setText('')
        else:
            self.sb1.setText('')

    def setTextStatusBar2(self, path):
        if len(path.split('/')) <= 2: return
        sizes = self.getSize(path, 1)
        if sizes:
            try:
                sizes = dict(sizes)
                size = human(int(sizes['Size'])*1024)
                free = human(int(sizes['Free'])*1024)
                used = human(int(sizes['Used'])*1024)
                self.sb2.setText(' Size: {0} | Free: {1} | Used: {2}'.format(size, free, used))
            except KeyError:
                self.sb2.setText('')
        else:
            self.sb2.setText('')

    def updateRowCount1(self):
        rows = str(len(self.tblView1.selectionModel().selectedRows()))
        if rows == '0':
            self.sb3.setText('')
            return
        self.sb3.setText(' '+rows)

    def updateRowCount2(self):
        rows = str(len(self.tblView2.selectionModel().selectedRows()))
        if rows == '0':
            self.sb4.setText('')
            return
        self.sb4.setText(' '+rows)

    def lineEditHistory(self, hList, item):
        hList.append(item)
        hList.insert(0,hList.pop())
        if len(hList) > 6:
            del hList[-1]
        return hList

# DIALOGS ####################################################################################################
    def msgPass(self):
        ret = QMessageBox.warning(self, 'Attention!', 'Continue?', '&Ok', '&Cancel', '', 0, 1)
        return (True if ret == 0 else False)

    def msgReboot(self):
        ret = QMessageBox.warning(self, 'Attention!', 'Reboot?', '&Ok', '&Cancel', '', 0, 1)
        return (True if ret == 0 else False)

    def msgUpload(self):
        ret = QMessageBox.warning(self, 'Attention!', 'Upload the modified file?', '&Ok', '&Cancel', '', 0, 1)
        return (True if ret == 0 else False)

    def msgDialog(self, lbl, txt='', default=''):
        text, ok = QInputDialog.getText(self, lbl, txt, QLineEdit().Normal, default)
        return (text if ok else False)

    def kill(self):
        DBridge.terminate()
        qApp.close()

    @pyqtSlot(QSystemTrayIcon.ActivationReason)
    def on_systemTrayIcon_activated(self, reason):
        if reason == QSystemTrayIcon.DoubleClick:
            (self.showNormal() if self.isHidden() else self.hide())

    def changeEvent(self, event):        
        if event.type() == QEvent.WindowStateChange:
            if self.windowState() & Qt.WindowMinimized:
                event.ignore()
                self.hide()
                return
        super(MyWindow, self).changeEvent(event)

    def closeEvent(self, e):
        #QTimer.singleShot(3000, self.kill)
        ret = QMessageBox.information(self, 'Quit...', 'Are you sure to quit?', '&Ok', '&Cancel', '', 0, 1)
        if ret == 0:
            if posixpath.isdir(TempDir):
                if os.listdir(TempDir) == []:
                    os.rmdir(TempDir)
            DBridge.terminate()
            e.accept()
        else:
            e.ignore()

# QPROCESS ###################################################################################################
    def qProc(self, cmd, log='', root='noRoot'):
        def readFromProcess():
            if log == 'out':
                #self.pgwidget.plainTextEdit.appendPlainText(unicode(qproc.readAll()))
                line = str(qproc.readAll())
                if line.find('DATA') >= 0:
                    self.transfered += self.push_pull_value
                    #print self.transfered
                    if self.transfered <= self.srcSize:
                        if self.push_pull_value == 65544:
                            value = int((self.transfered / self.srcSize) * 1000)
                        else:
                            value = int((self.transfered / self.srcSize) * 100)
                        self.pgwidget.pgBar.setValue(value)
                        self.test.setText("{0}% -> {1}".format(value, cmd))

                    else:
                        self.pgwidget.pgBar.setValue(100)
                        self.test.setText("100% -> {0}".format(cmd))
            elif log == 'cmd':
                self.pgwidget.plainTextEdit.appendPlainText(unicode(cmd))
            else:
                pass
        if   root == 'noRoot':
            pass
        elif root == 'Root':
            cmd = '{0} \"{1}\"'.format(sudoGUI, cmd)
        else:
            return
        env = QProcessEnvironment.systemEnvironment()
        env.insert("ADB_TRACE", "1")
        qproc = QProcess()
        qproc.setProcessEnvironment(env)
        qproc.readyRead.connect(readFromProcess)
        #qproc.started.connect(lambda: self.pgwidget.BtnClose.setEnabled(False))
        #qproc.finished.connect(lambda: self.pgwidget.startTimerEvent())
        qproc.setProcessChannelMode(QProcess.MergedChannels)
##        qproc.start(cmd)
##        qproc.waitForStarted()
##        while (qproc.state() == QProcess.Running):
##            if self.pgwidget.getKillProcVar():
##                self.pgwidget.setKillProcVar()
##                break
##            qApp.processEvents()
##            time.sleep(0.002)

        self.results.append(cmd)
        i = 0
        n = len(self.results)
        while i < n:
            self.test = Label()
            qproc.started.connect(lambda: self.test.showAction())
            qproc.finished.connect(lambda: self.test.hideAction())
            e = self.results[i]
            print e, len(self.results)
            qproc.start(e)
            qproc.waitForStarted()
            while (qproc.state() == QProcess.Running):
                qApp.processEvents()
                time.sleep(0.002)
            if qproc.state() == 0:
                del self.results[i]
                n-=1
                i+=1

# EXECUTE BATCH-MODE #########################################################################################
    def executeBatch(self, names, cmds, mode, dialog=True):
        def worker(cmd):
            if mode == 'shell':
                self.qProc(u'{0} shell {1}'.format(adb, cmd), 'out')
            elif mode == 'pull':
                src, out = cmd
                self.srcSize = float(int(DBridge.Adb(adb)._shell('du -k \"{0}\"'.format(src)).split()[0])*1024)
                self.pgwidget.pgBar.setMaximum(100)
                self.transfered = 0
                self.push_pull_value = 65536
                self.qProc(u'{0} pull \"{1}\" \"{2}\"'.format(adb, src, out), 'out')
            elif mode == 'push':
                src, out = cmd
                self.srcSize = float(os.path.getsize(src))
                self.pgwidget.pgBar.setMaximum(100)
                self.transfered = 0
                self.push_pull_value = 65544
                self.qProc(u'{0} push \"{1}\" \"{2}\"'.format(adb, src, out), 'out')
            elif mode == 'popen':
                cmd = cmd.replace('\'', '\\\'').replace('!', '\!').replace('[', '\[').replace(']', '\]')
                self.qProc(cmd, '')
        try:
            if dialog:
                self.pgwidget.show()
            for i in xrange(len(cmds)):
                if self.pgwidget.getKillProcVar():
                    self.pgwidget.setKillProcVar()
                    break
                name, cmd = names[i], cmds[i]
                self.pgwidget.plainTextEdit.appendPlainText(unicode(name))
                qApp.processEvents()
                worker(cmd)
                if mode != ('push' or 'pull'):
                    self.pgwidget.pgBar.setValue(0)
                    self.pgwidget.pgBar.setMaximum(len(cmds))
                    self.pgwidget.pgBar.setValue(i+1)
                else:
                    self.pgwidget.plainTextEdit.verticalScrollBar().setValue(self.pgwidget.plainTextEdit.verticalScrollBar().maximum())
        except Exception, e:
            print e
            self.pgwidget.plainTextEdit.appendPlainText(unicode(e))
            pass
        finally:
            cmds = []

# INIT-TABLEVIEW #############################################################################################
    def maintableView(self, p, tblViewVar, tblModelVar):
        def splitData(liste):
            from datetime import datetime
            n,m=[],[]
            liste = unicode(liste)
            # jump if no valid values
            for x in liste.splitlines():                
                if (len(x.split()) < 4) or ('No such file or directory' in x):
                    continue
                s = x.split()
                if len(s) <= 2: continue
                # cut first 5 elements of list
                s1 = s[:5]
                # insert B for Byte if size is only number and not M or G
                if s1[-1].isdigit():
                    s1[-1] = s1[-1]+'B'
                # date detection 1. Jan
                if '.' in s[5]:
                    s2 = [''.join(s[5:7])]
                    s2 = [s2[0].decode('utf-8')]
                else:
                    s2 = [s[5]]
                # time detection 00:00
                if ':' in s[6]:            
                    s2 = s[5]                    
                    s3 = s[6]
                    s4 = ' '.join(s[7:])                    
                else:
                    # date corretion
                    s2 = s[5]+' '+s[6]                    
                    s3 = s[7]
                    s4 = ' '.join(s[8:])
                # link correction
                if ' -> ' in s4:            
                    s4 = s4.split('->')[0]
                # insert 00:00 if no time is in data, correct date with '-', correct date
                if not ':' in s3:            
                    a = s2.split()
                    s2 = '-'.join([s3[2:],a[1].decode('utf-8'),a[0].replace('.','')])
                    s3 = '00:00'
                else:
                    # if no year, insert current, correct date
                    if (' ' in s2) and not ('-' in s2):                        
                        a = s2.split()                        
                        s2 = '-'.join([str(datetime.now().year)[2:],a[1],a[0].replace('.','')])

                # s2[2:] cut year number
                n = s1+[s2]+[s3]+[s4]
                # replace month-name with number
                d = {'01':'Jan','02':'Feb','03':'Mar','04':'Apr','05':'May','06':'Jun',
                     '07':'Jul','08':'Aug','09':'Sep','10':'Oct','11':'Nov','12':'Dec'}
                e = {'03':'Mär','05':'Mai','10':'Okt','12':'Dez'}
                for (k,v) in d.items():
                    if v in n[5]:
                        n[5] = n[5].replace(v,k)
                for (k,v) in e.items():
                    if v in n[5]:
                        n[5] = n[5].replace(v,k)                        
                # correct date, if day is single number fill with 0
                f = n[5].split('-')
                n[5] = '-'.join(f[0:2]+[f[-1].rjust(2, "0")])                
                # ist -> permission,count,owner,group,size,date,time,filename        
                # soll -> filename,size,date,time,owner,group,permission
                m.append([unicode(n[-1]),n[4],n[5],n[6],n[2],n[3],n[0]])
            return m

        def sortData(liste):
            # sort all rows in a specific order (unixre.compile(u'\d\w+\s(.*)\s+')
            #like: hidden folders, folders, hidden files, files)
            l1, l2, l3, l4 = [],[],[],[]
            for t in liste:
                if (t[0] == '.') or (t[0] == '..'):
                    continue
                if     t[-1].startswith(('d','l')) and     t[0].startswith('.'): l1.append(t)
                if     t[-1].startswith(('d','l')) and not t[0].startswith('.'): l2.append(t)
                if not t[-1].startswith(('d','l')) and     t[0].startswith('.'): l3.append(t)
                if not t[-1].startswith(('d','l')) and not t[0].startswith('.'): l4.append(t)
            return sorted(l1+l2, key=lambda s: s[0].lower()) + sorted(l3+l4, key=lambda s: s[0].lower())

        # local (pc)
        if tblModelVar == 1:
            stdouterr = DBridge.MyProcess(u'ls -{0} \"{1}\"'.format(p, self.path1))
        # remote (android)
        elif tblModelVar == 2:
            if self.deviceConnected:
                cmd = 'ls -{0} \"{1}\" --color=never'.format(p, self.path2)
                if not self.rootAccess:
                    cmd = u"su -c \'{0}\'".format(cmd)
                stdouterr = DBridge.Adb(adb)._shell(cmd)
        else:
            stdouterr = ''
        out = []
        out = sortData(splitData(stdouterr))
        self.mylist = out

        tblViewVar.setSortingEnabled(True) # Default: False
        
        tblViewVar.setModel(MyTableModel(self, out, ['filename', 'size', 'date', 'time', 'owner', 'group', 'permission']))
        try:
            self.tblView1.selectionModel().selectionChanged.connect(self.updateRowCount1)
            if self.deviceConnected:
                self.tblView2.selectionModel().selectionChanged.connect(self.updateRowCount2)
        except AttributeError:
            pass
        tblViewVar.hideColumn(4) # hide owner
        tblViewVar.hideColumn(5) # hide group
        #tblViewVar.horizontalHeader().setDefaultSectionSize(35)
        tblViewVar.verticalHeader().setDefaultSectionSize(20)        
        tblViewVar.resizeColumnsToContents()
        tblViewVar.horizontalHeader().setResizeMode(0, QHeaderView.Stretch)

# USEFUL TABLE-FUNCTIONS #####################################################################################
    def mainGetRows(self, tblModeVar, name_path=False):
        FileName = u''
        FilePath = u''
        FileNameOut = []
        FilePathOut = []
        IsDir = ''

        if tblModeVar == 1:
            tblView = self.tblView1
            path = self.path1
        elif tblModeVar == 2:
            tblView = self.tblView2
            path = self.path2
        tblView.setFocus(True)
        rows = tblView.selectionModel().selectedRows()
        if rows:
            for i in rows:
                tblViewDataAtRow = tblView.model().getRow(i.row())
                if tblModeVar == 1:
                    FilePath = posixpath.join(unicode(path), unicode(tblViewDataAtRow[0]))
                elif tblModeVar == 2:
                    FilePath = posixpath.join(unicode(path), unicode(tblViewDataAtRow[0]))
                FileName = unicode(tblViewDataAtRow[0])
                d = tblViewDataAtRow[-1]
                if unicode(d).startswith('d'):
                    IsDir = 'dir'
                else:
                    IsDir = 'file'
                FileNameOut.append((FileName, IsDir))
                FilePathOut.append((FilePath, IsDir))
            return (FileNameOut if name_path else FilePathOut)

    def getRow(self, tblModeVar, col=None):
        data = []
        if tblModeVar == 1:
            tblView = self.tblView1
        elif tblModeVar == 2:
            tblView = self.tblView2
        for i in tblView.selectionModel().selectedRows():
            tblViewDataAtRow = tblView.model().getRow(i.row())
            if col == None:
                data.append(tblViewDataAtRow)
            else:
                data.append(tblViewDataAtRow[col])
        return data

    def inTable(self, text, tblModeVar, col=0):
        ret = False
        if tblModeVar == 1:
            tblView = self.tblView1
        elif tblModeVar == 2:
            tblView = self.tblView2
        for i in range(tblView.model().rowCount()):
            if text in tblView.model().getRow(i)[col]:
                ret = True
        return ret

# TABLEVIEW-1 CONTEXTMENU #####################################################################################
    def tbl1_paste(self):
        vName, v0 = [], []
        path = self.path1
        if not self.moveList:
            for i, k in self.copyList:
                dirname = posixpath.dirname(i)
                basename = posixpath.basename(i)
                vName.append(basename)
                if dirname == path:
                    path = posixpath.join(dirname,"_"+basename)
                cmd = u'cp -f \"{0}\" \"{1}\"'.format(i, path)
                if k == 'dir':
                    cmd = u'cp -rf \"{0}\" \"{1}\"'.format(i, path)
                if not isWritable(path):
                    cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
                v0.append(cmd)
            self.copyList = []
            self.executeBatch(vName, v0, 'popen')
        elif not self.copyList:
            for i, k in self.moveList:
                vName.append(posixpath.basename(i))
                cmd = u'mv -f \"{0}\" \"{1}\"'.format(i, path)
                if not isWritable(path):
                    cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
                v0.append(cmd)
            self.moveList = []
            self.executeBatch(vName, v0, 'popen')
        else:
            return
        self.tableView1()

    def tbl1_pasteAsSymbolic(self):
        l, vName, v0 = [],[],[]
        path = self.path1
        if self.moveList:
            l = self.moveList
        elif self.copyList:
            l = self.copyList
        else:
            return
        self.moveList = []
        self.copyList = []
        for i, k in l:
            dirname = posixpath.dirname(i)
            basename = posixpath.basename(i)
            vName.append(basename)
            if dirname == path:
                path = posixpath.join(dirname,"_"+basename)
            vName.append(basename)
            linkName = posixpath.join(path,basename)
            cmd = u'ln -s \"{0}\" \"{1}\"'.format(i, linkName)
            if not isWritable(path):
                cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
            v0.append(cmd)
        self.executeBatch(vName, v0, 'popen')
        self.tableView1()

    def tbl1_rename(self):
        rows = self.mainGetRows(1)
        if not rows:
            return
        text = self.msgDialog('Rename', 'Enter new name:', self.mainGetRows(1, True)[0][0])
        if not text:
            return
        cmd = u'mv -f \"{0}\" \"{1}\"'.format(rows[0][0],posixpath.normpath(posixpath.join(self.path1, unicode(text))))
        if not isWritable(self.path1):
            cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
        self.qProc(cmd, '')
        self.tableView1()

    def tbl1_delete(self):
        rows = self.mainGetRows(1)
        if not rows:
            return
        if self.msgPass():
            vName,vName1, v0, v1 = [], [], [], []
            for i, k in rows:
                vName.append(posixpath.basename(i))
                vName1.append(posixpath.basename(i))
                if (self.path1 == HomeTrash) or isExternalDrive(self.path1):
                    cmd = u'rm -f \"{0}\"'.format(i)
                    if k == 'dir':
                        cmd = u'rm -rf \"{0}\"'.format(i)
                else:
                    cmd = u'mv -f \"{0}\" \"{1}\"'.format(i, HomeTrash)
                if not isWritable(self.path1):
                    cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
                print cmd
                v0.append(cmd)
            self.executeBatch(vName, v0, 'popen')
            self.tableView1()
        else:
            return

    def tbl1_deleteSecure(self):
        rows = self.mainGetRows(1)
        if not rows:
            return
        if self.msgPass():
            vName, v0 = [], []
            for i, k in rows:
                vName.append(posixpath.basename(i))
                cmd = u'srm -v -l \"{0}\"'.format(i)
                if k == 'dir':
                    cmd = u'srm -v -l -r \"{0}\"'.format(i)
                if not isWritable(self.path1):
                    cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
                v0.append(cmd)
            self.executeBatch(vName, v0, 'popen')
            self.tableView1()
        else:
            return

    def tbl1_chmod(self, perm):
        vName, v0 = [], []
        def recursive_file_permissions(path,mode):
            for item in glob.glob(path+'/*'):
                if posixpath.isdir(item):
                    recursive_file_permissions(posixpath.join(path,item),mode)
                else:
                    try:
                        cmd = 'chmod {0} \"{1}\"'.format(mode,posixpath.join(path,item))
                        if not isWritable(path):
                            cmd = '{0} \"{1}\"'.format(sudoGUI, cmd)
                        vName.append(posixpath.join(path,item))
                        v0.append(cmd)
                    except Exception, e:
                        print e
        for i, k in self.mainGetRows(1):
            if posixpath.isdir(i):
                recursive_file_permissions(i, perm)
            else:
                cmd = 'chmod {0} \"{1}\"'.format(perm,i)
                if not isWritable(self.path1):
                    cmd = '{0} \"{1}\"'.format(sudoGUI, cmd)
                vName.append(posixpath.basename(i))
                v0.append(cmd)
        self.executeBatch(vName, v0, 'popen', False)
        self.tableView1()

    def extractLocal(self, archive, extract_path='.'):
        vName, v0 = [], []
        rows = self.mainGetRows(1)
        if len(rows) == 1:
            DBridge.MyProcess(u'xdg-open \"{0}\"'.format(archive))
        else:
            for i, k in rows:
                extract_path = posixpath.splitext(i)[0]
                vName.append(posixpath.basename(i))
                if i.endswith(('.tgz', '.tar.gz', '.tar.bz2','7z', '.arj', '.cab', '.chm', '.cpio', '.dmg', '.hfs', '.lzh', '.lzma',
                                    '.nsis', '.udf', '.wim', '.xar', '.z', '.zip', '.gzip', '.tar', '.apk')):
                    cmd = u'7z x -mmt -y \"{0}\" -o\"{1}\"'.format(i, extract_path)
                    if not isWritable(posixpath.dirname(i)):
                        cmd = u'{0} \"7z x -mmt -y \"{1}\" -o\"{2}\"\"'.format(sudoGUI, i, extract_path)
                    v0.append(cmd)
            self.executeBatch(vName, v0, 'popen')
        self.tableView1()

    def contextMenuLocal(self, pos):
        menu = QMenu()
        pushAction              = menu.addAction('Copy to Android')
        menu.addSeparator()
        OPENmenu                = menu.addMenu('Open')
        termAction              = OPENmenu.addAction('Terminal')
        OPENmenu.addSeparator()
        openAction              = OPENmenu.addAction('Open')
        ropenAction             = OPENmenu.addAction('Open as Root')
        OPENmenu.addSeparator()
        editAction              = OPENmenu.addAction(posixpath.basename(self.getEditor))
        reditAction             = OPENmenu.addAction('{0} as Root'.format(posixpath.basename(self.getEditor)))
        OPENmenu.addSeparator()
        extractAction           = OPENmenu.addAction('Extract')
        extract_toAction        = OPENmenu.addAction('Extract to')
        NEWmenu                 = menu.addMenu('New')
        newfileAction           = NEWmenu.addAction('Create file')
        newfolderAction         = NEWmenu.addAction('Create folder')
        newarchiveAction        = NEWmenu.addAction('Create tar.gz')
        menu.addSeparator()
        selectAllAction         = menu.addAction('Select All')
        selectNoneAction         = menu.addAction('Select None')
        menu.addSeparator()
        moveAction              = menu.addAction('Cut')
        copyAction              = menu.addAction('Copy')
        pasteAction             = menu.addAction('Paste')
        symLinkAction           = menu.addAction('Symbolic-Link')
        renameAction            = menu.addAction('Rename')
        delAction               = menu.addAction('Delete')
        menu.addSeparator()
        delSecureAction         = menu.addAction('Secure-Delete')
        menu.addSeparator()
        pkgAction               = menu.addAction('Install')
        menu.addSeparator()
        showHidden              = menu.addAction('Show hidden')
        chmodAction             = menu.addAction('Info')
        CHMODmenu               = menu.addMenu('Quick')
        chmod_0400              = CHMODmenu.addAction('r--------')
        chmod_0600              = CHMODmenu.addAction('rw-------')
        chmod_0700              = CHMODmenu.addAction('rwx------')
        chmod_0440              = CHMODmenu.addAction('r--r-----')
        chmod_0640              = CHMODmenu.addAction('rw-r-----')
        chmod_0660              = CHMODmenu.addAction('rw-rw----')
        chmod_0750              = CHMODmenu.addAction('rwxr-x---')
        chmod_0770              = CHMODmenu.addAction('rwxrwx---')
        chmod_0444              = CHMODmenu.addAction('r--r--r--')
        chmod_0644              = CHMODmenu.addAction('rw-r--r--')
        chmod_0666              = CHMODmenu.addAction('rw-rw-rw-')
        chmod_0744              = CHMODmenu.addAction('rwxr--r--')
        chmod_0755              = CHMODmenu.addAction('rwxr-xr-x')
        chmod_0777              = CHMODmenu.addAction('rwxrwxrwx')
        chmod_1777              = CHMODmenu.addAction('rwxrwxrwt')

        self.pgwidget.plainTextEdit.clear()
        self.pgwidget.pgBar.reset()

        # check if android device is available
        if not self.deviceConnected:
            pushAction.setEnabled(False)
        else:
            pushAction.setEnabled(True)

        # check if copy/move list is empty
        if self.copyList or self.moveList:
            pasteAction.setEnabled(True)
            symLinkAction.setEnabled(True)
        else:
            pasteAction.setEnabled(False)
            symLinkAction.setEnabled(False)

        rows = self.mainGetRows(1)
        # check if table is empty
        if rows:
            for d in [pushAction, OPENmenu, newarchiveAction, moveAction, copyAction,
                      renameAction, delAction, delSecureAction, pkgAction, chmodAction, CHMODmenu]:
                d.setEnabled(True)
        else:
            for d in [pushAction, openAction, ropenAction, editAction, reditAction, extractAction, extract_toAction,
                      newarchiveAction, moveAction, copyAction, renameAction, delAction, delSecureAction, pkgAction, chmodAction, CHMODmenu]:
                d.setEnabled(False)

        action = menu.exec_(self.tblView1.mapToGlobal(pos+QPoint(5, -55)))
        if action == pushAction:
            if self.msgPass():
                if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                    DBridge.Custom(adb, fastboot)._remount(self.path2)
                vName, v0 = [], []
                for i, k in rows:
                    vName.append(posixpath.basename(i))
                    out = posixpath.normpath(posixpath.join(unicode(self.path2), posixpath.basename(i)))
                    v0.append((i, out))
                self.executeBatch(vName, v0, 'push')
                self.tableView2()
            else:
                return
        elif action == termAction:
            DBridge.MyProcess(u'{0} --working-directory={1}'.format(getTerminal(),self.path1))
        elif action == openAction:
            if rows[0][1] == 'file':
                DBridge.MyProcess(u'xdg-open \"{0}\"'.format(rows[0][0]))
            else:
                return
            self.tableView1()
        elif action == ropenAction:
            if rows[0][1] == 'file':
                DBridge.MyProcess(u'{0} \"xdg-open \"{1}\"\"'.format(sudoGUI, rows[0][0]))
            self.tableView1()
        elif action == editAction:
            if rows[0][1] == 'file':
                DBridge.MyProcess(u'{0} \"{1}\"'.format(self.getEditor, rows[0][0]))
            self.tableView1()
        elif action == reditAction:
            if rows[0][1] == 'file':
                DBridge.MyProcess(u'{0} \"{1} \"{2}\"\"'.format(sudoGUI, self.getEditor, rows[0][0]))
            self.tableView1()
        elif action == extractAction:
            if rows[0][1] == 'file':
                self.extractLocal(rows[0][0], posixpath.splitext(rows[0][0])[0])
            self.tableView1()
        elif action == extract_toAction:
            text = self.msgDialog('Extract to', 'Enter path:', posixpath.splitext(rows[0][0])[0])
            if not text:
                return
            if rows[0][1] == 'file':
                self.extractLocal(rows[0][0], posixpath.normpath(unicode(text)))
                DBridge.MyProcess(u'xdg-open \"{0}\"'.format(archive))
            self.tableView1()
        elif action == newfileAction:
            text = self.msgDialog('Create New File', 'Filename:')
            if not text:
                return
            cmd = u'cp /dev/null \"{0}\"'.format(posixpath.normpath(posixpath.join(self.path1, unicode(text))))
            if not isWritable(self.path1):
                cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
            self.qProc(cmd, '')
            self.tableView1()
        elif action == newfolderAction:
            text = self.msgDialog('Create New Folder', 'Foldername:')
            if not text:
                return
            os.mkdir(posixpath.normpath(posixpath.join(self.path1, unicode(text))))
            self.tableView1()
        elif action == newarchiveAction:
            name = posixpath.join(self.path1, self.mainGetRows(1, True)[0][0])
            name += '-'+strftime('%H%M%S', gmtime())
            x = ' '.join(['\"'+posixpath.basename(i)+'\"' for i, k in rows])
            cmd = u'tar -hvc --gzip -f \"{0}.tar.gz\" -C \"{1}\" {2}'.format(name, self.path1, x)
            self.pgwidget.show()
            self.qProc(cmd, 'out')
            self.tableView1()
        elif action == selectAllAction:
            self.tblView1.selectAll()
        elif action == selectNoneAction:
            self.tblView1.clearSelection()
        elif action == moveAction:
            #self.tbl1_cut()
            self.moveList = []
            self.moveList = self.mainGetRows(1)
        elif action == copyAction:
            #self.tbl1_copy()
            self.copyList = []
            self.copyList = self.mainGetRows(1)
        elif action == pasteAction:
            self.tbl1_paste()
        elif action == symLinkAction:
            self.tbl1_pasteAsSymbolic()
        elif action == renameAction:
            self.tbl1_rename()
        elif action == delAction:
            self.tbl1_delete()
        elif action == delSecureAction:
            self.tbl1_deleteSecure()
        elif action == pkgAction:
            if self.msgPass():
                self.pgwidget.show()
                self.pgwidget.pgBar.setMaximum(len(rows))
                x = 0
                self.pgwidget.pgBar.setValue(0)
                for i, k in rows:
                    if self.pgwidget.getKillProcVar():
                        self.pgwidget.setKillProcVar()
                        return
                    self.pgwidget.plainTextEdit.appendPlainText(unicode(i))
                    if i.endswith('.rpm'):
                        self.qProc(u'rpm -i \"{1}\"'.format(i), 'out', 'Root')
                    elif i.endswith('.deb'):
                        self.qProc(u'dpkg -i \"{0}\"'.format(i), 'out', 'Root')
                    elif i.endswith('.exe'):
                        self.qProc(u'wine \"{0}\"'.format(i), 'out')
                    elif i.endswith('.msi'):
                        self.qProc(u'start \"{0}\"'.format(i), 'out')
                    elif i.endswith('.apk'):
                        o = DBridge.Adb(adb, 'cmd')._install(i, '-r')
                        self.pgwidget.plainTextEdit.appendPlainText(unicode(o))
                    else:
                        QMessageBox().information(self, 'Attention!', 'Unknown package-format!')
                        return
                    x += 1
                    self.pgwidget.pgBar.setValue(x)
            else:
                return
        elif action == showHidden:
            self.ShowHidden1 = (False if self.ShowHidden1 else True)
            self.tableView1()
        elif action == chmodAction:
            row = self.getRow(1)
            owner, group, perm = row[0][4], row[0][5], row[0][-1]
            self.propdialog.fillStat(rows[0][0],True)
            self.propdialog.fillLayout(owner, group, perm)
            text = self.propdialog.exec_()
            if text == [perm[1:],owner+'.'+group]:
                return
            vName, v0 = [], []
            for i, k in rows:
                vName.append(posixpath.basename(i))
                if (self.propdialog.getPerm() in perm) and (text[1] == '.'.join([owner, group])):
                    print "Skipped, no changes!"
                    continue
                elif (self.propdialog.getPerm() in perm) and (text[1] != '.'.join([owner, group])):
                    print "only owner was changed"
                    cmd = u'chown {0[1]} \"{1}\"'.format(text,i)
                elif (self.propdialog.getPerm() not in perm) and (text[1] == '.'.join([owner, group])):
                    print "only permission was changed"
                    cmd = u'chmod {0[0]} \"{1}\"'.format(text,i)
                elif (self.propdialog.getPerm() not in perm) and (text[1] != '.'.join([owner, group])):
                    print "owner and permission were changed"
                    cmd = u'chmod {0[0]} \"{1}\" ; chown {0[1]} \"{1}\"'.format(text,i)
                else:
                    print "something wrong, skip all..."
                    continue
                if not isWritable(self.path1):
                    cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
                v0.append(cmd)
            self.executeBatch(vName, v0, 'popen')
            self.tableView1()
        else:
            l = ['0400','0600','0700','0440','0640','0660','0750','0770','0444','0644','0666','0744','0755','0777','1777']
            m = [chmod_0400,chmod_0600,chmod_0700,chmod_0440,chmod_0640,chmod_0660,chmod_0750,chmod_0770,
                chmod_0444,chmod_0644,chmod_0666,chmod_0744,chmod_0755,chmod_0777,chmod_1777]
            for x,y in enumerate(l):
                if action == m[x]:
                    self.tbl1_chmod(y)
        return

# TABLEVIEW-2 CONTEXTMENU ####################################################################################
    def tbl2_paste(self):
        if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
            DBridge.Custom(adb, fastboot)._remount(self.path2)
        vName, v0 = [], []
        path = self.path2
        if not self.moveList:
            self.pgwidget.show()
            for i, k in self.copyList:
                vName.append(posixpath.basename(i))
                dirname = posixpath.dirname(i)
                basename = posixpath.basename(i)
                if k == 'dir':
                    v0.append('cp -rf \"{0}\" \"{1}\"'.format(i, path))
                elif k == 'file':
                    if dirname == path:
                        path = posixpath.join(dirname,"_"+basename)
                    v0.append('cp -f \"{0}\" \"{1}\"'.format(i, path))
            self.copyList = []
            self.executeBatch(vName, v0, 'shell')
        elif not self.copyList:
            self.pgwidget.show()
            for i, k in self.moveList:
                vName.append(posixpath.basename(i))
                v0.append('mv -f \"{0}\" \"{1}\"'.format(i, path))
            self.moveList = []
            self.executeBatch(vName, v0, 'shell')
        else:
            return
        self.tableView2()

    def tbl2_pasteAsSymbolic(self):
        l, vName, v0 = [],[],[]
        path = self.path2
        if self.moveList:
            l = self.moveList
        elif self.copyList:
            l = self.copyList
        else:
            return
        self.moveList = []
        self.copyList = []
        for i, k in l:
            dirname = posixpath.dirname(i)
            basename = posixpath.basename(i)
            vName.append(basename)
            if dirname == path:
                path = posixpath.join(dirname,"_"+basename)
            vName.append(basename)
            linkName = posixpath.join(path,basename)
            cmd = 'ln -s \"{0}\" \"{1}\"'.format(i, linkName)
            v0.append(cmd)
        self.executeBatch(vName, v0, 'shell')
        self.tableView2()

    def tbl2_rename(self):
        rows = self.mainGetRows(2)
        if not rows:
            return
        if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
            DBridge.Custom(adb, fastboot)._remount(self.path2)
        text = self.msgDialog('Rename', 'Enter new name:', self.mainGetRows(2, True)[0][0])
        if not text:
            return
        DBridge.Adb(adb)._shell('mv -f \"{0}\" \"{1}\"'.format(rows[0][0], posixpath.normpath(posixpath.join(self.path2, unicode(text)))))
        self.tableView2()

    def tbl2_delete(self):
        rows = self.mainGetRows(2)
        if not rows:
            return
        if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
            DBridge.Custom(adb, fastboot)._remount(self.path2)
        if self.msgPass():
            vName, v0 = [], []
            for i, k in rows:
                vName.append(posixpath.basename(i))
                if k == 'file':
                    v0.append('rm -f \"{0}\"'.format(i))
                elif k == 'dir':
                    v0.append('rm -rf \"{0}\"'.format(i))
            self.executeBatch(vName, v0, 'shell')
            self.tableView2()
        else:
            return

    def tbl2_chmod(self, perm):
        if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
            DBridge.Custom(adb, fastboot)._remount(self.path2)
        vName, v0 = [], []
        for i, k in self.mainGetRows(2):
            vName.append(posixpath.basename(i))
            v0.append('chmod {0} \'{1}\''.format(perm, i))
        self.executeBatch(vName, v0, 'shell', False)
        self.tableView2()

    def extractRemote(self, archive, extract_path='.'):
        if not self.inTable(extract_path, 2):
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            DBridge.Adb(adb)._shell(u'mkdir \"{0}\"'.format(extract_path))
        if archive.endswith(('.tar', '.tgz', '.tar.gz')):
            cmd = 'tar -xf \"{0}\" -C \"{1}\"'.format(archive, extract_path)
        elif archive.endswith(('.tar.bz2')):
            cmd = 'tar -xjf \"{0}\" -C \"{1}\"'.format(archive, extract_path)
            return
        elif archive.endswith(('.zip', '.apk')):
            cmd = 'unzip -qo \"{0}\" -d \"{1}\"'.format(archive, extract_path)
        else:
            return
        DBridge.Adb(adb, 'out')._shell(cmd)


    def slotpermission(self, PKGLINES, window=True):
        if not DBridge.Custom(adb, fastboot).checkForDevice():
            return
        if not PKGLINES:
            return
        self.pgwidget.plainTextEdit.clear()
        if window:
            self.pgwidget.show()
        TOTAL = len(PKGLINES)
        self.pgwidget.pgBar.setMaximum(TOTAL)

        outText = 'Fixing permissions...'
        self.pgwidget.plainTextEdit.appendPlainText(outText)
        print outText
        DBridge.Adb(adb)._remount()
        for i, CODEPATH in enumerate(PKGLINES):
            if self.pgwidget.getKillProcVar():
                self.pgwidget.setKillProcVar()
                return
            data = DBridge.Adb(adb)._shell('grep {0} /data/system/packages.xml'.format(CODEPATH))
            PKGNAME = re.findall('.*?name=\"(.*?)\"', data)[0]
            PKGGID = PKGUID = re.findall('.*?serId=\"(.*?)\"', data)[0]
            DATAPATH = '/data/data/{0}'.format(PKGNAME)
            self.pgwidget.plainTextEdit.appendPlainText('{0} ({1}, {2})'.format(CODEPATH, PKGNAME, PKGUID))
            print '{0} ({1}, {2})'.format(CODEPATH, PKGNAME, PKGUID)
            APPDIR = DBridge.Adb(adb)._shell('dirname {0}'.format(DATAPATH))
            if APPDIR == '/system/app':
                DBridge.Adb(adb)._shell('chown 0 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('chown :0 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('chmod 644 {0}'.format(CODEPATH))
            elif APPDIR == '/data/app':
                DBridge.Adb(adb)._shell('chown 1000 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('chown :1000 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('chmod 644 {0}'.format(CODEPATH))
            elif APPDIR == '/data/app-private':
                DBridge.Adb(adb)._shell('chown 1000 {0}'.format(CODEPATH))
                DBridge.Adb(adb)._shell('chown :{0} {1}'.format(PKGUID, CODEPATH))
                DBridge.Adb(adb)._shell('chmod 640 {0}'.format(CODEPATH))

            DBridge.Adb(adb)._shell('chmod 755 {0}'.format(DATAPATH))
            DBridge.Adb(adb)._shell('chown -R {0} {1}'.format(PKGUID, DATAPATH))
            DBridge.Adb(adb)._shell('chown -R :{0} {1}'.format(PKGUID, DATAPATH))
            DBridge.Adb(adb)._shell('chown {0} {1}'.format(PKGUID, CODEPATH))
            DBridge.Adb(adb)._shell('chown :{0} {1}'.format(PKGUID, CODEPATH))

            DIRS = DBridge.Adb(adb)._shell('find {0} -mindepth 1 -type d'.format(DATAPATH)).splitlines()
            self.pgwidget.pgBar.setValue(0)
            for f in DIRS:
                PERM=755
                FNAME=DBridge.Adb(adb)._shell('basename {0}'.format(f)).splitlines()
                if 'lib' in FNAME:
                    DBridge.Adb(adb)._shell('chmod 755 {0}'.format(f))
                    PKGUID=1000
                    PKGGID=1000
                    PERM=755
                elif 'shared_prefs' in FNAME:
                    DBridge.Adb(adb)._shell('chmod 771 {0}'.format(f))
                    PERM=660
                elif 'databases' in FNAME:
                    DBridge.Adb(adb)._shell('chmod 771 {0}'.format(f))
                    PERM=660
                elif 'cache' in FNAME:
                    DBridge.Adb(adb)._shell('chmod 771 {0}'.format(f))
                    PERM=600
                else:
                    DBridge.Adb(adb)._shell('chmod 771 {0}'.format(f))
                    PERM=771

                DBridge.Adb(adb)._shell('chown {0} {1}'.format(PKGUID, f))
                DBridge.Adb(adb)._shell('chown :{0} {1}'.format(PKGGID, f))
                DBridge.Adb(adb)._shell('find {0} -type f -maxdepth 1 ! -perm {1} -exec chmod {1} {2} \';\''.format(f, PERM, '{}'))
                DBridge.Adb(adb)._shell('find {0} -type f -maxdepth 1 ! -user {1} -exec chown {1} {2} \';\''.format(f, PKGUID, '{}'))
                DBridge.Adb(adb)._shell('find {0} -type f -maxdepth 1 ! -group {1} -exec chown :{1} {2} \';\''.format(f, PKGGID, '{}'))
            self.pgwidget.plainTextEdit.appendPlainText(unicode('({0} of {1}) fixed {2}'.format(i+1, TOTAL, PKGNAME)))
            self.pgwidget.pgBar.setValue(i+1)
        DBridge.Adb(adb)._sync()

        outText = 'Fix permissions complete!'
        self.pgwidget.plainTextEdit.appendPlainText(outText)
        print outText

    def contextMenuRemote(self, pos):
        menu = QMenu()
        pullAction              = menu.addAction('Copy to PC')
        menu.addSeparator()
        OPENmenu                = menu.addMenu('Open')
        termAction              = OPENmenu.addAction('Terminal')
        OPENmenu.addSeparator()
        viewAction              = OPENmenu.addAction('View')
        OPENmenu.addSeparator()
        editAction              = OPENmenu.addAction(posixpath.basename(self.getEditor))
        OPENmenu.addSeparator()
        extractAction           = OPENmenu.addAction('Extract')
        extract_toAction        = OPENmenu.addAction('Extract to')
        NEWmenu                 = menu.addMenu('New')
        newfileAction           = NEWmenu.addAction('Create file')
        newfolderAction         = NEWmenu.addAction('Create folder')
        newarchiveAction        = NEWmenu.addAction('Create tar.gz')
        menu.addSeparator()
        selectAllAction         = menu.addAction('Select All')
        selectNoneAction         = menu.addAction('Select None')
        menu.addSeparator()
        moveAction              = menu.addAction('Cut')
        copyAction              = menu.addAction('Copy')
        pasteAction             = menu.addAction('Paste')
        symLinkAction           = menu.addAction('Symbolic-Link')
        renameAction            = menu.addAction('Rename')
        delAction               = menu.addAction('Delete')
        menu.addSeparator()
        pkgAction               = menu.addAction('Install')
        menu.addSeparator()
        showHidden              = menu.addAction('Show hidden')
        PROPmenu                = menu.addMenu('Properties')
        PROPmenu.addSeparator()
        chmodAction             = PROPmenu.addAction('Info')
        CHMODmenu               = PROPmenu.addMenu('Quick')
        chmod_0400              = CHMODmenu.addAction('r--------')
        chmod_0600              = CHMODmenu.addAction('rw-------')
        chmod_0700              = CHMODmenu.addAction('rwx------')
        chmod_0440              = CHMODmenu.addAction('r--r-----')
        chmod_0640              = CHMODmenu.addAction('rw-r-----')
        chmod_0660              = CHMODmenu.addAction('rw-rw----')
        chmod_0750              = CHMODmenu.addAction('rwxr-x---')
        chmod_0770              = CHMODmenu.addAction('rwxrwx---')
        chmod_0444              = CHMODmenu.addAction('r--r--r--')
        chmod_0644              = CHMODmenu.addAction('rw-r--r--')
        chmod_0666              = CHMODmenu.addAction('rw-rw-rw-')
        chmod_0744              = CHMODmenu.addAction('rwxr--r--')
        chmod_0755              = CHMODmenu.addAction('rwxr-xr-x')
        chmod_0777              = CHMODmenu.addAction('rwxrwxrwx')
        chmod_1777              = CHMODmenu.addAction('rwxrwxrwt')
        PROPmenu.addSeparator()
        fixAction               = PROPmenu.addAction('Fix permission')
        PROPmenu.addSeparator()
        rwAction                = PROPmenu.addAction('Re-mount as read/write')
        menu.addSeparator()
        ADBmenu                 = menu.addMenu('ADB')
        rebootAction            = ADBmenu.addAction('Reboot')
        rebootrecoveryAction    = ADBmenu.addAction('Reboot in recovery')
        rebootbootloaderAction  = ADBmenu.addAction('Reboot in bootloader')

        self.pgwidget.plainTextEdit.clear()
        self.pgwidget.pgBar.reset()

        # check if android device is available
        if not self.deviceConnected:
            for d in [pullAction, OPENmenu, NEWmenu, moveAction, copyAction, pasteAction,
                      renameAction, delAction, pkgAction, showHidden, PROPmenu, ADBmenu, fixAction]:
                d.setEnabled(False)

        # check if copy/move list is empty
        if self.copyList or self.moveList:
            pasteAction.setEnabled(True)
            symLinkAction.setEnabled(True)
        else:
            pasteAction.setEnabled(False)
            symLinkAction.setEnabled(False)

        # check if table is empty
        rows = self.mainGetRows(2)
        if rows:
            for d in [pullAction, viewAction, editAction, extractAction, extract_toAction, newarchiveAction,
                      moveAction, copyAction, renameAction, delAction, pkgAction, showHidden, PROPmenu, CHMODmenu, fixAction]:
                d.setEnabled(True)
        else:
            for d in [pullAction, viewAction, editAction, extractAction, extract_toAction, newarchiveAction,
                      moveAction, copyAction, renameAction, delAction, pkgAction, showHidden, PROPmenu, CHMODmenu, fixAction]:
                d.setEnabled(False)

        action = menu.exec_(self.tblView2.mapToGlobal(pos+QPoint(5, 25)))
        if action == pullAction:
            if self.msgPass():
                vName, v0 = [], []
                for i, k in rows:
                    vName.append(posixpath.basename(i))
                    if k == 'dir':
                        out = posixpath.normpath(posixpath.join(self.path1, posixpath.basename(i)))
                        v0.append((i, out))
                    elif k == 'file':
                        v0.append((i, self.path1))
                self.executeBatch(vName, v0, 'pull')
                self.tableView1()
            else:
                return
        elif action == termAction:
            DBridge.MyProcess(u'{0} -e \"{1} shell\"'.format(getTerminal(),adb))
        elif action == viewAction:
            if rows[0][1] == 'file':
                i = rows[0][0]
                out = posixpath.normpath(posixpath.join(TempDir, posixpath.basename(i)))
                if DBridge.Custom(adb, fastboot)._HasPulled(i, out):
                    DBridge.MyProcess(u'xdg-open {0}'.format(out))
                else:
                    return
            else:
                return
        elif action == editAction:
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            if rows[0][1] == 'file':
                i = rows[0][0]
                out = posixpath.normpath(posixpath.join(TempDir, posixpath.basename(i)))
                if DBridge.Custom(adb, fastboot)._HasPulled(i, out):
                    DBridge.MyProcess(u'{0} \"{1}\"'.format(self.getEditor, out))
                    if self.msgUpload():
                        if DBridge.Custom(adb, fastboot)._HasPushed(out, i):
                            self.tableView2()
                    else:
                        return
                else:
                    return
            else:
                return
        elif action == extractAction:
            if rows[0][1] == 'file':
                self.extractRemote(rows[0][0], posixpath.splitext(rows[0][0])[0])
            self.tableView2()
        elif action == extract_toAction:
            text = self.msgDialog('Extract to', 'Enter path:', posixpath.splitext(rows[0][0])[0])
            if not text:
                return
            if rows[0][1] == 'file':
                self.extractRemote(rows[0][0], posixpath.normpath(unicode(text)))
            self.tableView2()
        elif action == newfileAction:
            text = self.msgDialog('Create New File', 'Filename:')
            if not text:
                return
            text = text.replace(' ', '_')
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            DBridge.Adb(adb, 'cmd')._shell(u'\"echo \' \' > \"{0}\"\"'.format(posixpath.normpath(posixpath.join(self.path2, unicode(text)))))
            self.tableView2()
        elif action == newfolderAction:
            text = self.msgDialog('Create New Folder', 'Foldername:')
            if not text:
                return
            text = text.replace(' ', '_')
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            DBridge.Adb(adb, 'cmd')._shell(u'mkdir \"{0}\"'.format(posixpath.normpath(posixpath.join(self.path2, unicode(text)))))
            self.tableView2()
        elif action == newarchiveAction:
            self.pgwidget.show()
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            name = posixpath.join(self.path2, self.mainGetRows(2, True)[0][0])
            name += '-'+strftime('%H%M%S', gmtime())
            x = ' '.join(['\''+posixpath.basename(i)+'\'' for i, k in rows])
            o = DBridge.Adb(adb, 'out')._shell('\"tar -hvczf \'{0}.tar.gz\' -C \'{1}\' {2}\"'.format(name, self.path2, x))
            self.pgwidget.plainTextEdit.appendPlainText(unicode(o))
            self.tableView2()
        elif action == selectAllAction:
            self.tblView2.selectAll()
        elif action == selectNoneAction:
            self.tblView2.clearSelection()
        elif action == moveAction:
            self.moveList = []
            self.moveList = self.mainGetRows(2)
        elif action == copyAction:
            self.copyList = []
            self.copyList = self.mainGetRows(2)
        elif action == pasteAction:
            self.tbl2_paste()
        elif action == symLinkAction:
            self.tbl2_pasteAsSymbolic()
        elif action == renameAction:
            self.tbl2_rename()
        elif action == delAction:
            self.tbl2_delete()
        elif action == pkgAction:
            if self.msgPass():
                self.pgwidget.show()
                self.pgwidget.pgBar.setMaximum(len(rows))
                x = 0
                self.pgwidget.pgBar.setValue(0)
                for i, k in rows:
                    if self.pgwidget.getKillProcVar():
                        self.pgwidget.setKillProcVar()
                        return
                    self.pgwidget.plainTextEdit.appendPlainText(unicode(i))
                    if i.endswith('.apk'):
                        if DBridge.Custom(adb, fastboot)._GetAttached()[1] == 'recovery':
                            continue
                        o = DBridge.Adb(adb, 'out')._shell(u'pm install -r \"{0}\"'.format(i))
                        self.pgwidget.plainTextEdit.appendPlainText(unicode(o))
                    else:
                        QMessageBox().information(self, 'Attention!', 'Unknown package-format!')
                        return
                    x += 1
                    self.pgwidget.pgBar.setValue(x)
            else:
                return
        elif action == showHidden:
            self.ShowHidden2 = (False if self.ShowHidden2 else True)
            self.tableView2()
        elif action == chmodAction:
            row = self.getRow(2)
            owner, group, perm = row[0][4], row[0][5], row[0][-1]
            self.propdialog.fillStat(rows[0][0],False)
            self.propdialog.fillLayout(owner, group, perm)
            text = self.propdialog.exec_()
            if text == [perm[1:],owner+'.'+group]:
                return
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            vName, v0 = [], []
            for i, k in rows:
                vName.append(posixpath.basename(i))
                if (self.propdialog.getPerm() in perm) and (text[1] == '.'.join([owner, group])):
                    print "Skipped, no changes!"
                    continue
                elif (self.propdialog.getPerm() in perm) and (text[1] != '.'.join([owner, group])):
                    print "only owner was changed"
                    cmd = u'\"chown {0[1]} \'{1}\'\"'.format(text,i)
                elif (self.propdialog.getPerm() not in perm) and (text[1] == '.'.join([owner, group])):
                    print "only permission was changed"
                    cmd = u'\"chmod {0[0]} \'{1}\'\"'.format(text,i)
                elif (self.propdialog.getPerm() not in perm) and (text[1] != '.'.join([owner, group])):
                    print "owner and permission were changed"
                    cmd = u'\"chmod {0[0]} \'{1}\' ; chown {0[1]} \'{1}\'\"'.format(text,i)
                else:
                    print "something wrong, skip all..."
                    continue
                if not isWritable(self.path1):
                    cmd = u'{0} \"{1}\"'.format(sudoGUI, cmd)
                v0.append(cmd)
            self.executeBatch(vName, v0, 'shell')
            self.tableView2()
        elif action == fixAction:
            applist = []
            for i, k in rows:
                if k == 'file' and i.endswith('.apk') and not i.startswith(('/sdcard','/mnt')):
                    applist.append(i)
            self.slotpermission(applist)
            self.tableView2()
        elif action == rwAction:
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
        elif action == rebootAction:
            if self.msgReboot():
                DBridge.Adb(adb, 'cmd')._reboot()
                DBridge.Custom(adb, fastboot).waitfordevice()
            else:
                return
        elif action == rebootrecoveryAction:
            if self.msgReboot():
                DBridge.Adb(adb, 'cmd')._reboot('recovery')
                DBridge.Custom(adb, fastboot).waitfordevice()
            else:
                return
        elif action == rebootbootloaderAction:
            if self.msgReboot():
                DBridge.Adb(adb, 'cmd')._reboot('bootloader')
                DBridge.Custom(adb, fastboot).waitfordevice()
            else:
                return
        else:
            l = ['0400','0600','0700','0440','0640','0660','0750','0770','0444','0644','0666','0744','0755','0777','1777']
            m = [chmod_0400,chmod_0600,chmod_0700,chmod_0440,chmod_0640,chmod_0660,chmod_0750,chmod_0770,
                chmod_0444,chmod_0644,chmod_0666,chmod_0744,chmod_0755,chmod_0777,chmod_1777]
            for x,y in enumerate(l):
                if action == m[x]:
                    self.tbl2_chmod(y)
        return

# load and check for new bookmarks ####################################################################
    def loadBookmarks(self):
        EditConfigMap('bookmarks_local', u'Desktop', getUserPath('DESKTOP'))
        EditConfigMap('bookmarks_local', u'Dokumente', getUserPath('DOCUMENTS'))
        EditConfigMap('bookmarks_local', u'Downloads',getUserPath('DOWNLOAD'))
        EditConfigMap('bookmarks_local', u'Bilder',getUserPath('PICTURES'))
        EditConfigMap('bookmarks_local', u'Musik',getUserPath('MUSIC'))
        EditConfigMap('bookmarks_local', u'Video',getUserPath('VIDEOS'))
        EditConfigMap('bookmarks_local', u'Vorlagen',getUserPath('TEMPLATES'))
        EditConfigMap('bookmarks_local', u'Öffentlich',getUserPath('PUBLICSHARE'))
        EditConfigMap('bookmarks_local', u'/etc', '/etc')
        EditConfigMap('bookmarks_local', u'/usr/share', '/usr/share')
        EditConfigMap('bookmarks_local', u'Trash', HomeTrash)
        if self.deviceConnected:
            self.path2 = EXTERNAL_STORAGE()
            EditConfigMap('bookmarks_remote', u'/data',ANDROID_DATA())
            EditConfigMap('bookmarks_remote', u'/system',self.rootPath2)
            EditConfigMap('bookmarks_remote', u'/etc',posixpath.join(self.rootPath2, 'etc'))
            EditConfigMap('bookmarks_remote', u'download',posixpath.join(self.path2, 'Download'))
            EditConfigMap('bookmarks_remote', u'pictures',posixpath.join(self.path2, 'DCIM'))
            EditConfigMap('bookmarks_remote', u'music',posixpath.join(self.path2, 'Music'))
        self.bookmarks_local = posixpath.join(ReadConfigMap('bookmarks_local'))
        drives = getExternalDrives()
        if drives:
            d = {x:x for x in drives}
            z = self.bookmarks_local.copy()
            z.update(d)
            self.bookmarks_local = OrderedDict(z)
        else:
            self.bookmarks_local = OrderedDict(self.bookmarks_local)
        self.bookmarks_remote = OrderedDict(posixpath.join(ReadConfigMap('bookmarks_remote')))

# TABLEVIEW-1 SLOTS ##########################################################################################
    def tableView1(self):
        try:
            self.currLine1 = self.tblView1.selectionModel().currentIndex().row()
        except AttributeError:
            self.currLine1 = 0
        if self.ShowHidden1:
            self.maintableView('lLAh', self.tblView1, 1)
        else:
            self.maintableView('lLh', self.tblView1, 1)
        self.tblView1.selectRow(self.currLine1)                                 
        self.tblView1.model().givePath(self.path1)

    def contextMenu1(self, pos):
        self.contextMenuLocal(pos)

    def MenuFavorites1(self):
        self.loadBookmarks()
        menu = QMenu()
        for key, value in self.bookmarks_local.iteritems():
            action = menu.addAction(unicode(key[0].upper()+key[1:]))
            action.triggered.connect(lambda f=key,arg=value: self.lineEdit1.setText(unicode(arg)))
        menu.exec_(self.tBtnFav1.mapToGlobal(QPoint(5, 25)))

    def MenuHistory1(self):
        menu = QMenu()
        for item in self.lineHistory1:
            action = menu.addAction(item)
            action.triggered.connect(lambda f=item,arg=item: self.lineEdit1.setText(unicode(arg)))
        menu.exec_(self.tBtnHist1.mapToGlobal(QPoint(5, 25)))

    def onBtnRootClick1(self):
        self.lineEdit1.setText('/')

    def onBtnHomeClick1(self):
        self.lineEdit1.setText(Home)

    def onBtnBackClick1(self):
        t = '/'
        if unicode(self.path1).endswith(t):
            self.path1 = unicode(posixpath.normpath(self.path1[:-1]))
        self.path1 = unicode(posixpath.normpath(posixpath.split(self.path1)[0]))
        if (not self.path1) or (self.path1 == '.'):
            self.path1 = t
        self.lineEdit1.setText(self.path1)

    def onBtnRefreshClick1(self):
        self.tableView1()

    def onLineEdit1(self):
        if self.lineEdit1.text() == '/':
            self.tBtnBack1.setEnabled(False)
        else:
            self.tBtnBack1.setEnabled(True)
        c = self.tblView1.model().rowCount()
        if posixpath.isdir(unicode(self.lineEdit1.text())):
            self.pathX1[0] = self.pathX1[1]
            self.pathX1[1] = self.path1 = unicode(self.lineEdit1.text())
            self.tableView1()
            self.lineEditHistory(self.lineHistory1, self.path1)
            if (self.tblView1.model().rowCount() != c) and (not isExternalDrive(self.path1)):
                self.setTextStatusBar1(self.path1)

    def onDoubleClick1(self, e):
        path = self.mainGetRows(1)
        if path[0][1] == 'dir':
            self.path1 = posixpath.normpath(posixpath.join(unicode(self.path1), unicode(path[0][0])))
            self.lineEdit1.setText(self.path1)
        elif path[0][1] == 'file':
            DBridge.MyProcess(u'xdg-open \"{0}\"'.format(path[0][0]))
        else:
            return

# TABLEVIEW-2 SLOTS ##########################################################################################
    def tableView2(self):
        if not self.deviceConnected:
            return
        try:
            self.currLine2 = self.tblView2.selectionModel().currentIndex().row()
        except AttributeError:
            self.currLine2 = 0
        if self.ShowHidden2:
            self.maintableView('lLAh', self.tblView2, 2)
        else:
            self.maintableView('lLh', self.tblView2, 2)
        if not ('mnt' in self.path2) or ('sdcard' in self.path2):
            self.tBtnRW.setText(DBridge.Custom(adb, fastboot)._rwStatus(self.path2))
        self.tblView2.selectRow(self.currLine2)

    def contextMenu2(self, pos):
        if not self.deviceConnected:
            return
        self.contextVar = 2
        self.contextMenuRemote(pos)

    def MenuFavorites2(self):
        self.loadBookmarks()
        menu = QMenu()
        for key, value in self.bookmarks_remote.iteritems():
            action = menu.addAction(unicode(key[0].upper()+key[1:]))
            action.triggered.connect(lambda f=key,arg=value: self.lineEdit2.setText(unicode(arg)))
        menu.exec_(self.tBtnFav2.mapToGlobal(QPoint(5, 25)))

    def MenuHistory2(self):
        menu = QMenu()
        for item in self.lineHistory2:
            action = menu.addAction(item)
            action.triggered.connect(lambda f=item,arg=item: self.lineEdit2.setText(unicode(arg)))
        menu.exec_(self.tBtnHist2.mapToGlobal(QPoint(5, 25)))

    def onBtnRootClick2(self):
        self.lineEdit2.setText('/')

    def onBtnHomeClick2(self):
        self.lineEdit2.setText(EXTERNAL_STORAGE())

    def onBtnBackClick2(self):
        if unicode(self.path2).endswith('/'):
            self.path2 = unicode(posixpath.normpath(self.path2)[:-1])
        self.path2 = unicode(posixpath.normpath(posixpath.split(self.path2)[0]))
        if (not self.path2) or (self.path2 == '.'):
            self.path2 = u'/'
        self.lineEdit2.setText(self.path2)

    def onBtnRefreshClick2(self):
        self.deviceConnected = DBridge.Custom(adb, fastboot).checkForDevice()
        if self.deviceConnected:
            self.rootAccess = DBridge.Custom(adb, fastboot)._HasRootAccess()
            if not self.path2:
                self.path2 = EXTERNAL_STORAGE()
            self.rootPath2 = ANDROID_ROOT()
            self.on_offTable2(True)
            self.tableView2()
        else:
            self.tblView2.model().removeAllRows()
            self.on_offTable2(False)

    def onBtnRW(self):
        if not self.deviceConnected:
            return
        DBridge.Adb(adb, 'cmd')._remount()
        if not ('mnt' in self.path2) or ('sdcard' in self.path2):
            self.tBtnRW.setText(DBridge.Custom(adb, fastboot)._rwStatus(self.path2))
            if DBridge.Custom(adb, fastboot)._rwStatus(self.path2) == 'ro':
                DBridge.Custom(adb, fastboot)._remount(self.path2)
            self.tBtnRW.setText(DBridge.Custom(adb, fastboot)._rwStatus(self.path2))

    def onLineEdit2(self):
        if self.lineEdit2.text() == '/':
            self.tBtnBack2.setEnabled(False)
        else:
            self.tBtnBack2.setEnabled(True)
        c = self.tblView2.model().rowCount()
        self.pathX2[0] = self.pathX2[1]
        self.pathX2[1] = self.path2 = unicode(self.lineEdit2.text())
        self.tableView2()
        self.lineEditHistory(self.lineHistory2, self.path2)
        if self.tblView2.model().rowCount() != c:
            self.setTextStatusBar2(self.path2)

    def onDoubleClick2(self, e):
        path = self.mainGetRows(2)
        if path[0][1] == 'dir':
            self.path2 = posixpath.normpath(posixpath.join(unicode(self.path2), unicode(path[0][0])))
            self.lineEdit2.setText(self.path2)
        elif path[0][1] == 'file':
            out = posixpath.normpath(posixpath.join(TempDir, posixpath.basename(path[0][0])))
            if DBridge.Custom(adb, fastboot)._HasPulled(path[0][0], out):
                DBridge.MyProcess(u'xdg-open \"{0}\"'.format(out))
            else:
                return
        else:
            return

# KEYBOARD-SHORTCUTS #########################################################################################
    def mouseFor(self):        
        if QApplication.focusWidget() == self.tblView1:
            self.tblView1.setFocus(True)
            self.lineEdit1.setText(self.pathX1[0])            
        elif QApplication.focusWidget() == self.tblView2:
            self.tblView2.setFocus(True)
            self.lineEdit2.setText(self.pathX2[0])
        else:
            return
    def mouseBack(self):
        if QApplication.focusWidget() == self.tblView1:
            self.tblView1.setFocus(True)
            self.onBtnBackClick1()
        elif QApplication.focusWidget() == self.tblView2:
            self.tblView2.setFocus(True)
            self.onBtnBackClick2()
        else:
            return
##    def mouseMoved(self):
##        if QApplication.focusWidget() == self.tblView1:
##            print 'moved!!'

    def keyPressEvent(self, e):
        self.pgwidget.plainTextEdit.clear()
        # TABLE-1
        if QApplication.focusWidget() == self.tblView1:            
            rows = self.mainGetRows(1)
            if e.key() == Qt.Key_Return:
                if not rows:
                    return
                if rows[0][1] == 'dir':
                    self.path1 = posixpath.normpath(posixpath.join(unicode(self.path1), unicode(rows[0][0])))
                    self.lineEdit1.setText(self.path1)
                else:
                    DBridge.MyProcess(u'xdg-open \"{0}\"'.format(rows[0][0]))
            elif e.key() == Qt.Key_Backspace:
                self.onBtnBackClick1()
            elif e.key() == Qt.Key_F2:
                self.tbl1_rename()
            elif e.key() == Qt.Key_F4:
                DBridge.MyProcess(u'{0} --working-directory={1}'.format(getTerminal(),self.path1))
            elif e.key() == Qt.Key_F5:
                self.tableView1()
            elif e.key() == Qt.Key_Delete:
                self.tbl1_delete()
            if int(e.modifiers()) == Qt.ControlModifier:
                if e.key() == Qt.Key_X:
                    self.moveList = []
                    self.moveList = self.mainGetRows(1)
                elif e.key() == Qt.Key_C:
                    self.copyList = []
                    self.copyList = self.mainGetRows(1)
                elif e.key() == Qt.Key_V:
                    self.tbl1_paste()
        # TABLE-2
        elif QApplication.focusWidget() == self.tblView2:
            rows = self.mainGetRows(2)
            if e.key() == Qt.Key_Return:
                if not rows:
                    return
                if rows[0][1] == 'dir':
                    self.path2 = posixpath.normpath(posixpath.join(unicode(self.path2), unicode(rows[0][0])))
                    self.lineEdit2.setText(self.path2)
            elif e.key() == Qt.Key_Backspace:
                self.onBtnBackClick2()
            elif e.key() == Qt.Key_F2:
                self.tbl2_rename()
            elif e.key() == Qt.Key_F4:
                DBridge.MyProcess(u'{0} -e \"{1} shell\"'.format(getTerminal(),adb))
            elif e.key() == Qt.Key_F5:
                self.tableView2()
            elif e.key() == Qt.Key_Delete:
                self.tbl2_delete()
            if int(e.modifiers()) == Qt.ControlModifier:
                if e.key() == Qt.Key_X:
                    self.moveList = []
                    self.moveList = self.mainGetRows(2)
                elif e.key() == Qt.Key_C:
                    self.copyList = []
                    self.copyList = self.mainGetRows(2)
                elif e.key() == Qt.Key_V:
                    self.tbl2_paste()

# MAIN-FUNTION ###############################################################################################
def main():
    os.chdir(ScriptDir)
    if not posixpath.isdir(TempDir):
        os.makedirs(TempDir)
    app = QApplication([])
    w = MyWindow()
    w.setWindowIcon(QIcon(MainIcon))
    if not 'linux' in sys.platform:
        QMessageBox().information(w, 'Attention!', 'Sorry, you need Linux!')
        sys.exit()
    if activeUser == "root":
        w.setStyleSheet('QMainWindow{border: 1px solid red;}')
    w.show()
    app.exec_()

if __name__ == '__main__':
    main()
